unit oInterfaces;

{
  ================================================================================
  *
  *       Application:  CliO
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Developer:    doma.user@domain.ext
  *       Site:         Hines OIFO
  *
  *       Description:
  *
  *
  *       Notes:
  *
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/CLIO/oInterfaces.pas $
  *
  * $History: oInterfaces.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/CLIO
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/CLIO
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/CLIO
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/CLIO
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/CLIO
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:37p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/CLIO
  *
  *
  ================================================================================
}
interface

uses
  Classes;

type
  { Ordinal data types needed by the interfaces }
  TDBConnectionType = (DbVistABroker, DbCacheSQL, DbMSAccess, DbOracle);
  TDBCmdType         = (CtQuery, CtInsert, CtUpdate);
  TDBCmdStatus       = (CsActive, CsExecuting, CsError, CsComplete);
  TDBQueryComparison = (CoLessThan, CoLessThanOrEqualTo, CoEqualTo, CoEqualToOrGreaterThan, CoGreaterThan);
  TDBValueType       = (VtString, VtInteger, VtDouble, VtDate, VtDateTime, VtDateTimeSeconds, VtClob);
  { Forward Declarations }
  I_DBInsert         = interface;
  I_DBQuery          = interface;
  I_DBUpdate         = interface;
  I_DBExecutorQuery  = interface;
  I_DBExecutorInsert = interface;
  I_DBExecutorUpdate = interface;

  I_DBConnection = interface
    ['{9DB93BD9-FFD8-4756-A05C-AB24E5E1364C}']
    procedure SetName(AName: string); stdcall;
    function GetName: string; stdcall;
    function GetDBType: TDBConnectionType; stdcall;
    function Initialize(AP1, AP2, AP3, AP4, AP5: string): Boolean; stdcall;
    function PostInit(AObject: TObject): Boolean; stdcall;
    function IsInitialized: Boolean; stdcall;
    function Open: Boolean; stdcall;
    function IsOpen: Boolean; stdcall;
    procedure SetSequenceTableName(AName: string); stdcall;
    function GetSequenceTableName: string; stdcall;
    function BeginTransaction: Boolean; stdcall;
    function CommitTransaction: Boolean; stdcall;
    function RollBackTransaction: Boolean; stdcall;
    function ExecRemoteProc(AName: string; AParams: array of string; AOptions: array of Integer; AMultList: TStringList;
      var ARetList: TStringList): Boolean; stdcall;
    function ExecuteQuery(AQuery: I_DBExecutorQuery): Boolean; stdcall;
    function ExecuteInsert(AInsert: I_DBExecutorInsert): Boolean; stdcall;
    function ExecuteUpdate(AUpdate: I_DBExecutorUpdate): Boolean; stdcall;
    function Close: Boolean; stdcall;
    function Description: string; stdcall;
    function Properties: string; stdcall;
    function GetInsertValue(AValue: string; AValueType: TDBValueType): string; stdcall;
    function GetNextID(AViewName: string): Integer; stdcall;
    { Manages Dates in and out of the DB - Default methods available in TDBConnection }
    procedure SetDateSeparator(ADateSeparator: Char); stdcall;
    procedure SetTimeSeparator(ATimeSeparator: Char); stdcall;
    procedure SetDateTimeSeparator(ADateTimeSeparator: Char); stdcall;
    procedure SetDateFormat(ADateFormat: string); stdcall;
    procedure SetTimeFormat(ATimeFormat: string); stdcall;
    procedure SetTimeSecondsFormat(ATimeSecondsFormat: string); stdcall;
    function GetDateSeparator: string; stdcall;
    function GetTimeSeparator: string; stdcall;
    function GetDateTimeSeparator: string; stdcall;
    function GetDateFormat: string; stdcall;
    function GetDateTimeFormat: string; stdcall;
    function GetDateTimeSecondsFormat: string; stdcall;
    function GetTimeFormat: string; stdcall;
    function GetTimeSecondsFormat: string; stdcall;
  end;

  I_DBCommand = interface
    ['{A43771E8-4B5B-4446-B9B9-AC1D6D4450DA}']
    function View: string; stdcall;
    function Status: TDBCmdStatus; stdcall;
    function Execute(ADBConnection: I_DBConnection): Boolean; stdcall;
    procedure Close; stdcall;
  end;

  I_DBInsert = interface(I_DBCommand)
    ['{3A3CB7DC-61AB-4798-92EA-A1F7B9042D1F}']
    procedure AddValueString(AColumn: string; AValue: string); overload; stdcall;
    procedure AddValueInteger(AColumn: string; AValue: Integer); overload; stdcall;
    procedure AddValueDouble(AColumn: string; AValue: Double); overload; stdcall;
    procedure AddValueDate(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueDateTime(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueDateTimeSeconds(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueClob(AColumn: string; AValue: string); stdcall;
  end;

  I_DBQuery = interface(I_DBCommand)
    ['{3EE97E5E-031C-49B7-A156-C38A1797BFB3}']
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: string); overload; stdcall;
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: Integer); overload; stdcall;
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: Double); overload; stdcall;
    procedure UsePrimaryKey(AColumn: string; AValue: string); overload; stdcall;
    procedure UsePrimaryKey(AColumn: string; AValue: Integer); overload; stdcall;
    function QueryResults: string; stdcall;
  end;

  I_DBUpdate = interface(I_DBCommand)
    ['{ED1375D6-7990-4D54-8C3D-4BA0D87D3CE7}']
    procedure AddValueString(AColumn: string; AValue: string); overload; stdcall;
    procedure AddValueInteger(AColumn: string; AValue: Integer); overload; stdcall;
    procedure AddValueDouble(AColumn: string; AValue: Double); overload; stdcall;
    procedure AddValueDate(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueDateTime(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueDateTimeSeconds(AColumn: string; AValue: TDateTime); overload; stdcall;
    procedure AddValueClob(AColumn: string; AValue: string); stdcall;
    procedure UsePrimaryKey(AColumn: string; AValue: string); overload; stdcall;
    procedure UsePrimaryKey(AColumn: string; AValue: Integer); overload; stdcall;
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: string); overload; stdcall;
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: Integer); overload; stdcall;
    procedure AddFilter(AColumn: string; AComparison: TDBQueryComparison; AValue: Double); overload; stdcall;
  end;

  I_DBExecutorInsert = interface(I_DBInsert)
    ['{0A4DE8B8-27EE-4B59-8305-09C28CBCE494}']
    function ValueCount: Integer; stdcall;
    function Value(Index: Integer): string; stdcall;
    function ValueIsClobType(Index: Integer): Boolean; stdcall;
    function SQLValueStmt: string; stdcall;
    function ColumnCount: Integer; stdcall;
    function Column(Index: Integer): string; stdcall;
    function SQLColumnStmt: string; stdcall;
    function FilterCount: Integer; stdcall;
    function Filter(Index: Integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

  I_DBExecutorQuery = interface(I_DBQuery)
    ['{FE214D7B-4ED8-47F6-B44A-D110E7C38803}']
    procedure SetResults(AString: string); stdcall;
    function PrimaryKey: Boolean;
    function PrimaryKeyColumn: string;
    function PrimaryKeyValue: string;
    function PrimaryKeyValueType: TDBValueType;
    function FilterCount: Integer; stdcall;
    function Filter(Index: Integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

  I_DBExecutorUpdate = interface(I_DBUpdate)
    ['{A968B677-5FBC-4415-AF65-086B74F30F75}']
    function ValueCount: Integer; stdcall;
    function Value(Index: Integer): string; stdcall;
    function ValueIsClobType(Index: Integer): Boolean; stdcall;
    function SQLValueStmt: string; stdcall;
    function ColumnCount: Integer; stdcall;
    function Column(Index: Integer): string; stdcall;
    function SQLColumnStmt: string; stdcall;
    function PrimaryKey: Boolean;
    function PrimaryKeyColumn: string;
    function PrimaryKeyValue: string;
    function PrimaryKeyValueType: TDBValueType;
    function SQLUpdateStmt: string; stdcall;
    function FilterCount: Integer; stdcall;
    function Filter(Index: Integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

type
  TCustomInterfacedObject = class(TInterfacedObject)
  protected
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

type
  TBaseInterfacedObject = class(TCustomInterfacedObject)
  public
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

implementation

{ TCustomInterfacedObject }

function TCustomInterfacedObject._AddRef: Integer;
begin
  Result := -1;
end;

function TCustomInterfacedObject._Release: Integer;
begin
  Result := -1;
end;
{ TBaseInterfacedObject }

function TBaseInterfacedObject._AddRef: Integer;
begin
  Result := -1;
end;

function TBaseInterfacedObject._Release: Integer;
begin
  Result := -1;
end;

end.
