unit fMDK_BugReport;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 12/06/07 9:36a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Report form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_BugReport.pas $
  *
  * $History: fMDK_BugReport.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, ActnList, StdActns, Printers, Mask, UMDK_options, UMDK_Common,
  System.Actions;

type
  TfrmBugReport = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ReReport: TRichEdit;
    SaveDialog1: TSaveDialog;
    ActionList1: TActionList;
    FileSaveAs1: TFileSaveAs;
    Panel3: TPanel;
    AcPrint: TAction;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    WindowClose1: TWindowClose;
    AcClose: TAction;
    FontDialog1: TFontDialog;
    FontEdit1: TFontEdit;
    AcSendMail: TAction;
    SpbSend: TBitBtn;
    SpeedButton8: TSpeedButton;
    SpbLandscape: TSpeedButton;
    Label2: TLabel;
    AcSaveToDB: TAction;
    SbDBSave: TSpeedButton;
    SbDBLoad: TSpeedButton;
    AcLoadFromDB: TAction;
    BbFont: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    AcSaveAs: TAction;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure AcPrintExecute(Sender: TObject);
    procedure WindowClose1Execute(Sender: TObject);
    procedure AcCloseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FontEdit1Accept(Sender: TObject);
    procedure FontEdit1BeforeExecute(Sender: TObject);
    procedure AcSaveToDBExecute(Sender: TObject);
    procedure AcLoadFromDBExecute(Sender: TObject);
    procedure AcSaveAsExecute(Sender: TObject);
  private
    { Private declarations }
    Ignore: Boolean;
    FLastName: string;
    procedure SetLastName(AName: string);
  public
    { Public declarations }
    OptionType: string;
    MailSubject, AddressTo, AddressFrom, SMTPHost: string;
    procedure Report(AStringList: TStringList; ALineLen: Integer);
    property LastName: string read FLastName write SetLastName;
  end;

var
  FrmBugReport: TfrmBugReport;

function NewBugReport(AHost, AToAddress, AFromAddress, ASubject: string): TfrmBugReport;
function NewReport(ALastName: string; AHost, AToAddress, AFromAddress, ASubject: string; AType: string = OtSystem)
  : TfrmBugReport;

implementation

uses
  UMDK_Engine;

{$R *.dfm}

function NewBugReport(AHost, AToAddress, AFromAddress, ASubject: string): TfrmBugReport;
begin
  Result := TfrmBugReport.Create(Application);
  if Result <> nil then
    try
      Result.SMTPHost := AHost;
      Result.AddressTo := AToAddress;
      Result.AddressFrom := AFromAddress;
      Result.MailSubject := ASubject;
    except
    end;
end;

function NewReport(ALastName: string; AHost, AToAddress, AFromAddress, ASubject: string; AType: string = OtSystem)
  : TfrmBugReport;
begin
  Result := TfrmBugReport.Create(Application);
  if Result <> nil then
    try
      Result.SMTPHost := AHost;
      Result.AddressTo := AToAddress;
      Result.AddressFrom := AFromAddress;
      Result.MailSubject := ASubject;
      Result.BorderStyle := BsNone;
      Result.Panel1.Visible := False;
      Result.ReReport.Color := ClWindow;
      Result.OptionType := AType;
    except
    end;
end;

procedure TfrmBugReport.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = Char(VK_ESCAPE) then Close;
end;

procedure TfrmBugReport.FormResize(Sender: TObject);
begin
  ReReport.Invalidate;
end;

procedure TfrmBugReport.AcPrintExecute(Sender: TObject);
var
  Rr: TRect;
  IPage, I, J: Integer;

  procedure DrawFrame(AR: TRect);
  begin
    Printer.Canvas.Brush.Color := ClBlack;
    Printer.Canvas.FrameRect(AR);
    Printer.Canvas.Brush.Style := BsClear;
  end;

  procedure ClosePage;
  begin
    Printer.Canvas.TextOut(Printer.PageWidth - 400, Printer.PageHeight - 100, IntToStr(IPage));
    Inc(IPage);
  end;

begin
  if PrintDialog1.Execute then
    with Printer do begin
      Printer.Canvas.Font.Assign(FontEdit1.Dialog.Font);
      if SpbLandscape.Down then Orientation := PoLandscape
      else Orientation := PoPortrait;
      Rr := Rect(580, 180, (Pagewidth - 180), (PageHeight - 180));
      BeginDoc;
      Canvas.Brush.Style := BsClear;
      J := 0;
      IPage := 1;
      for I := 0 to ReReport.Lines.Count do begin
        if ((J + 1) * Canvas.TextHeight(ReReport.Lines.Strings[I])) > (Pageheight - 400) then begin
          DrawFrame(Rr);
          ClosePage;
          Newpage;
          J := 0;
        end;
        Canvas.TextOut(600, 200 + (J * Canvas.TextHeight(ReReport.Lines.Strings[I])), ReReport.Lines.Strings[I]);
        Inc(J);
      end;
      DrawFrame(Rr);
      ClosePage;
      EndDoc;
    end;
end;

procedure TfrmBugReport.WindowClose1Execute(Sender: TObject);
begin
  Close;
end;

procedure TfrmBugReport.AcCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmBugReport.FormCreate(Sender: TObject);
begin
  Ignore := False;
  Ignore := True;
  Rereport.Font.Size := FontDialog1.Font.Size;
  Ignore := False;
{$IFDEF AANTEST}
  SbDBSave.Visible := True;
  SbDBLoad.Visible := True;
{$ELSE}
  SpbSend.Visible := False;
  SbDBSave.Visible := False;
  SbDBLoad.Visible := False;
{$ENDIF}
end;

procedure TfrmBugReport.FontEdit1Accept(Sender: TObject);
begin
  ReReport.Font.Assign(FontEdit1.Dialog.Font);
  Printer.Canvas.Font.Assign(FontEdit1.Dialog.Font);
end;

procedure TfrmBugReport.Report(AStringList: TStringList; ALineLen: Integer);
var
  I: Integer;
  ASL: TStringList;
  function Replace13(AValue, AMargin: string): string;
  var
    Ii: Integer;
    SList: TStringList;
  begin
    SList := TStringList.Create;
    SList.Text := AValue;
    for Ii := 0 to SList.Count - 1 do SList[Ii] := Amargin + SList[Ii];
    Result := SList.Text;
    SList.Free;
  end;
  procedure FormatAdd(ALine, AMargin: string; ALimit: Integer);
  var
    J, K: Integer;
    Ss: string;
  begin
    J := 1;
    repeat
      K := ALimit - Length(Amargin);
      Ss := Copy(ALine, J, K);
      if Length(Ss) >= K then
        while (Copy(Ss, K, 1) <> ' ') and (K > 1) do begin
          Ss := Copy(Ss, 1, K - 1);
          K := K - 1;
        end;
      ASL.Text := ASL.Text + Replace13(Ss, Amargin);
      J := J + K;
    until J >= Length(ALine);
  end;

begin
  ASL := TStringList.Create;
  for I := 0 to AStringList.Count - 1 do FormatAdd(AStringList[I], '  ', ALineLen);
  ReReport.Lines.Text := ASL.Text;
  ASL.Free;
end;

procedure TfrmBugReport.FontEdit1BeforeExecute(Sender: TObject);
begin
  FontDialog1.Font.Name := ReReport.Font.Name;
end;

procedure TfrmBugReport.AcSaveToDBExecute(Sender: TObject);
begin
  if OptionType = OtSystem then Engine.SetSystemOptionByName(LastName, ReReport.Lines.Text)
  else Engine.SetUserOptionByName(LastName, ReReport.Lines.Text)
end;

procedure TfrmBugReport.AcLoadFromDBExecute(Sender: TObject);
var
  S: string;
begin
  if OptionType = OtSystem then S := Engine.GetSystemOptionByName(LastName)
  else S := Engine.GetUserOptionByName(LastName);
  if S <> YoUnKnown then ReReport.Lines.Text := S
  else ReReport.Lines.Text := '';
end;

procedure TfrmBugReport.SetLastName(AName: string);
begin
  FLastName := AName;
  AcLoadFromDBExecute(nil);
end;

procedure TfrmBugReport.AcSaveAsExecute(Sender: TObject);
begin
  if SaveDialog1.Execute then ReReport.Lines.SaveToFile(SaveDialog1.FileName);
end;

end.
