unit fMDK_CDS;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 1/24/08 2:24p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  The unit contains general client data set view/edit form
  *                     and providers special actions to support the Hemodialysis
  *                     application dictionary
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_CDS.pas $
  *
  *       $ History: fMDK_CDS.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, ExtCtrls, Grids, ValEdit, Buttons, DBGrids, DB,
  ComCtrls, DBClient, ActnList, Menus, ImgList, System.Actions;

type
  TStringReplace = function(AString: string): string;

  TfrmMDK_CDS = class(TForm)
    PnlDetailsCDS: TPanel;
    PnlCDSTools: TPanel;
    ActionList1: TActionList;
    AcSend: TAction;
    AcSaveAs: TAction;
    AcLoad: TAction;
    AcDictionaryCreate: TAction;
    AcDictionarySave: TAction;
    AcDictionaryLoad: TAction;
    DlgSave: TSaveDialog;
    DlgOpen: TOpenDialog;
    AcGUIUpdate: TAction;
    AcUpdateField: TAction;
    AcDeleteAll: TAction;
    AcCopyRecord: TAction;
    AcRecover: TAction;
    AcSortAndFilter: TAction;
    SplCDS: TSplitter;
    PnlCDSDetails: TPanel;
    PnlFieldName: TPanel;
    DBMemo1: TDBMemo;
    ImageList1: TImageList;
    Panel2: TPanel;
    PcMain: TPageControl;
    TsAccessSites: TTabSheet;
    Panel12: TPanel;
    DbG: TDBGrid;
    TsRecord: TTabSheet;
    VleRecord: TValueListEditor;
    PnlInfoPlus0: TPanel;
    AcPatchDictionary: TAction;
    AcViewXML: TAction;
    AcSaveInstrumentData: TAction;
    PnlPos: TPanel;
    Bevel1: TBevel;
    PnlDBN: TPanel;
    DbN: TDBNavigator;
    SbSaveAs: TBitBtn;
    CkbConfirmDelete: TCheckBox;
    AcSaveAsVistAOption: TAction;
    AcReload: TAction;
    AcResetID: TAction;
    PnlDictionaryPlus: TPanel;
    BitBtn9: TBitBtn;
    BitBtn12: TBitBtn;
    BbResetID: TBitBtn;
    PnlDictionaryActions1: TPanel;
    BitBtn11: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn8: TBitBtn;
    PnlInfoPlus: TPanel;
    BitBtn2: TBitBtn;
    SbRecover: TBitBtn;
    BbReload: TBitBtn;
    BbSaveAsVistAOption: TBitBtn;
    SbLoad: TBitBtn;
    AcDictionaryVerify: TAction;
    BitBtn1: TBitBtn;
    AcReloadDictionary: TAction;
    AcSetLabels: TAction;
    BbDeleteAll: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn7: TBitBtn;
    AcClearField: TAction;
    BitBtn4: TBitBtn;
    AcDictionaryDefault: TAction;
    BitBtn5: TBitBtn;
    PnlDictionaryBackup: TPanel;
    AcDictionaryBackup: TAction;
    AcDictionaryRestore: TAction;
    BitBtn6: TBitBtn;
    BitBtn13: TBitBtn;
    procedure AcSaveAsExecute(Sender: TObject);
    procedure AcDictionaryCreateExecute(Sender: TObject);
    procedure AcDictionarySaveExecute(Sender: TObject);
    procedure AcDictionaryLoadExecute(Sender: TObject);
    procedure DbGKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DbGTitleClick(Column: TColumn);
    procedure DbGDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure DbGCellClick(Column: TColumn);
    procedure CkbConfirmDeleteClick(Sender: TObject);
    procedure AcLoadExecute(Sender: TObject);
    procedure DbNClick(Sender: TObject; Button: TNavigateBtn);
    procedure PcMainChange(Sender: TObject);
    procedure AcGUIUpdateExecute(Sender: TObject);
    procedure AcDeleteAllExecute(Sender: TObject);
    procedure AcCopyRecordExecute(Sender: TObject);
    procedure AcRecoverExecute(Sender: TObject);
    procedure AcSortAndFilterExecute(Sender: TObject);
    procedure AcPatchDictionaryExecute(Sender: TObject);
    procedure AcSaveInstrumentDataExecute(Sender: TObject);
    procedure AcSaveAsVistAOptionExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcReloadExecute(Sender: TObject);
    procedure AcResetIDExecute(Sender: TObject);
    procedure AcDictionaryVerifyExecute(Sender: TObject);
    procedure AcReloadDictionaryExecute(Sender: TObject);
    procedure AcSetLabelsExecute(Sender: TObject);
    procedure AcClearFieldExecute(Sender: TObject);
    procedure AcDictionaryDefaultExecute(Sender: TObject);
    procedure DbGDblClick(Sender: TObject);
    procedure AcDictionaryRestoreExecute(Sender: TObject);
    procedure AcDictionaryBackupExecute(Sender: TObject);
  private
    { Private declarations }
    FCDSOptionName: string;
    procedure ShowPosition;
    function GetXML: string;
    procedure ForAllRecords(AField: string; SR: TStringReplace);
  public
    { Public declarations }
    procedure ShowCDSRecord(ACDS: TClientDataSet);
    procedure SelectCDS(AName: string);
    procedure SetStatus(AStatus: string);
    procedure SetUpLayout(B: Boolean);
  end;

var
  FrmMDK_CDS: TfrmMDK_CDS;

implementation

uses
  DMDK_Data, System.UITypes, UMDK_Engine, UMDK_CDSCommon, UGMV_VersionInfo, UROR_CommonUtils, FMDK_SorAndFilter,
  UMDK_Options, UXML, UMDK_Dictionary, UMDK_Common;

const
  MsgSystemOptionLockFailed = 'System Option Lock Failed' + #13#10;

{$R *.dfm}

procedure TfrmMDK_CDS.ShowPosition;
begin
  try
    PnlPos.Caption := Format('%d/%d', [TClientDataSet(DbG.DataSource.DataSet).RecNo,
      TClientDataSet(DbG.DataSource.DataSet).RecordCount]);
  except
  end;
end;

procedure TfrmMDK_CDS.AcSaveAsExecute(Sender: TObject);
var
  SL: TStringList;
begin
  SL := nil;
  if DlgSave.Execute then
    try
      TClientDataSet(DbG.DataSource.DataSet).MergeChangeLog;
      SL := TStringList.Create;
      SL.Text := TClientDataSet(DbG.DataSource.DataSet).XMLData;
      SL.SaveToFile(DlgSave.FileName);
    finally
      SL.Free;
    end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.AcLoadExecute(Sender: TObject);
var
  SL: TStringList;
begin
  if DlgOpen.Execute then begin
    SL := TStringList.Create;
    SL.LoadFromFile(DlgOpen.FileName);
    try
      if CDSGetData(DmData.CdsSource, SL.Text) then begin
        CDSAppend(DmData.CdsSource, TClientDataSet(DbG.DataSource.DataSet));
      end;
    except
    end;
    SL.Free;
  end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.AcDictionaryCreateExecute(Sender: TObject);
begin
  UMDK_Dictionary.DictionaryID := 0;
  UpdateDictionary(DmData.CdsInfo);
  UpdateDictionary(DmData.CdsFlowSheet);
  UpdateDictionary(DmData.CdsAP);
  UpdateDictionary(DmData.CdsAPHistory);
  UpdateDictionary(DmData.CdsVAInfection);
  UpdateDictionary(DmData.CdsStudyHistory);
  UpdateDictionary(DmData.CdsMedList);
  UpdateDictionary(DmData.CdsSummary);
  UpdateDictionary(DmData.CdsNotes);
  ShowPosition;
end;

procedure TfrmMDK_CDS.AcDictionarySaveExecute(Sender: TObject);
begin
  Engine.SaveDictionaryToDB;
end;

procedure TfrmMDK_CDS.AcDictionaryLoadExecute(Sender: TObject);
begin
  Engine.LoadDictionaryFromDB;
end;

procedure TfrmMDK_CDS.DbGKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  ShowPosition;
end;

procedure TfrmMDK_CDS.DbGTitleClick(Column: TColumn);
begin
  try
    TClientDataSet(DbG.DataSource.DataSet).IndexFieldNames := Column.FieldName;
  except
  end;
end;

procedure TfrmMDK_CDS.DbGDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  Field: TField;
  DataSet: TDataSet;
  Risk: string;
begin
  DataSet := DbG.DataSource.DataSet;
  if (DataSet = DmData.DsEvents.DataSet) or (DataSet = DmData.DsStudyEvents.DataSet) then begin
    Field := DataSet.FieldByName(FnEvents_Type);
    Risk := Field.AsString;
    if Risk = EtDebug then DbG.Canvas.Font.Color := ClBlack
    else if Risk = EtWarning then DbG.Canvas.Font.Color := ClBlue
    else if Risk = EtInfo then DbG.Canvas.Font.Color := ClGreen
    else DbG.Canvas.Font.Color := ClRed;
    if (GdFocused in State) { //  or (gdSelected in State) } then begin
      DbG.Canvas.Font.Color := ClWhite;
    end else begin
      if Risk = EtWarning then DbG.Canvas.Brush.Color := $00FFFDE6
      else if Risk = EtError then DbG.Canvas.Brush.Color := $00FFFDE6
      else if Risk = EtInfo then DbG.Canvas.Brush.Color := $00C8ECFD
      else DbG.Canvas.Brush.Color := ClWindow;
    end;
    DbG.DefaultDrawColumnCell(Rect, DataCol, Column, State);
  end
  else DbG.DefaultDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TfrmMDK_CDS.DbGCellClick(Column: TColumn);
begin
  try
    DBMemo1.DataField := Column.FieldName;
    ShowPosition;
  except
  end;
end;

procedure TfrmMDK_CDS.ShowCDSRecord(ACDS: TClientDataSet);
var
  I: Integer;
  S: string;
  SL: TStringList;
begin
  if not Assigned(ACDS) then Exit;
  if not ACDS.Active then Exit;
  try
    if not ACDS.RecordCount > 0 then Exit;
  except
    Exit;
  end;
  S := '';
  SL := TStringList.Create;
  for I := 0 to ACDS.FieldDefs.Count - 1 do begin
    try
      S := ACDS.FieldByName(ACDS.FieldDefs[I].Name).AsString;
    except
      S := '';
    end;
    SL.Add(ACDS.FieldDefs[I].Name + '=' + S);
  end;
  VleRecord.Strings.Assign(SL);
  for I := 0 to ACDS.FieldDefs.Count - 1 do VleRecord.ItemProps[I].ReadOnly := True;
  SL.Free;
  ShowPosition;
end;

procedure TfrmMDK_CDS.SelectCDS(AName: string);
begin
  FCDSOptionName := 'Unknown';
  AcDictionaryCreate.Enabled := False;
  AcDictionaryLoad.Enabled := False;
  AcDictionarySave.Enabled := False;
  AcGUIUpdate.Enabled := False;
  AcCopyRecord.Enabled := False;
{$IFDEF AANTEST}
  DbG.ReadOnly := False;
  FrmMDK_CDS.DbN.Enabled := True;
{$ENDIF}
  if AName = 'Summary' then begin
    DbG.DataSource := DmData.DsSummary;
    DbN.DataSource := DmData.DsSummary;
    FCDSOptionName := '';
  end else if AName = 'Study History' then begin
    DbG.DataSource := DmData.DsStudyHistory;
    DbN.DataSource := DmData.DsStudyHistory;
    FCDSOptionName := '';
  end else if (AName = 'Flow Sheet') or (AName = 'Flowsheet') then begin
    DbG.DataSource := DmData.DsFlowSheet;
    DbN.DataSource := DmData.DsFlowSheet;
    FCDSOptionName := '';
  end
  // else if aName = 'Events' then
  else if AName = 'Application Events' then begin
    DbG.DataSource := DmData.DsEvents;
    DbN.DataSource := DmData.DsEvents;
    // SetUpEventsGrid;
    FCDSOptionName := '';
  end else if AName = 'Info' then begin
    DbG.DataSource := DmData.DsInfo;
    DbN.DataSource := DmData.DsInfo;
    FCDSOptionName := '';
  end else if (AName = 'AP') or (AName = 'Access Points') then begin
    DbG.DataSource := DmData.DsAP;
    DbN.DataSource := DmData.DsAP;
    FCDSOptionName := '';
  end else if AName = 'AP History' then begin
    DbG.DataSource := DmData.DsAPHistory;
    DbN.DataSource := DmData.DsAPHistory;
    FCDSOptionName := '';
  end else if AName = 'AP Infection History' then begin
    DbG.DataSource := DmData.DsVAInfection;
    DbN.DataSource := DmData.DsVAInfection;
    FCDSOptionName := '';
  end else if AName = 'Medication' then begin
    DbG.DataSource := DmData.DsMedList;
    DbN.DataSource := DmData.DsMedList;
    FCDSOptionName := '';
  end else if AName = 'Timeline' then begin
    DbG.DataSource := DmData.DsTimeline;
    DbN.DataSource := DmData.DsTimeline;
    FCDSOptionName := '';
  end else if AName = 'Notes' then begin
    DbG.DataSource := DmData.DsNotes;
    DbN.DataSource := DmData.DsNotes;
    FCDSOptionName := '';
  end else if AName = 'Study Events' then begin
    DbG.DataSource := DmData.DsStudyEvents;
    DbN.DataSource := DmData.DsStudyEvents;
    FCDSOptionName := '';
  end else if AName = 'Status' then begin
    DbG.DataSource := DmData.DsStatus;
    DbN.DataSource := DmData.DsStatus;
    FCDSOptionName := '';
  end else if AName = OnSubmittedStudies then begin
    DbG.DataSource := DmData.DsSubmitHistory;
    DbN.DataSource := DmData.DsSubmitHistory;
    FCDSOptionName := OnSubmittedStudies;
  end else if (AName = 'Dictionary') or (AName = 'Application Dictionary') then begin
    DbG.DataSource := DmData.DsDict;
    DbN.DataSource := DmData.DsDict;
    AcDictionaryCreate.Enabled := True;
    AcDictionaryLoad.Enabled := True;
    AcDictionarySave.Enabled := True;
    AcGUIUpdate.Enabled := True;
    AcCopyRecord.Enabled := True;
    FCDSOptionName := OnDictionary;
  end;
  if FCDSOptionName <> 'Unknown' then begin
    ShowCDSRecord(TClientDataSet(DbG.DataSource.DataSet));
    DBMemo1.DataField := '';
    DBMemo1.DataSource := DbG.DataSource;
    DBMemo1.DataField := DbG.DataSource.DataSet.FieldDefs[0].Name;
  end;
end;

procedure TfrmMDK_CDS.CkbConfirmDeleteClick(Sender: TObject);
begin
  DbN.ConfirmDelete := CkbConfirmDelete.Checked;
end;

procedure TfrmMDK_CDS.DbNClick(Sender: TObject; Button: TNavigateBtn);
begin
  ShowCDSRecord(TClientDataSet(DbG.DataSource.DataSet));
  ShowPosition;
end;

procedure TfrmMDK_CDS.PcMainChange(Sender: TObject);
begin
  try
    ShowCDSRecord(TClientDataSet(DbG.DataSource.DataSet));
  except
  end;
end;

procedure TfrmMDK_CDS.AcGUIUpdateExecute(Sender: TObject);
var
  ABM: TBookmark;
begin
  ABM := DmData.CdsDict.GetBookmark;
  Engine.SetUpFields;
  DmData.CdsDict.GotoBookmark(ABM);
  DmData.CdsDict.FreeBookmark(ABM);
end;

procedure TfrmMDK_CDS.AcDeleteAllExecute(Sender: TObject);
begin
  if not CkbConfirmDelete.Checked or (MessageDlg('Delete all records from the Table?', MtConfirmation, [MbYes, MbNo], 0)
    = MrYes) then
    try
      DbN.DataSource.DataSet.First;
      while not DbN.DataSource.DataSet.EOF and (DbN.DataSource.DataSet.RecordCount > 0) do
          DbN.DataSource.DataSet.Delete;
      ShowPosition;
    except
    end;
end;

procedure TfrmMDK_CDS.AcCopyRecordExecute(Sender: TObject);
var
  I, Ii: Integer;
  S: string;
const
  Cc = '00000000';
begin
  S := '';
  Ii := DbN.DataSource.DataSet.Fields[0].AsInteger + 2;
  for I := 0 to DbN.DataSource.DataSet.FieldCount - 1 do S := S + DbN.DataSource.DataSet.Fields[I].AsString + '^';
  DbN.DataSource.DataSet.Insert;
  for I := 1 to DbN.DataSource.DataSet.FieldCount - 1 do
      DbN.DataSource.DataSet.Fields[I].AsString := Piece(S, '^', I + 1);
  S := IntToStr(Ii);
  S := Copy(Cc, 1, Length(Cc) - Length(S)) + S;
  DbN.DataSource.DataSet.Fields[0].AsString := S;
  DbN.DataSource.DataSet.Post;
end;

procedure TfrmMDK_CDS.AcRecoverExecute(Sender: TObject);
var
  S: string;
  SL: TStringList;
  Ds: TDataSet;
begin
  Ds := DbG.DataSource.DataSet;
  S := Ds.FieldByName(FnEvents_Comments).AsString;
  if Pos(XML_VERSION, S) < 1 then begin
    ShowMessage('No Valid XML string found in the field <' + FnEvents_Comments + '>');
    Exit;
  end;
  Ds.Next;
  while (Ds.FieldByName(FnEvents_StudyID).AsString = CToBeContinued) and (not Ds.EOF) do begin
    S := S + Ds.FieldByName(FnEvents_Comments).AsString;
    Ds.Next;
  end;
  if DlgSave.Execute then begin
    SL := TStringList.Create;
    SL.Text := S;
    SL.SaveToFile(DlgSave.FileName);
    SL.Free;
  end;
end;

procedure TfrmMDK_CDS.AcSortAndFilterExecute(Sender: TObject);
var
  I: Integer;
  S: string;
  ACDS: TDataSet;
begin
  try
    ACDS := DbG.DataSource.DataSet;
    if not Assigned(DlgSort) then begin
      Application.CreateForm(TdlgSort, DlgSort);
      S := '';
      for I := 0 to ACDS.FieldCount - 1 do
        if ACDS.Fields[I].Visible then S := S + ACDS.Fields[I].FieldName + #13#10;
      DlgSort.CmbField.Items.Text := S;
      DlgSort.LbFrom.Items.Text := S;
    end;
    if DlgSort.ShowModal = MrOK then begin
      try
        ACDS.Filter := DlgSort.MmFilter.Text;
        ACDS.Filtered := DlgSort.MmFilter.Text <> '';
      except
      end;
      if DlgSort.RbYes.Checked then TClientDataSet(ACDS).IndexFieldNames := DlgSort.EdSort.Text
      else TClientDataSet(ACDS).IndexFieldNames := '';
    end;
  except
  end;
end;

procedure TfrmMDK_CDS.SetStatus(AStatus: string);
begin
{$IFDEF AANTEST}
  SbLoad.Visible := True;
  SbRecover.Visible := True;
  SbSaveAs.Visible := True;
  CkbConfirmDelete.Visible := True;
  PnlDBN.Visible := True;
  PnlInfoPlus.Visible := True;
  PnlDictionaryPlus.Visible := True;
{$ELSE}
  SbLoad.Visible := False;
  SbSaveAs.Visible := False;
  SbRecover.Visible := AStatus = RnAdmin;
  PnlDBN.Visible := AStatus = RnAdmin;
  CkbConfirmDelete.Visible := False;
  PnlInfoPlus.Visible := False;
  PnlDictionaryPlus.Visible := False;
  BbReload.Visible := False;
  BbSaveAsVistAOption.Visible := False;
{$ENDIF}
end;

procedure TfrmMDK_CDS.AcPatchDictionaryExecute(Sender: TObject);
var
  SL: TStringList;
begin
  if (MessageDlg('Do you want to save the copy of current dictionary in a text file?', MtInformation, [MbOk, MbNo], 0)
    = MrOK) then AcSaveAsExecute(nil);
  if DlgOpen.Execute then begin
    SL := TStringList.Create;
    SL.LoadFromFile(DlgOpen.FileName);
    DmData.PatchDictionary(SL.Text);
    SL.Free;
  end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.AcSaveInstrumentDataExecute(Sender: TObject);
var
  S, Ss, SName, SExtension: string;
  I: Integer;
  Ds: TDataSet;
  SL: TStringList;
begin
  if not DlgSave.Execute then Exit;
  S := DlgSave.FileName;
  SExtension := ExtractFileExt(S);
  SName := ExtractFileName(S);
  SName := ChangeFileExt(SName, '.');
  SName := Copy(SName, 1, Length(SName) - 1);
  I := 0;
  SL := TStringList.Create;
  Ds := DbG.DataSource.DataSet;
  repeat
    Inc(I);
    SL.Clear;
    S := Ds.FieldByName(FnEvents_Comments).AsString;
    Ds.Next;
    while (Ds.FieldByName(FnEvents_StudyID).AsString = CToBeContinued) and (not Ds.EOF) do begin
      S := S + Ds.FieldByName(FnEvents_Comments).AsString;
      Ds.Next;
    end;
    try
      if Pos('<?xml', S) > 0 then begin
        while (Pos('<?xml', S) <> 1) and (Length(S) > 5) do S := Copy(S, 2, Length(S));
      end else begin
      end;
    except
    end;
    SL.Text := S;
    Ss := Format('%s-%-2.2d%s', [SName, I, SExtension]);
    if S <> '' then SL.SaveToFile(Ss);
  until Ds.EOF or (Ds.FieldByName(FnEvents_Action).AsString <> 'Get Instrument Results');
  SL.Free;
end;

procedure TfrmMDK_CDS.AcSaveAsVistAOptionExecute(Sender: TObject);
var
  S: string;
begin
  try
    // s := fCDSOptionName; -- it's too dengerous to overwrite dictionary.
    S := 'COPY_' + DbG.DataSource.DataSet.Name;
    if InputQuery('Input Box', 'Enter the name of the option to save table <' + DbG.DataSource.DataSet.Name + '>', S)
      and (S <> '') then
      try
        TClientDataSet(DbG.DataSource.DataSet).MergeChangeLog;
        Engine.SetSystemOptionByName(S, TClientDataSet(DbG.DataSource.DataSet).XMLData);
      except
        on E: Exception do ShowMessage( { msgSystemOptionLockFailed+ } 'CDS XML was not saved');
      end;
  except
  end;
end;

procedure TfrmMDK_CDS.FormCreate(Sender: TObject);
begin
{$IFDEF AANTEST}
  BbSaveAsVistAOption.Visible := True;
  BbResetID.Visible := True;
  SbLoad.Visible := True;
{$ENDIF}
end;

procedure TfrmMDK_CDS.AcReloadExecute(Sender: TObject);
var
  S: string;
begin
  S := GetXML;
  if S = '' then ShowMessage('Incorrect Format. Try another record')
  else Engine.SetInstrumentRecord(Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, S, 'Reload Log Record');
end;

function TfrmMDK_CDS.GetXML: string;
var
  S: string;
  Ds: TDataSet;
begin
  Ds := DbG.DataSource.DataSet;
  Ds.DisableControls; // zzzzzzandria 061011
  S := Ds.FieldByName(FnEvents_Comments).AsString;
  Ds.Next;
  while (Ds.FieldByName(FnEvents_StudyID).AsString = CToBeContinued) and (not Ds.EOF) do begin
    S := S + Ds.FieldByName(FnEvents_Comments).AsString;
    Ds.Next;
  end;
  Ds.EnableControls; // zzzzzzandria 061011
  try
    if Pos('<?xml', S) > 0 then begin
      while (Pos('<?xml', S) <> 1) and (Length(S) > 5) do S := Copy(S, 2, Length(S));
    end
    else S := '';
  except
  end;
  Result := S;
end;

procedure TfrmMDK_CDS.AcResetIDExecute(Sender: TObject);
begin
  with DmData.CdsDict do begin
    Last;
    while not BOF do begin
      Edit;
      FieldByName(FnDict_ID).AsString := Format('%8.8d', [RecNo * 10]);
      Post;
      Prior;
    end;
  end;
end;

procedure TfrmMDK_CDS.AcDictionaryVerifyExecute(Sender: TObject);
begin
  VerifyDictionary(DmData.CdsInfo);
  VerifyDictionary(DmData.CdsFlowSheet);
  VerifyDictionary(DmData.CdsAP);
  VerifyDictionary(DmData.CdsAPHistory);
  VerifyDictionary(DmData.CdsVAInfection);
  VerifyDictionary(DmData.CdsStudyHistory);
  VerifyDictionary(DmData.CdsMedList);
  VerifyDictionary(DmData.CdsSummary);
  VerifyDictionary(DmData.CdsNotes);
end;

procedure TfrmMDK_CDS.AcReloadDictionaryExecute(Sender: TObject);
begin
  Engine.LoadDictionaryFromDB;
  Engine.SetUpFields;
end;

procedure TfrmMDK_CDS.AcSetLabelsExecute(Sender: TObject);
var
  S: string;
  ACDS: TClientDataSet;
  BM: TBookmark;
begin
  ACDS := TClientDataSet(DbN.DataSource.DataSet);
  BM := ACDS.GetBookmark;
  ACDS.First;
  while not ACDS.EOF do begin
    S := ACDS.FieldByName(FnDict_Label).AsString;
    if Pos('<', S) = 1 then S := Copy(S, 2, Length(S));
    if Pos('>', S) = Length(S) then S := Copy(S, 1, Length(S) - 1);
    ACDS.Edit;
    ACDS.FieldByName(FnDict_Label).AsString := S;
    ACDS.Post;
    ACDS.Next;
  end;
  ACDS.GotoBookmark(BM);
  ACDS.FreeBookmark(BM);
end;

procedure TfrmMDK_CDS.ForAllRecords(AField: string; SR: TStringReplace);
var
  S: string;
  ACDS: TClientDataSet;
  BM: TBookmark;
begin
  if not Assigned(SR) then Exit;
  ACDS := TClientDataSet(DbN.DataSource.DataSet);
  BM := ACDS.GetBookmark;
  ACDS.First;
  while not ACDS.EOF do begin
    try
      S := ACDS.FieldByName(AField).AsString;
    except
      Exit;
    end;
    ACDS.Edit;
    ACDS.FieldByName(AField).AsString := SR(S);
    ACDS.Post;
    ACDS.Next;
  end;
  ACDS.GotoBookmark(BM);
  ACDS.FreeBookmark(BM);
end;

function ReplacePounds(AString: string): string;
begin
  if Pos('#', Trim(AString)) = 1 then Result := ''
  else Result := AString;
end;

procedure TfrmMDK_CDS.AcClearFieldExecute(Sender: TObject);
begin
  ForAllRecords(FnDict_Format, ReplacePounds);
end;

procedure TfrmMDK_CDS.AcDictionaryDefaultExecute(Sender: TObject);
var
  S: string;
begin
  S := GetDefaultResource(OnDictionary);
  if S <> '' then begin
    Engine.LoadDictionaryFromString(S);
  end;
end;

procedure TfrmMDK_CDS.DbGDblClick(Sender: TObject);
var
  S: string;
  CdsDict, CDS: TClientDataSet;
  AF: TField;
begin
  if FCDSOptionName <> OnDictionary then Exit;
  if Engine.CurrentOperatorMode <> RnAdmin then Exit;
  CdsDict := TClientDataSet(DbG.DataSource.DataSet);
  S := CdsDict.FieldByName(FnDict_Table).AsString;
  CDS := DmData.GetCDSByName(S);
  if not Assigned(CDS) then Exit;
  S := CdsDict.FieldByName(FnDict_Column).AsString;
  AF := CDS.FieldByName(S);
  S := 'FullName: ' + AF.FullName + #13#10 + 'Display Name: ' + AF.DisplayName + #13#10 + 'Data Type: ' +
    DataTypeComment(AF.DataType) + #13#10;
  if AF.DataType = FtInteger then
      S := S + 'Min Value: ' + IntToStr(TIntegerField(AF).MinValue) + #13#10 + 'Max Value: ' +
      IntToStr(TIntegerField(AF).MaxValue) + #13#10;
  if AF.DataType = FtFloat then
      S := S + 'Min Value: ' + Format('%n', [TFloatField(AF).MinValue]) + #13#10 + 'Max Value: ' +
      Format('%n', [TFloatField(AF).MaxValue]) + #13#10;
  S := S + #13#10;
  if MessageDlg(S + 'Reset GUI fields assosiated with this dictionary line?', MtConfirmation, [MbNo, MbOk], 0) <> MrOK
  then Exit;
  CDSSetUpField(AF, CdsDict.FieldByName(FnDict_Format).AsString, CdsDict.FieldByName(FnDict_EditMask).AsString,
    CdsDict.FieldByName(FnDict_Width).AsString, CdsDict.FieldByName(FnDict_Units).AsString,
    CdsDict.FieldByName(FnDict_Default).AsString, CdsDict.FieldByName(FnDict_Section).AsString,
    CdsDict.FieldByName(FnDict_Label).AsString, CdsDict.FieldByName(FnDict_MaxValue).AsString,
    CdsDict.FieldByName(FnDict_MinValue).AsString);
end;

procedure TfrmMDK_CDS.AcDictionaryRestoreExecute(Sender: TObject);
begin
  // restoration of the dictionary from backup  copy
{$IFDEF DICTIONARY_BACKUP}
  Engine.LoadDictionaryFromDB(DonDictionaryBackup);
{$ENDIF}
end;

procedure TfrmMDK_CDS.AcDictionaryBackupExecute(Sender: TObject);
begin
  // backup copy of dictionary
{$IFDEF DICTIONARY_BACKUP}
  Engine.SaveDictionaryToDB(DonDictionaryBackup);
{$ENDIF}
end;

procedure TfrmMDK_CDS.SetUpLayout(B: Boolean);
begin
  PnlCDSDetails.Visible := True;
  PnlFieldName.Visible := True;
  PnlDictionaryActions1.Visible := B;
  PnlDictionaryBackup.Visible := True;
  DbG.ReadOnly := False;
  DbN.Enabled := True;
  AcDeleteAll.Enabled := True;
  AcLoad.Enabled := True;
  DbN.VisibleButtons := [NbFirst, NbPrior, NbNext, NbLast, NbRefresh, NbEdit, NbPost, NbCancel];
end;

end.
