unit fMDK_ListEdit;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 12/03/07 1:15p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the  Hemodialysis application
  *                     PCE Editor form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_ListEdit.pas $
  *
  * $History: fMDK_ListEdit.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 4  *****************
  * User: Zzzzzzandria Date: 6/21/07    Time: 9:05a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  * Build 312 #14
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ActnList, Buttons, CheckLst, DB,
  DBClient, Grids, DBGrids, UMDK_BillingInfo, DBCtrls, System.Actions;

type
  TfrmListEdit = class(TForm)
    Panel1: TPanel;
    PnlToolbar: TPanel;
    PnlData: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    EdClinicID: TEdit;
    EdPatientID: TEdit;
    Al: TActionList;
    AcSetData: TAction;
    PageControl1: TPageControl;
    TsDiagnosis: TTabSheet;
    TsProcedures: TTabSheet;
    Panel6: TPanel;
    Panel7: TPanel;
    TsProviders: TTabSheet;
    Panel11: TPanel;
    Panel12: TPanel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Panel13: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    TvDiagnoses: TTreeView;
    CbDiagnoses: TComboBox;
    Splitter1: TSplitter;
    Panel9: TPanel;
    Splitter2: TSplitter;
    Panel10: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel18: TPanel;
    CbProcedure: TComboBox;
    TvProcedure: TTreeView;
    Panel19: TPanel;
    Splitter3: TSplitter;
    Panel20: TPanel;
    CbProvider: TComboBox;
    LbProviders: TListBox;
    Panel21: TPanel;
    Panel22: TPanel;
    ClbProvider: TCheckListBox;
    AcAddProvider: TAction;
    LblProvider: TLabel;
    AcDeleteProvider: TAction;
    Label3: TLabel;
    SbDebug: TSpeedButton;
    AcData: TAction;
    AcAddDiagnosys: TAction;
    AcDeleteDiagnosys: TAction;
    AcAddProcedure: TAction;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    AcGetProcedures: TAction;
    AcGetDiagnoses: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label4: TLabel;
    EdStudy: TEdit;
    SpeedButton4: TSpeedButton;
    AcGetEncounterData: TAction;
    Panel3: TPanel;
    Panel23: TPanel;
    LblDiagnoses: TLabel;
    Label6: TLabel;
    CkbDiagnoses: TCheckListBox;
    PnlGrid: TPanel;
    DbgProcedures: TDBGrid;
    CdsProcedures: TClientDataSet;
    DsProcedures: TDataSource;
    AcGetLegacy: TAction;
    TsService: TTabSheet;
    PnlService: TPanel;
    Mm: TMemo;
    AcClear: TAction;
    SpeedButton5: TSpeedButton;
    AcSetPCE: TAction;
    SpeedButton6: TSpeedButton;
    AcDeleteProcedure: TAction;
    SpeedButton2: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Timer1: TTimer;
    CbReview: TCheckBox;
    AcSave: TAction;
    Label5: TLabel;
    Label7: TLabel;
    SB: TStatusBar;
    MmService: TMemo;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Splitter4: TSplitter;
    PnlSC: TPanel;
    CbxSC: TCheckBox;
    CbxCV: TCheckBox;
    CbxAOE: TCheckBox;
    CbxIRE: TCheckBox;
    CbxEC: TCheckBox;
    CbxMST: TCheckBox;
    CbxHNC: TCheckBox;
    Pnl1: TPanel;
    RbSC1: TRadioButton;
    RbSC2: TRadioButton;
    Panel24: TPanel;
    RbCV1: TRadioButton;
    RbCV2: TRadioButton;
    Panel25: TPanel;
    RbAOE1: TRadioButton;
    RbAOE2: TRadioButton;
    Panel26: TPanel;
    RbIRE1: TRadioButton;
    RbIRE2: TRadioButton;
    Panel28: TPanel;
    RbHNC1: TRadioButton;
    RbHNC2: TRadioButton;
    Panel29: TPanel;
    RbMST1: TRadioButton;
    RbMST2: TRadioButton;
    Panel30: TPanel;
    RbEC1: TRadioButton;
    RbEC2: TRadioButton;
    Label8: TLabel;
    Label9: TLabel;
    Bevel2: TBevel;
    Label10: TLabel;
    Bevel3: TBevel;
    Button1: TButton;
    AcReview: TAction;
    AcSearchClinic: TAction;
    AcSetClinic: TAction;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    AcGetPCEInfo: TAction;
    BitBtn9: TBitBtn;
    Panel2: TPanel;
    RbCLV1: TRadioButton;
    RbCLV2: TRadioButton;
    CbxCLV: TCheckBox;
    procedure CbDiagnosesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure CbProviderKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AcAddProviderExecute(Sender: TObject);
    procedure ClbProviderClick(Sender: TObject);
    procedure AcDeleteProviderExecute(Sender: TObject);
    procedure LbProvidersKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AcDataExecute(Sender: TObject);
    procedure AcGetProceduresExecute(Sender: TObject);
    procedure AcGetDiagnosesExecute(Sender: TObject);
    procedure AcGetEncounterDataExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcAddProcedureExecute(Sender: TObject);
    procedure TvProcedureDblClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AcGetLegacyExecute(Sender: TObject);
    procedure CkbDiagnosesClick(Sender: TObject);
    procedure AcAddDiagnosysExecute(Sender: TObject);
    procedure AcDeleteDiagnosysExecute(Sender: TObject);
    procedure PnlGridResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TvDiagnosesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TvProcedureKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AcSetDataExecute(Sender: TObject);
    procedure AcClearExecute(Sender: TObject);
    procedure AcSetPCEExecute(Sender: TObject);
    procedure AcDeleteProcedureExecute(Sender: TObject);
    procedure DbgProceduresColEnter(Sender: TObject);
    procedure DbgProceduresDblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure CbReviewClick(Sender: TObject);
    procedure AcSaveExecute(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure AcReviewExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure AcGetPCEInfoExecute(Sender: TObject);
  private
    FLegacy: string;
    function GetLegacy: string;
    procedure SetLegacy(AValue: string);
    procedure ClearObjects;
    procedure DoProviderSearch(ATarget: string);
    procedure SetConnectionData(AV: string);
    procedure SBShow(AString: string);
  protected
    FIgnore: Boolean;
  public
    procedure SetUpClinicInfo;
    property Legacy: string read GetLegacy write SetLegacy;
    procedure ShowStatus;
    procedure SetQuantityLimit(AnInteger: Integer);
  end;

var
  FrmListEdit: TfrmListEdit;

function UpdateList(ADFN, AClinic: string; APage: Integer = 0): Integer;

implementation

uses
  UMDK_Engine, UROR_CommonUtils, UMDK_CDSCommon, UMDK_Options, System.UITypes, UMDK_Info, UMDK_Common, FMDK_Cover,
  DMDK_Data;

{$R *.dfm}

const
  IStatus       = 0;
  ILastUpdate   = 1;
  FnPr_Quantity = 'Quantity';

function UpdateList(ADFN, AClinic: string; APage: Integer = 0): Integer;
var
  S, SComment: string;
begin
  if not Assigned(FrmListEdit) then Application.CreateForm(TfrmListEdit, FrmListEdit);
  FrmListEdit.Legacy := Engine.BillingInfo.Legacy;
  FrmListEdit.PageControl1.ActivePageIndex := APage;
  case APage of
    0: FrmListEdit.ActiveControl := FrmListEdit.CbDiagnoses;
    1: FrmListEdit.ActiveControl := FrmListEdit.CbProcedure;
    2: FrmListEdit.ActiveControl := FrmListEdit.CbProvider;
  end;
  FrmListEdit.PnlToolbar.Color := Preferences.IValue(OnColorToolbar);
  FrmListEdit.EdPatientID.Text := ADFN;
  FrmListEdit.SetUpClinicInfo;
  FrmListEdit.EdStudy.Text := Engine.CurrentPatient.SessionID;
  FrmListEdit.AcGetEncounterData.Execute;
  FrmListEdit.CbReview.Checked := True;
  FrmListEdit.CbReviewClick(nil);
  FrmListEdit.AcReviewExecute(nil);
  Engine.GetServiceConnections(Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, S);
  FrmListEdit.MmService.Lines.Text := S;
  FrmListEdit.ShowStatus;
  Result := FrmListEdit.ShowModal;
  if Result = MrOK then begin
    FrmListEdit.AcGetLegacyExecute(nil);
    Engine.BillingInfo.Legacy := FrmListEdit.Legacy;
    Engine.Report(RtInfo, FrmListEdit.Legacy, '', 0, ''
      { Engine.CurrentOperatorID } , 'getEncounterData');
    if not Engine.ValidBillingInfo(SComment) then begin
      MessageDlg('Billing Information is not correct.' + #13#10 + #13#10 + SComment + #13#10 + #13#10, MtInformation,
        [MbOK], 0);
      Result := -1;
    end;
  end;
end;

procedure ClearNode(AName: string; ATree: TTreeView);
var
  J, I: Integer;
  TheNode: TTreeNode;
begin
  TheNode := nil;
  for I := 0 to ATree.Items.Count - 1 do begin
    if ATree.Items[I].Text = AName then begin
      TheNode := ATree.Items[I];
      Break;
    end;
  end;
  J := 0;
  while J < ATree.Items.Count - 1 do begin
    if (TheNode <> nil) and (ATree.Items[J].Parent = TheNode) then ATree.Items.Delete(ATree.Items[J])
    else Inc(J);
  end;
  if TheNode <> nil then ATree.Items.Delete(TheNode);
end;

procedure SetUpTab(AName, AValue: string; Tv: TTreeView);
var
  SL: TStringList;
  SName, SCode: string;
  I: Integer;
  { tnParent, } TnRoot: TTreeNode;
begin
  ClearNode(AName, Tv);
  TnRoot := nil;
  SL := TStringList.Create;
  SL.Text := AValue;
  for I := 1 to SL.Count - 1 do begin
    if TnRoot = nil then TnRoot := Tv.Items.AddChild(nil, AName);
    SCode := Piece(SL[I], '^', 1);
    SName := Piece(SL[I], '^', 2);
    if SCode = '' then
      // tnParent := tv.Items.AddChild(tnRoot, sName)
        Tv.Items.AddChild(TnRoot, SName)
    else
      // tv.Items.AddChild(tnParent, sCode + ' -- ' + sname);
        Tv.Items.AddChild(TnRoot, SCode + ' -- ' + SName);
  end;
  SL.Free;
end;

procedure TfrmListEdit.CbDiagnosesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  Ss: string;
  Cds_currentinfo: TMDK_Info;

  procedure SetUpTab(AName, AValue: string; Tv: TTreeView);
  var
    SL: TStringList;
    SName, SIEN, SCode: string;
    I, K: Integer;
    TnRoot: TTreeNode;
  begin
    ClearNode(AName, Tv);
    TnRoot := nil;
    SL := TStringList.Create;
    SL.Text := AValue;
    if Pos('^', SL[0]) > 0 then K := 0
    else K := 1;
    for I := K to SL.Count - 1 do begin
      if TnRoot = nil then TnRoot := Tv.Items.AddChild(nil, AName);
      SCode := Piece(SL[I], '^', 1);
      SIEN := Piece(SL[I], '^', 2);
      SName := Piece(SL[I], '^', 3);
      Tv.Items.AddChild(TnRoot, SCode + ' -- ' + SName + ' | ' + SIEN);
    end;
    I := SL.Count;
    if I > 0 then I := I - 1;
    if Tv = FrmListEdit.TvDiagnoses then begin
      SBShow(SB.Panels[IStatus].Text + '  ' + IntToStr(I) + ' items found');
      if I > 0 then ActiveControl := TvDiagnoses;
    end else begin
      SBShow(SB.Panels[IStatus].Text + '  ' + IntToStr(I) + ' items found');
      if I > 0 then ActiveControl := TvProcedure;
    end;
    if TnRoot <> nil then TnRoot.Expand(True);
    SL.Free;
  end;

begin
  Cds_currentinfo := Engine.GetCurrentInfo;
  if Key = Vk_Return then begin
    if Sender = CbProcedure then begin
      if CbProcedure.Text = '' then begin
        Timer1.Enabled := True;
        SBShow('  Enter search target and press Enter');
        Exit;
      end;
      SBShow('  Looking for <' + CbProcedure.Text + '>');
      Application.ProcessMessages;
      Engine.GetCPTByTarget(CbProcedure.Text, Cds_currentinfo.StudyID, Ss);
      if Pos('-1', Ss) = 1 then ShowMessage(Piece(Ss, '^', 2))
      else SetUpTab('Lexicon Procedures', Ss, TvProcedure);
    end;
    if Sender = CbDiagnoses then begin
      if CbDiagnoses.Text = '' then begin
        Timer1.Enabled := True;
        SBShow('  Enter search target and press Enter');
        Exit;
      end;
      SBShow('  Looking for <' + CbDiagnoses.Text + '>');
      Application.ProcessMessages;
      // come back to this for DiagDate
      Engine.GetICDByTarget(CbDiagnoses.Text, Cds_currentinfo.StudyID, Ss);
      if Pos('-1', Ss) = 1 then ShowMessage(Piece(Ss, '^', 2))
      else SetUpTab('Lexicon Diagnoses', Ss, TvDiagnoses);
    end;
    Timer1.Enabled := True;
  end;
end;

procedure TfrmListEdit.DoProviderSearch(ATarget: string);
var
  I: Integer;
  S, SName, SValue: string;
  SL: TStringList;
begin
  if ATarget = '' then begin
    Timer1.Enabled := True;
    SBShow('  Enter search target and press Enter');
    Exit;
  end;
  SBShow('  Looking for <' + ATarget + '>');
  SL := TStringList.Create;
  S := Engine.GetProviderList(ATarget);
  SL.Text := S;
  if Pos('-1', S) = 1 then ShowMessage(Piece(S, '^', 2))
  else begin
    Timer1.Enabled := True;
    if SL.Count > 1 then begin
      LbProviders.Items.Clear;
      for I := 1 to SL.Count - 1 do begin
        SName := Piece(SL[I], '^', 2);
        SValue := Piece(SL[I], '^', 1);
        LbProviders.Items.AddObject(SName, Pointer(StrToInt(SValue)));
      end;
    end;
    I := SL.Count;
    if I > 0 then I := I - 1;
    SBShow('  Looking for <' + ATarget + '>: ' + IntToStr(I) + ' items found');
    if I > 0 then ActiveControl := LbProviders;
  end;
  SL.Free;
end;

procedure TfrmListEdit.CbProviderKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = Vk_Return) and (CbProvider.Text <> '') then DoProviderSearch(Uppercase(CbProvider.Text))
end;

procedure TfrmListEdit.AcAddProviderExecute(Sender: TObject);
var
  S: string;
  AP: TMDK_Provider;
begin
  try
    S := LbProviders.Items[LbProviders.ItemIndex];
    AP := TMDK_Provider.Create;
    AP.ID := IntToStr(Integer(Pointer(LbProviders.Items.Objects[LbProviders.ItemIndex])));
    AP.Name := S;
    AP.Primary := False;
    if Pos(Uppercase(LbProviders.Items[LbProviders.ItemIndex]), Uppercase(ClbProvider.Items.Text)) > 0 then begin
      ShowMessage('The provider "' + LbProviders.Items[LbProviders.ItemIndex] + '" has already been selected');
      Exit;
    end;
    ClbProvider.Items.AddObject(LbProviders.Items[LbProviders.ItemIndex], AP);
  except
  end;
end;

procedure OnlyYou(AClb: TCheckListBox);
var
  I: Integer;
begin
  for I := 0 to AClb.Items.Count - 1 do AClb.Checked[I] := I = AClb.ItemIndex;
end;

procedure TfrmListEdit.ClbProviderClick(Sender: TObject);

  procedure OnlyYou(AClb: TCheckListBox);
  var
    I: Integer;
  begin
    for I := 0 to AClb.Items.Count - 1 do begin
      AClb.Checked[I] := I = AClb.ItemIndex;
      try
        TMDK_Provider(ClbProvider.Items.Objects[I]).Primary := I = AClb.ItemIndex;
      except
      end;
    end;
  end;

begin
  if ClbProvider.ItemIndex < 0 then ClbProvider.ItemIndex := 0;
  try
    LblProvider.Caption := ClbProvider.Items[ClbProvider.ItemIndex] + '  ' +
      TMDK_Provider(ClbProvider.Items.Objects[ClbProvider.ItemIndex]).ID;
  except
  end;
  OnlyYou(ClbProvider);
end;

procedure TfrmListEdit.AcDeleteProviderExecute(Sender: TObject);
var
  I: Integer;
  AP: TMDK_Provider;
begin
  if ClbProvider.Items.Count < 1 then Exit;
  try
    I := ClbProvider.ItemIndex;
    AP := TMDK_Provider(ClbProvider.Items.Objects[I]);
    try
      FreeAndNil(AP);
    except
    end;
    ClbProvider.Items.Delete(I);
    if I < ClbProvider.Items.Count then ClbProvider.ItemIndex := I
    else if ClbProvider.Items.Count > 0 then ClbProvider.ItemIndex := ClbProvider.Items.Count - 1;
  except
  end;
end;

procedure TfrmListEdit.LbProvidersKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = Vk_Return) and (LbProviders.Items.Count <> 0) then AcAddProvider.Execute;
end;

procedure TfrmListEdit.AcDataExecute(Sender: TObject);
begin
  PnlData.Visible := not PnlData.Visible;
  LblProvider.Visible := not LblProvider.Visible;
end;

procedure TfrmListEdit.AcGetProceduresExecute(Sender: TObject);
var
  Ss: string;
begin
  Engine.GetClinicProcedures(EdPatientID.Text, EdClinicID.Text, Ss);
  Mm.Lines.Text := Mm.Lines.Text + Ss + #13#10;
  SetUpTab('Procedures by Clinic', Ss, TvProcedure);
end;

procedure TfrmListEdit.AcGetDiagnosesExecute(Sender: TObject);
var
  Ss: string;
begin
  Engine.GetClinicDiagnosis(EdPatientID.Text, EdClinicID.Text, Ss);
  Mm.Lines.Text := Mm.Lines.Text + Ss + #13#10;
  SetUpTab('Diagnoses By Clinic', Ss, TvDiagnoses);
end;

procedure TfrmListEdit.AcGetEncounterDataExecute(Sender: TObject);
var
  S: string;
begin
  // Engine.GetBillingData(edStudy.Text,s);
  Engine.GetEncounterData(EdStudy.Text, S);
  Mm.Lines.Text := S;
end;

procedure TfrmListEdit.FormCreate(Sender: TObject);
begin
  FIgnore := False;
  NewStringField(CdsProcedures, 'Code', 'Code', 8, 20);
  NewStringField(CdsProcedures, 'Title', 'Title', 200, 200);
  NewIntegerField(CdsProcedures, FnPr_Quantity, FnPr_Quantity, 8);
  try
    TIntegerField(CdsProcedures.Fields[CdsProcedures.FieldCount - 1]).MaxValue :=
      DevOptions.IValue(DonMaxProcedureQuantity);
  except
    begin
      TIntegerField(CdsProcedures.Fields[CdsProcedures.FieldCount - 1]).MaxValue := 99;
    end;
  end;
  NewStringField(CdsProcedures, 'IEN', 'IEN', 8, 20);
{$IFNDEF AANTEST}
  CdsProcedures.Fields[CdsProcedures.FieldCount - 1].Visible := False;
{$ENDIF}
  CdsProcedures.CreateDataSet;
  CdsProcedures.Open;
{$IFDEF AANTEST}
  PnlData.Visible := True;
  SbDebug.Visible := True;
  LblProvider.Visible := True;
  LblDiagnoses.Visible := True;
{$ELSE}
  PnlData.Visible := False;
  SbDebug.Visible := False;
  LblProvider.Visible := False;
  LblDiagnoses.Visible := False;
{$ENDIF}
end;

procedure TfrmListEdit.AcAddProcedureExecute(Sender: TObject);
var
  Tn: TTreeNode;
  SCode, STitle, SIEN: string;
begin
  Tn := TvProcedure.Selected;
  if Tn = nil then Exit;
  if Tn.Level < 1 then Exit;
  if Pos('--', Tn.Text) = 0 then Exit;
  SCode := Trim(Piece(Tn.Text, '--', 1));
  STitle := Piece(Tn.Text, '--', 2);
  SIEN := Piece(STitle, ' | ', 2);
  if CdsProcedures.Locate('Code', SCode, []) then begin
    ShowMessage('The Procedure "' + STitle + '" has already been selected.');
    ActiveControl := DbgProcedures;
  end
  else
    try
      CdsProcedures.Insert;
      CdsProcedures.FieldByName('Code').AsString := SCode;
      CdsProcedures.FieldByName('Title').AsString := STitle;
      CdsProcedures.FieldByName(FnPr_Quantity).AsInteger := 1;
      CdsProcedures.FieldByName('IEN').AsString := SIEN;
      CdsProcedures.Post;
    except
    end;
end;

procedure TfrmListEdit.TvProcedureDblClick(Sender: TObject);
begin
  AcAddProcedure.Execute;
end;

procedure TfrmListEdit.PageControl1Change(Sender: TObject);
begin
  with PageControl1 do begin
    if ActivePage = TsDiagnosis then ActiveControl := CbDiagnoses;
    if ActivePage = TsProcedures then ActiveControl := CbProcedure;
    if ActivePage = TsProviders then ActiveControl := CbProvider;
  end;
end;

procedure TfrmListEdit.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := MrCancel;
end;

procedure TfrmListEdit.AcGetLegacyExecute(Sender: TObject);
begin
  Mm.Lines.Text := Legacy;
end;

procedure TfrmListEdit.CkbDiagnosesClick(Sender: TObject);
  procedure OnlyYou(AClb: TCheckListBox);
  var
    I: Integer;
  begin
    for I := 0 to AClb.Items.Count - 1 do begin
      AClb.Checked[I] := I = AClb.ItemIndex;
      if Assigned(AClb.Items.Objects[I]) then
        try
          TMDK_Provider(ClbProvider.Items.Objects[I]).Primary := AClb.Checked[I];
        except
        end;
    end;
  end;

begin
  if CkbDiagnoses.ItemIndex < 0 then CkbDiagnoses.ItemIndex := 0;
  TMDK_Diagnosis(CkbDiagnoses.Items.Objects[CkbDiagnoses.ItemIndex]).Primary :=
    CkbDiagnoses.Checked[CkbDiagnoses.ItemIndex];
  OnlyYou(CkbDiagnoses);
end;

procedure TfrmListEdit.AcAddDiagnosysExecute(Sender: TObject);
var
  S, Ss, SIEN: string;
  AP: TMDK_Diagnosis;
begin
  try
    if TvDiagnoses.Selected = nil then Exit;
    S := TvDiagnoses.Selected.Text;
    if Pos(' -- ', S) = 0 then Exit;
    Ss := Piece(S, ' -- ', 1);
    S := Piece(S, ' -- ', 2);
    SIEN := Piece(S, ' | ', 2);
    if Pos(S, CkbDiagnoses.Items.Text) > 0 then Exit;
    AP := TMDK_Diagnosis.Create;
    AP.ID := Ss;
    AP.Title := S;
    AP.IEN := SIEN;
    AP.Category := '';
    AP.Primary := False;
    CkbDiagnoses.Items.AddObject(S, AP);
  except
  end;
end;

procedure TfrmListEdit.AcDeleteDiagnosysExecute(Sender: TObject);
var
  I: Integer;
  AP: TMDK_Diagnosis;
begin
  if CkbDiagnoses.Items.Count < 1 then Exit;
  try
    I := CkbDiagnoses.ItemIndex;
    AP := TMDK_Diagnosis(CkbDiagnoses.Items.Objects[I]);
    try
      FreeAndNil(AP);
    except
    end;
    CkbDiagnoses.Items.Delete(I);
    if I < CkbDiagnoses.Items.Count then CkbDiagnoses.ItemIndex := I
    else if CkbDiagnoses.Items.Count > 0 then CkbDiagnoses.ItemIndex := CkbDiagnoses.Items.Count - 1;
  except
  end;
end;

procedure TfrmListEdit.PnlGridResize(Sender: TObject);
var
  I: Integer;
begin
  I := DbgProcedures.Columns[0].Width + DbgProcedures.Columns[2].Width
{$IFDEF AANTEST}
    + DbgProcedures.Columns[3].Width
{$ENDIF}
    ;
  DbgProcedures.Columns[1].Width := DbgProcedures.Width - I - 40;
end;

procedure TfrmListEdit.FormResize(Sender: TObject);
begin
  PnlGrid.OnResize(Sender);
end;

procedure TfrmListEdit.TvDiagnosesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = Vk_Return then AcAddDiagnosysExecute(nil);
end;

procedure TfrmListEdit.TvProcedureKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = Vk_Return then AcAddProcedureExecute(nil);
end;

function TfrmListEdit.GetLegacy: string;
var
  Ss: string;
  I: Integer;
  APro: TMDK_Provider;
  ADiag: TMDK_Diagnosis;

  function SetCB(AName: string; Ckb: TCheckBox): string;
  begin
    Result := '';
    if AName = '' then Exit;
    if Ckb.Enabled then begin
      Result := AName + ';1^';
      if Ckb.Checked then Result := Result + '1;'
      else Result := Result + '0;';
    end
    else Result := AName + ';0^;';
  end;

  function SetRB(AName: string; Ckb: TRadioButton): string;
  begin
    Result := '';
    if AName = '' then Exit;
    if Ckb.Enabled then begin
      Result := AName + ';1^';
      if Ckb.Checked then Result := Result + '1;'
      else Result := Result + '0;';
    end
    else Result := AName + ';0^;';
  end;

begin
  Ss := '';
  try
    Ss := Ss + SetRB('SC', RbSC1);
    Ss := Ss + SetRB('AO', RbAOE1);
    Ss := Ss + SetRB('IR', RbIRE1);
    Ss := Ss + SetRB('EC', RbEC1);
    Ss := Ss + SetRB('MST', RbMST1);
    Ss := Ss + SetRB('HNC', RbHNC1);
    Ss := Ss + SetRB('CV', RbCV1);
    Ss := Ss + SetRB('CLV', RbCLV1);
    Ss := Ss + #13#10;
    for I := 0 to ClbProvider.Items.Count - 1 do begin
      APro := TMDK_Provider(ClbProvider.Items.Objects[I]);
      Ss := Ss + 'PRV^' + APro.ID + '^^' + APro.Name + '^^';
      if ClbProvider.Checked[I] then Ss := Ss + '1';
      Ss := Ss + #13#10;
    end;
    for I := 0 to CkbDiagnoses.Items.Count - 1 do begin
      ADiag := TMDK_Diagnosis(CkbDiagnoses.Items.Objects[I]);
      Ss := Ss + 'POV^' + ADiag.IEN + '^' + ADiag.ID + '^^' + ADiag.Title + '^';
      if CkbDiagnoses.Checked[I] then Ss := Ss + '1';
      Ss := Ss + #13#10;
    end;
    CdsProcedures.First;
    while not CdsProcedures.Eof do begin
      Ss := Ss + 'CPT^' + CdsProcedures.FieldByName('IEN').AsString + '^' + CdsProcedures.FieldByName('Code')
        .AsString + '^^';
      Ss := Ss + Piece(CdsProcedures.FieldByName('Title').AsString, '|', 1) + '^^';
      Ss := Ss + CdsProcedures.FieldByName(FnPr_Quantity).AsString;
      CdsProcedures.Next;
      Ss := Ss + #13#10;
    end;
  except
  end;
  Result := Ss;
end;

procedure TfrmListEdit.ClearObjects;
var
  I: Integer;
  AP: TMDK_Provider;
  AD: TMDK_Diagnosis;
begin
  for I := 0 to CkbDiagnoses.Count - 1 do begin
    AD := TMDK_Diagnosis(CkbDiagnoses.Items.Objects[I]);
    try
      FreeAndNil(AD);
    except
    end;
  end;
  CkbDiagnoses.Items.Clear;
  for I := 0 to ClbProvider.Count - 1 do begin
    AP := TMDK_Provider(ClbProvider.Items.Objects[I]);
    try
      FreeAndNil(AP);
    except
    end;
  end;
  ClbProvider.Items.Clear;
  CdsProcedures.First;
  while not CdsProcedures.Eof do CdsProcedures.Delete;
end;

procedure TfrmListEdit.AcSetDataExecute(Sender: TObject);
begin
  Legacy := Mm.Lines.Text;
end;

procedure TfrmListEdit.SetConnectionData(AV: string);

  procedure Connection(ASource: string; ACB: TCheckBox);
  var
    S1, S2: string;
  begin
    if ASource = '' then Exit;
    S1 := Piece(ASource, '^', 1);
    S2 := Piece(Piece(ASource, '^', 2), ';', 1);
    if S1 = '0' then begin
      ACB.Enabled := False;
      ACB.Checked := False;
    end else begin
      ACB.Enabled := True;
      ACB.Checked := S2 = '1';
    end;
  end;

  procedure Connection1(ASource: string; ACB, ACB1: TRadioButton);
  var
    S1, S2: string;
  begin
    if ASource = '' then Exit;
    S1 := Piece(ASource, '^', 1);
    S2 := Piece(Piece(ASource, '^', 2), ';', 1);
    if S1 = '0' then begin
      ACB.Enabled := False;
      ACB.Checked := False;
      ACB1.Enabled := False;
      ACB1.Checked := False;
    end else begin
      ACB.Enabled := True;
      ACB1.Enabled := True;
      ACB.Checked := S2 = '1';
//      ACB1.Checked := S2 = '0';
    end;
  end;

var
  Ss: string;
begin
  Ss := Piece(AV, 'SC;', 2);
  Connection(Ss, CbxSC);
  Connection1(Ss, RbSC1, RbSC2);
  Ss := Piece(AV, 'AO;', 2);
  Connection(Ss, CbxAOE);
  Connection1(Ss, RbAOE1, RbAOE2);
  Ss := Piece(AV, 'IR;', 2);
  Connection(Ss, CbxIRE);
  Connection1(Ss, RbIRE1, RbIRE2);
  Ss := Piece(AV, 'EC;', 2);
  Connection(Ss, CbxEC);
  Connection1(Ss, RbEC1, RbEC2);
  Ss := Piece(AV, 'HNC;', 2);
  Connection(Ss, CbxHNC);
  Connection1(Ss, RbHNC1, RbHNC2);
  Ss := Piece(AV, 'MST;', 2);
  Connection(Ss, CbxMST);
  Connection1(Ss, RbMST1, RbMST2);
  Ss := Piece(AV, 'CV;', 2);
  Connection(Ss, CbxCV);
  Connection1(Ss, RbCV1, RbCV2);
  Ss := Piece(AV, 'CLV;', 2);
  Connection(Ss, CbxCLV);
  Connection1(Ss, RbCLV1, RbCLV2);
end;

procedure TfrmListEdit.SetLegacy(AValue: string);
var
  I: Integer;
  SL: TStringList;
  {
    iPRVKeyword = 1;
    iPRVCode = 2;
    iPRVName = 4;
    iPRVPrimary = 6;
  }
  procedure AddProvider(ASource: string);
  var
    AProvider: TMDK_Provider;
  begin
    AProvider := TMDK_Provider.Create;
    AProvider.ID := Piece(ASource, '^', IPRVCode);
    AProvider.Name := Piece(ASource, '^', IPRVName);
    AProvider.Primary := Piece(ASource, '^', IPRVPrimary) = '1';
    ClbProvider.Items.AddObject(AProvider.Name, AProvider);
    ClbProvider.Checked[ClbProvider.Items.Count - 1] := AProvider.Primary;
  end;
{
  iCPTKeyword = 1;
  iCPTCode = 3;
  iCPTSHortDescription = 5;
  iCPTQuantity = 7;
}
  procedure AddCPT(ASource: string);
  begin
    try
      CdsProcedures.Insert;
      CdsProcedures.FieldByName('Code').AsString := Piece(ASource, '^', ICPTCode);
      CdsProcedures.FieldByName('Title').AsString := Piece(ASource, '^', ICPTShortDescription);
      CdsProcedures.FieldByName(FnPr_Quantity).AsString := Piece(ASource, '^', ICPTQuantity);
      CdsProcedures.Post;
    except
    end;
  end;
{
  iICD9Keyword = 1;
  iICD9Code = 3;
  iICD9ShortDescription = 5;
  iICD9Primary = 6;
}
  procedure AddICD(ASource: string);
  var
    ADiagnosis: TMDK_Diagnosis;
  begin
    ADiagnosis := TMDK_Diagnosis.Create;
    ADiagnosis.ID := Piece(ASource, '^', IICD9Code);
    ADiagnosis.IEN := Piece(ASource, '^', IICDIEN);
    ADiagnosis.Title := Piece(ASource, '^', IICD9ShortDescription);
    ADiagnosis.Primary := Piece(ASource, '^', IICD9Primary) = '1';
    CkbDiagnoses.Items.AddObject(ADiagnosis.Title, ADiagnosis);
    CkbDiagnoses.Checked[CkbDiagnoses.Items.Count - 1] := ADiagnosis.Primary;
  end;

begin
  ClearObjects;
  FLegacy := AValue;
  SL := TStringList.Create;
  SL.Text := AValue;
  if SL.Count < 1 then Exit;
  SetConnectionData(SL[0]);
  for I := 1 to SL.Count - 1 do begin
    if Piece(SL[I], '^', 1) = 'PRV' then AddProvider(SL[I]);
    if Piece(SL[I], '^', 1) = 'POV' then AddICD(SL[I]);
    if Piece(SL[I], '^', 1) = 'CPT' then AddCPT(SL[I]);
  end;
end;

procedure TfrmListEdit.AcClearExecute(Sender: TObject);
begin
  ClearObjects;
end;

procedure TfrmListEdit.AcSetPCEExecute(Sender: TObject);
var
  S: string;
  ASL: TStringList;
begin
  ASL := TStringList.Create;
  ASL.Text := Mm.Lines.Text;
  Engine.SetEncounterData(EdStudy.Text, ASL, S);
  ASL.Free;
{$IFDEF AANTEST}
  ShowMessage(S);
{$ENDIF}
end;

procedure TfrmListEdit.AcDeleteProcedureExecute(Sender: TObject);
begin
  if CdsProcedures.Eof then
    try
      CdsProcedures.Prior;
    except
      Exit;
    end;
  try
    CdsProcedures.Delete;
    CdsProcedures.Post;
  except
  end;
end;

procedure TfrmListEdit.DbgProceduresColEnter(Sender: TObject);
begin
  with DbgProcedures.SelectedField do begin
    if (FieldName = FnPr_Quantity) then DbgProcedures.ReadOnly := False
    else DbgProcedures.ReadOnly := True
  end;
end;

procedure TfrmListEdit.DbgProceduresDblClick(Sender: TObject);
begin
  AcDeleteProcedure.Execute;
end;

procedure TfrmListEdit.SetUpClinicInfo;
var
  Ss: string;
begin
  Engine.GetClinicProcedures(Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, Ss);
  SetUpTab('Procedures by Clinic', Ss, TvProcedure);
  Engine.GetClinicDiagnosis(Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, Ss);
  SetUpTab('Diagnoses By Clinic', Ss, TvDiagnoses);
end;

procedure TfrmListEdit.Timer1Timer(Sender: TObject);
begin
  try
    SBShow('');
    Timer1.Enabled := False;
  except
  end
end;

procedure TfrmListEdit.SpeedButton2Click(Sender: TObject);
begin
  DoProviderSearch(Uppercase(CbProvider.Text));
end;

procedure TfrmListEdit.SpeedButton7Click(Sender: TObject);
var
  K: Word;
begin
  K := Vk_Return;
  CbDiagnosesKeyDown(CbProcedure, K, []);
end;

procedure TfrmListEdit.SpeedButton8Click(Sender: TObject);
var
  K: Word;
begin
  K := Vk_Return;
  CbDiagnosesKeyDown(CbDiagnoses, K, []);
end;

procedure TfrmListEdit.CbReviewClick(Sender: TObject);
begin
  if not CbReview.Checked then begin
    RbSC2.Enabled := CbReview.Checked;
    RbCV2.Enabled := CbReview.Checked;
    RbAOE2.Enabled := CbReview.Checked;
    RbEC2.Enabled := CbReview.Checked;
    RbMST2.Enabled := CbReview.Checked;
    RbHNC2.Enabled := CbReview.Checked;
    RbIRE2.Enabled := CbReview.Checked;
    RbCLV2.Enabled := CbReview.Checked;
    RbSC1.Enabled := CbReview.Checked;
    RbCV1.Enabled := CbReview.Checked;
    RbAOE1.Enabled := CbReview.Checked;
    RbEC1.Enabled := CbReview.Checked;
    RbMST1.Enabled := CbReview.Checked;
    RbHNC1.Enabled := CbReview.Checked;
    RbIRE1.Enabled := CbReview.Checked;
    RbCLV1.Enabled := CbReview.Checked;
    CbxSC.Enabled := CbReview.Checked;
    CbxCV.Enabled := CbReview.Checked;
    CbxAOE.Enabled := CbReview.Checked;
    CbxEC.Enabled := CbReview.Checked;
    CbxMST.Enabled := CbReview.Checked;
    CbxHNC.Enabled := CbReview.Checked;
    CbxIRE.Enabled := CbReview.Checked;
    CbxCLV.Enabled := CbReview.Checked;
  end else begin
    SetConnectionData(FLegacy);
    if not FIgnore then Engine.PCESetReviewed;
  end;
  ShowStatus;
end;

procedure TfrmListEdit.AcSaveExecute(Sender: TObject);
begin
  // if cbReview.Checked then
  if Engine.PCEReadyToSubmit then ModalResult := MrOK
  else ShowMessage('Please, review the Service connection information before saving the data');
end;

procedure TfrmListEdit.SBShow(AString: string);
begin
  SB.Panels[IStatus].Text := AString;
end;

procedure TfrmListEdit.SpeedButton10Click(Sender: TObject);
begin
  ModalResult := MrCancel;
end;

procedure TfrmListEdit.ShowStatus;
var
  SL: TStringList;
begin
  // SB.Panels[iLastUpdate].Text := Engine.PCEBillingStatusDescription;
  SL := TStringList.Create;
  SL.Text := Engine.PCEBillingStatusDescription;
  Caption := 'PCE Information. ' + SL[0];
  SL.Free;
end;

procedure TfrmListEdit.AcReviewExecute(Sender: TObject);
begin
  SetConnectionData(FLegacy);
  if not FIgnore then Engine.PCESetReviewed;
  ShowStatus;
end;

procedure TfrmListEdit.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CdsProcedures.First;
  while not CdsProcedures.Eof do begin
    if CdsProcedures.FieldByName(FnPr_Quantity).AsInteger > DevOptions.IValue(DonMaxProcedureQuantity) then Break;
    CdsProcedures.Next;
  end;
  if CdsProcedures.Eof or (MessageDlg('Procedure Quantity ' + #13#10 + CdsProcedures.FieldByName('Quantity').AsString +
    #13#10 + ' is greater then the limit value' + #13#10 + DevOptions.SValue(DonMaxProcedureQuantity) + #13#10 +
    'Close the dialog?', MtConfirmation, [MbYes, MbNo], 0) = MrYes) then CanClose := True;
end;

procedure TfrmListEdit.SetQuantityLimit(AnInteger: Integer);
begin
  TIntegerField(CdsProcedures.FieldByName(FnPr_Quantity)).MaxValue := AnInteger;
end;

procedure TfrmListEdit.AcGetPCEInfoExecute(Sender: TObject);
var
  S: string;
begin
  S := Engine.GetPCEInfo;
  MessageDlg('PCE Info:' + #13#10#13#10 + S, MtInformation, [MbOK], 0);
end;

end.
