unit fMDK_LocalLogin;
{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Site Name:    Hines OIFO
  *       Date Created: 3/28/07
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Local login dialog window
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_Engine.pas $
  *
  *       $ History: uMDK_Engine.pas $
}

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Jpeg;

type
  TdlgLocalLogin = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    Memo1: TMemo;
    CbName: TComboBox;
    Memo2: TMemo;
    Image1: TImage;
    LblName: TLabel;
    BitBtn3: TBitBtn;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure CbNameKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DlgLocalLogin: TdlgLocalLogin;

implementation

uses
  UGMV_VersionInfo, Dialogs, System.UITypes;

{$R *.dfm}

procedure TdlgLocalLogin.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

procedure TdlgLocalLogin.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = Char(VK_ESCAPE) then ModalResult := MrCancel;
end;

procedure TdlgLocalLogin.CbNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = Char(VK_RETURN) then ModalResult := MrOK;
end;

procedure TdlgLocalLogin.FormCreate(Sender: TObject);
begin
  LblName.Caption := CurrentTitle;
end;

procedure TdlgLocalLogin.BitBtn3Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_INDEX, 1001); // this is a patch
end;

procedure TdlgLocalLogin.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (Trim(CbName.Text) = '') and (ModalResult <> MrCancel) then begin
    MessageDlg('Provide the user name, please', MtWarning, [MbOK], 0);
    Action := CaNone;
  end;
end;

end.
