unit fMDK_Main;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 10/03/08 2:20p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Main form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_Main.pas $
  *
  *       $ History: fMDK_Main.pas $
  *
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdActns, ActnList, Menus, ExtCtrls, StdCtrls,
{$IFDEF XPTHEME}
  XPMan, Trpcb,
{$ENDIF}
  Buttons, CommCtrl, AppEvnts, UMDK_Patients, Grids, DBGrids, ShellAPI,
  MidasLib, // To avoid the distribution of the MIDAS.DLL
  ImgList, System.Actions, System.ImageList
  , WinHelpViewer;

type
  TShellMode = (SmBlank, SmLog, SmPatient);

type
  TfrmMain = class(TForm)
    ActionList: TActionList;
    FileExit: TAction;
    HelpAbout: TAction;
    PnlToolBar: TPanel;
    PnlPtInfo: TPanel;
    LblPtDemographics: TLabel;
    LblPtName: TLabel;
    AcShowLog: TAction;
    StatusBar: TStatusBar;
    AclMain: TActionList;
    AcFileExit: TAction;
    AcFileBreakLink: TAction;
    AcFileRejoinApp: TAction;
    AcFileRejoinGlobal: TAction;
    AcPatientSelect: TAction;
    PgcMain: TPageControl;
    TsCover: TTabSheet;
    TsRxLab: TTabSheet;
    TsPreTreatment: TTabSheet;
    TsAccess: TTabSheet;
    TsFlowSheet: TTabSheet;
    TsPostTreatment: TTabSheet;
    TsSummary: TTabSheet;
    PnlTopSpace: TPanel;
    MmShell: TMainMenu;
    N1: TMenuItem;
    Exit1: TMenuItem;
    AlEvents: TActionList;
    PnlLog: TPanel;
    PnlBlank: TPanel;
    AcSave: TAction;
    AcShowPatientInfo: TAction;
    AcShowPatientPostings: TAction;
    PatientInfo1: TMenuItem;
    Postings1: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    CCOW1: TMenuItem;
    BreaktheClinicalLink1: TMenuItem;
    UseApplicationData1: TMenuItem;
    N2: TMenuItem;
    UseGlobalData1: TMenuItem;
    AcFileDisplayStatus: TAction;
    N4: TMenuItem;
    DisplayStatus1: TMenuItem;
    AcHelpIndex: TAction;
    Index1: TMenuItem;
    AcWebPage: TAction;
    Timer: TTimer;
    AcBugsLog1: TMenuItem;
    SelectPatient1: TMenuItem;
    N5: TMenuItem;
    AcOptionsShow: TAction;
    Print1: TMenuItem;
    Save1: TMenuItem;
    N7: TMenuItem;
    TsSubmit: TTabSheet;
    AcReloadOptions: TAction;
    ReloadOptions1: TMenuItem;
    Web1: TMenuItem;
    Panel3: TPanel;
    Bevel1: TBevel;
    TmGateway: TTimer;
    AcShowGatewayInfo: TAction;
    ShowGatewayInfo1: TMenuItem;
    MnuDEV: TMenuItem;
    AcSaveVitals: TAction;
    AcSaveFlowsheet: TAction;
    SaveVitals1: TMenuItem;
    SaveFlowsheetVitals1: TMenuItem;
    AcReadMe: TAction;
    ReadMe1: TMenuItem;
    MnuOptions: TMenuItem;
    AcUserManual: TAction;
    UserManual1: TMenuItem;
    N6: TMenuItem;
    ImageList1: TImageList;
    AcShowStatusPanel: TAction;
    ShowHideStatusPanel1: TMenuItem;
    N8: TMenuItem;
    EditFlowsheetRecord1: TMenuItem;
    AcShowGUI: TAction;
    ShowGUI1: TMenuItem;
    AcSaveRPCResults: TAction;
    SaveRPCResults1: TMenuItem;
    AcSetPending: TAction;
    N10: TMenuItem;
    SetPendingStatus1: TMenuItem;
    PnlStudyInfo: TPanel;
    LblStudyDate: TLabel;
    Label2: TLabel;
    LblStudyNum: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    LblLocationID: TLabel;
    LblStudyStatus: TLabel;
    LblAppointmentInfo: TLabel;
    MiComments: TMenuItem;
    PnlStatusseparator: TPanel;
    Bevel7: TBevel;
    PnlButtons3D: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SbSelect: TSpeedButton;
    SbSave: TSpeedButton;
    N11: TMenuItem;
    ShowOldStyleComments1: TMenuItem;
    AcRPCLog: TAction;
    RPCLog1: TMenuItem;
    N12: TMenuItem;
    AcGatewayWatch: TAction;
    WatchGateway1: TMenuItem;
    procedure FileExitExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcFileExitExecute(Sender: TObject);
    procedure AcPatientSelectExecute(Sender: TObject);
    procedure PnlPtInfoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PnlPtInfoMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AcShowLogExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AcSaveExecute(Sender: TObject);
    procedure AcShowPatientInfoExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure HelpAboutExecute(Sender: TObject);
    procedure AcHelpIndexExecute(Sender: TObject);
    procedure AcWebPageExecute(Sender: TObject);
    procedure PgcMainChange(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure StatusBarMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StatusBarDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AcOptionsShowExecute(Sender: TObject);
    procedure AcReloadOptionsExecute(Sender: TObject);
    procedure PgcMainChanging(Sender: TObject; var AllowChange: Boolean);
    procedure TmGatewayTimer(Sender: TObject);
    procedure AcShowGatewayInfoExecute(Sender: TObject);
    procedure AcSaveVitalsExecute(Sender: TObject);
    procedure AcSaveFlowsheetExecute(Sender: TObject);
    procedure AcUserManualExecute(Sender: TObject);
    procedure AcShowStatusPanelExecute(Sender: TObject);
    procedure PgcMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure AcShowGUIExecute(Sender: TObject);
    procedure AcSaveRPCResultsExecute(Sender: TObject);
    procedure AcSetPendingExecute(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure ShowOldStyleComments1Click(Sender: TObject);
    procedure AcRPCLogExecute(Sender: TObject);
    procedure AcGatewayWatchExecute(Sender: TObject);
  private
    FMenu: TMainMenu;
    FCurrentForm: TForm;
    FMode: TShellMode;
    function VerifyStartUp: Boolean;
    procedure ShutDownKitchen(AMsg: string = '');
    procedure SetUpForm(AForm: TForm; ATab: TWinControl { TTabSheet } );
    procedure SetMode(AMode: TShellMode);
    procedure AdjustInfoPanelPosition(AStep: Integer);
    procedure SetBackGroundColor(AReadOnly: Boolean);
    procedure ShowStatusMessage(AString: string);
  public
    function Connect: Boolean;
    procedure Disconnect;
    procedure SelectPatient(APatient: TMDKRegisteredPatient);
    property Mode: TShellMode read FMode write SetMode;
    procedure RefreshStudyStatus(AcClear: Boolean = False);
    procedure RefreshSubmitStatusPanel;
    procedure ShutDown;
    procedure GoToPage(APage: string);
    procedure ResetOptions;
    procedure UpdateSB;
    procedure RefreshCurrentWindow;
    procedure AppException(Sender: TObject; E: Exception);
  end;

var
  FrmMain: TfrmMain;

implementation

uses
  DMDK_Data, DB, FMDK_Blank, FMDK_Log, FMDK_Access, FMDK_Cover, FMDK_RxLab, FMDK_Pre, FMDK_Post, FMDK_Flowsheet,
  FMDK_Summary, UMDK_Engine, UMDK_Summary, FMDK_Info, FGMV_AboutDlg, UMDK_Common, UGMV_VersionInfo, UROR_RPCBroker,
  FMDK_Wait, UMDK_Info, FMDK_Options, UMDK_Options, FMDK_Submit, UMDK_InstrumentRecord, FMDK_Medication, FMDK_ListEdit,
  UMDK_MedList, FGMV_TimeOutManager, UMDK_CDSCommon, UMDK_Utils, UMDK_Flowsheet, Printers, FMDK_FlowSheetEdit,
  FMDK_LocalLogin, FMDK_AddOptions, System.UITypes,
  ODBController_Renal, UMDK_LocalDB, UMDK_Notes, IMDK_Presenter,
{$IFDEF RPCLOG}
  FZZ_EventLog, UZZ_DescribedItem,
{$ENDIF}
  FMDK_Studies;

{$R *.dfm}
{$R MDK_Dictionary.res} // default string lists

const
  SbIndex_StudyID       = 2;
  SbIndex_Connection    = 1;
  SbIndex_ReadOnly      = 3;
  SbIndex_User          = 4; // 2;
  SbIndex_UserRole      = 5; // 3;//4
  SbIndex_GatewayStatus = 6; // 4;//5

var
  ContextName: string = 'MD HEMODIALYSIS USER';
  /// /////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FormCreate(Sender: TObject);

  procedure SafeSetUpForm(AForm: TForm; AWinCOntrol: TWinControl);
  begin
    try
      SetUpForm(AForm, AWinCOntrol);
    except
      on E: Exception do ShowMessage('Setup form failed:' + #13 + E.Message);
    end;
  end;

begin
  Left := 0;
  Top := 0;
  FCurrentForm := nil;
{$IFNDEF LOG_DIALOG}
  SafeSetUpForm(FrmLog, PnlLog);
{$ENDIF}
  SafeSetUpForm(FrmBlank, PnlBlank);
  SafeSetUpForm(FrmCover, TsCover);
  SafeSetUpForm(FrmRxLab, TsRxLab);
  SafeSetUpForm(FrmPre, TsPreTreatment);
  SafeSetUpForm(FrmAccess, TsAccess);
  SafeSetUpForm(FrmPost, TsPostTreatment);
  SafeSetUpForm(FrmFlow, TsFlowSheet);
  SafeSetUpForm(FrmSummary, TsSummary);
  SafeSetUpForm(FrmSubmit, TsSubmit);
  TsCover.Caption := PnCover;
  TsRxLab.Caption := PnRxLab;
  TsPreTreatment.Caption := PnPre;
  TsPostTreatment.Caption := PnPost;
  TsAccess.Caption := PnAccess;
  TsFlowSheet.Caption := PnFlow;
  TsSummary.Caption := PnSummary;
  Mode := SmBlank;
  if Assigned(FrmCover) then FMenu := FrmCover.GetMainMenu;
  HelpContext := 1001;
  PgcMain.HelpContext := 1001;
  Position := PoScreenCenter; // zzzzzzandria 2008-03-12
{$IFDEF AANTEST}
  MnuDEV.Visible := True;
{$ELSE}
  MnuDEV.Visible := False;
{$ENDIF}
  StatusBar.Panels[SbIndex_GatewayStatus].Style := PsOwnerDraw;
end;

procedure TfrmMain.UpdateSB;
var
  I, Wd: Integer;
begin
  if Assigned(Engine) then begin
    StatusBar.Panels[SbIndex_UserRole].Text := '  ' + Engine.CurrentOperatorMode + '   ';
    if Engine.CurrentPatient = nil then StatusBar.Panels[SbIndex_ReadOnly].Text := NotAplicable
    else if Engine.CurrentPatient.ID = '' then StatusBar.Panels[SbIndex_ReadOnly].Text := NotAplicable
    else if Engine.CurrentPatient.ReadOnly then StatusBar.Panels[SbIndex_ReadOnly].Text := '    R/O   '
    else StatusBar.Panels[SbIndex_ReadOnly].Text := ' Editable ';
  end else
    StatusBar.Panels[SbIndex_ReadOnly].Text := NotAplicable;
  Wd := StatusBar.Width;
  for I := StatusBar.Panels.Count - 1 downto 1 do begin
    if StatusBar.Panels[I].Text <> '' then
        StatusBar.Panels[I].Width := StatusBar.Canvas.TextWidth(StatusBar.Panels[I].Text) + 10;
    Wd := Wd - StatusBar.Panels[I].Width;
  end;
  StatusBar.Panels[0].Width := Wd;
  StatusBar.Invalidate;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  UpdateSB;
end;
/// /////////////////////////////////////////////////////////////////////////////

function TfrmMain.VerifyStartUp: Boolean;
var
  SDictionary, S10, Sb10, S, Ss: string;
  FNow: TDateTime;
  BLocalConnect: Boolean;
const
  MsgDictionaryLoadFailed = 'The application dictionary cannot loaded.' + #13#10 +
    '(Possible reason: network traffic congestion)' + #13#10 + 'The application will close.' + #13#10#13#10 +
    'Please try again later.' + #13#10;
  MsgDictionaryNotFound = 'Appication Dictionary is not found.' + #13#10 + 'Do you want to use the default dictionary?'
    + #13#10 + '' + #13#10 + 'Select "No" to close the application without changes';
begin
  FrmWait.WakeUp(PgcMain, 'Starting Application', AviCopyFiles);
  Caption := {$IFDEF AANTEST} ' ===DEV=== ' + {$ENDIF}CurrentTitle;
  Engine := TMDK_Engine.Create;
{$IFDEF DEMO}
  BLocalConnect := CmdLineSwitch(['/DEMO']);
{$ELSE}
  BLocalConnect := False;
{$ENDIF}
  Engine.StartUpRenalController(BLocalConnect); // creates Renal Controller
{$IFDEF DEMO}
  if CmdLineSwitch(['/DEMO']) then Engine.CurrentOperatorID := DlgLocalLogin.CbName.Text;
{$ENDIF}
  if not Engine.VersionIsCompatible then
    begin
{$IFDEF DEBUG}
      Caption := Caption + ' Server Version Ignored. ';
{$ELSE}
      Result := False;
      Exit;
{$ENDIF}
    end;
{$IFDEF RPCLOG}
  WatchGateway1.Visible := Engine.CurrentOperatorMode = RnAdmin;
  RPCLog1.Visible := True; // Engine.CurrentOperatorMode = rnAdmin;
  if Engine.CurrentOperatorMode = RnAdmin then Caption := Caption + '  RPC Log Enabled';
{$ENDIF}
  FrmWait.WakeUp(PgcMain, 'Starting Application', AviCopyFiles);
  // assuming Engine is Running:
  Engine.SetServerDelay;
  FrmWait.AddLogLine(Char(VK_TAB) + 'Load Dictionary:');
  // zzzzzzandria 2008-02-19 --------------------------------------------- begin
  S := Engine.FRenalController.GetXPAR('');
  if Piece(S, '^', 3) <> 'YES' then begin
    Engine.FRenalController.GetSystemOption(OnDictionary, SDictionary);
    if (SDictionary = '') or (Pos('-1', SDictionary) = 1) then S := Engine.RestoreDefaults;
    Engine.FRenalController.SetXPAR('', FloatToStr(WindowsDateTimeToFMDateTime(Now)) + '^' + Engine.CurrentOperatorID +
      '^YES^' + GetWorkstationName);
  end;
  // zzzzzzandria 2008-02-19 ----------------------------------------------- end
  // Check if ICD10 Codes are available first if not, check if ICd10 codes are
  // part of gui resources. If not on server, but in resources, update server.
  // otherwise do nothing zzzzzzcarnej
  Engine.FRenalController.GetSystemOption(OnESRD_ICD10, S10);
{$IFDEF RPCLOG}
  AddEvent('ESRD ICD10 Get', GetDescribedItem(OnESRD_ICD10 + ' set', S10));
{$ENDIF}
  if Pos('-1^', S10) = 1 then begin
    Sb10 := GetDefaultResource(OnESRD_ICD10);
    if Sb10 <> '' then Engine.FRenalController.SetSystemOption(OnESRD_ICD10, Sb10);
  end;
  // Check if the dictionary is available and restore it if needed
  Engine.FRenalController.GetSystemOption(OnDictionary, SDictionary);
  if (SDictionary = '') or (Pos('-1', SDictionary) = 1) then begin
    FrmWait.Hide;
    if DevOptions.BValue(DonSilentDefaultsRestore) or
      (MessageDlg(MsgDictionaryNotFound, MtWarning, [MbYes, MbNo], 0) = MrYes) then begin
      S := Engine.RestoreOptionDefault(OnDictionary); // zzzzzzandria 2008-02-14
      if S = '' then Engine.FRenalController.GetSystemOption(OnDictionary, SDictionary)
      else begin
        MessageDlg(MsgDictionaryLoadFailed, MtError, [MbOK], 0);
        ShutDownKitchen('No dictionary found');
        Result := False;
        Exit;
      end;
    end else begin
      ShutDownKitchen('No dictionary found');
      Result := False;
      Exit;
    end;
  end;
  FrmWait.Show;
  FNow := Now;
  // zzzzzzandria 2007-07-20 ----------------------------------------------- begin
  if not Engine.LoadDictionaryFromString(SDictionary) then begin
    Engine.Report(RtError, S, '', 0, '', 'Load Dictionary', 'FAILED', True);
    S := Engine.RestoreOptionDefault(OnDictionary);
    if S <> '' then begin
      Engine.Report(RtError, 'Failed to restore the default dictionary' + #13#10 + S, '', 0, '',
        'Load Default Dictionary', 'FAILED', True);
      Result := False;
      Exit;
    end else begin
      Engine.FRenalController.GetSystemOption(OnDictionary, SDictionary);
      if not Engine.LoadDictionaryFromString(SDictionary) then begin
        Engine.Report(RtError, 'Failed to install the default dictionary', '', 0, '', 'Install the default dictionary',
          'FAILED', True);
      end else begin
        Engine.SaveDictionaryToDB;
        Engine.Report(RtWarning, SDictionary, '', 0, '', 'Save default dictionary', 'OK', True);
      end;
    end;
  end;
{$IFDEF SAVE_ERRORS_LOG}
  Engine.FRenalController.GetSystemOption(OnErrorLog, S);
  try
    CDSInitByString(DmData.CdsEvents, S, False);
  except
  end;
{$ENDIF}
  // zzzzzzandria 2007-07-20 ------------------------------------------------- end
  FrmWait.AppendLogLine(Char(VK_TAB) + FormatDateTime('ss.zzz', Now - FNow));
  if DevOptions.BValue(DonCleanOptions) then begin
    Engine.CleanUpOptions;
    FNow := Now;
    FrmWait.AddLogLine(Char(VK_TAB) + 'Update options:');
    // Clean preferences
    S := Engine.GetSystemOptionByName(OnSysOptions);
    SysOptions.CleanupString(S);
    SysOptions.Overwrite(S);
    if not SysOptions.CheckValues(Ss) then Engine.Report(RtWarning, Ss, '', 0, '', 'Fix System Option values');
    Engine.SetSystemOptionByName(OnSysOptions, SysOptions.ValueList.Text);
    S := Engine.GetUserOptionByName(OnUserOptions);
    UserOptions.Overwrite(S);
    if not UserOptions.CheckValues(Ss) then Engine.Report(RtWarning, Ss, '', 0, '', 'Fix User Option values');
    S := Engine.GetSystemOptionByName(OnSysOptions);
    UserOptions.CleanupValues(S);
    Engine.SetUserOptionByName(OnUserOptions, UserOptions.ValueList.Text);
    ResetPreferences(SysOptions.ValueList.Text, UserOptions.ValueList.Text);
    S := Engine.GetUserOptionByName(OnUserSettings);
    // UserSettings.ValueList.Text := s;
    UserSettings.CleanupString(S);
    UserSettings.CleanUpBlankLines(S);
    UserSettings.Overwrite(S);
    Preferences.Overwrite(S);
    FrmWait.AppendLogLine(Char(VK_TAB) + FormatDateTime('ss.zzz', Now - FNow));
  end;
  CheckSummaryReport; // zzzzzzandria 2008-03-31 -------------------------------
  FrmWait.AddLogLine(Char(VK_TAB) + 'Set Up Fields:');
  FNow := Now;
  Engine.SetUpFields; // updates field formats;  zzzzzzandria  050322
  FrmWait.AppendLogLine(Char(VK_TAB) + FormatDateTime('ss.zzz', Now - FNow));
  // With the Engine Running we can create Business Objects
  FrmLog.SetUpTreeView;
  FrmLog.SetRole(Engine.CurrentOperatorMode);
  // Link Vascular Access GUI elements with Datasets
  FrmAccess.VAP := Engine.VAP_CDS;
  FrmAccess.VAPH := Engine.VAPH_CDS;
  FrmAccess.VAPIH := Engine.VAPIH_CDS;
  FrmAccess.OperatorID := Engine.CurrentOperatorID;
  // Submit
  FrmSubmit.LblOperator.Caption := Engine.CurrentOperatorID;
  Application.ProcessMessages;
  // frmFlow
  FrmFlow.BtnReload.Visible := Engine.CurrentOperatorMode = RnAdmin;
  InitStudyList;
  Mode := SmBlank; // setMode will set the initial Layout
  AcPatientSelect.Enabled := Engine <> nil;
  TmGateway.Enabled := True;
  TmGatewayTimer(nil);
  Result := True;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Engine);
end;

procedure TfrmMain.ShutDownKitchen(AMsg: string = '');
var
  ErrorMsg: string;
begin
  ErrorMsg := AMsg;
  if Assigned(FrmStudies) and Assigned(Engine) then
    if not Engine.CurrentPatient.ReadOnly then FrmStudies.ReleaseStudy(Engine.CurrentPatient.SessionID, ErrorMsg);
  try
    FrmLog.SaveOptions;
{$IFNDEF LOG_DIALOG}
    FrmLog.Close;
{$ENDIF}
    FrmBlank.Close;
    FrmCover.Close;
    FrmAccess.Close;
    FrmRxLab.Close;
    FrmPre.Close;
    FrmPost.Close;
    FrmFlow.Close;
    FrmSummary.Close;
    // zzzzzzandria 2007-07-20 ------------------------------------------- begin
{$IFDEF SAVE_ERRORS_LOG}
    if Preferences.BValue(OnSaveErrorsLog) then DmData.SaveErrorsLog;
{$ENDIF}
    // zzzzzzandria 2007-07-20 --------------------------------------------- end
  except
  end;
  FrmWait.LayDown;
end;
/// /////////////////////////////////////////////////////////////////////////////
// Connect is called from the project module to create the connection/broker
/// /////////////////////////////////////////////////////////////////////////////

function TfrmMain.Connect: Boolean;
begin
  Result := False;
  // zzzzzzandria 20081003 ------------------------------------------------- begin
  // comments removed on 20081002
  // zzzzzzandria 20081003 --------------------------------------------------- end
  if VerifyStartUp then begin
    Result := True;
{$IFDEF XPTHEME}
    DevOptions.SetValue(DonWindowsXPTheme, 'TRUE');
{$ELSE}
    DevOptions.SetValue(DonWindowsXPTheme, 'FALSE');
{$ENDIF}
    if not Assigned(RPCBroker) then begin
      StatusBar.Panels[SbIndex_Connection].Text := '  ' + LOCAL_DIR;
      StatusBar.Panels[SbIndex_User].Text := '  ' + Engine.CurrentOperatorID;
      // zzzzzzandria 20081003 ------------------------------------------------- begin
    end else begin
      StatusBar.Panels[SbIndex_Connection].Text := Format(' %s @ %d', [RPCBroker.Server, RPCBroker.ListenerPort]);
      StatusBar.Panels[SbIndex_User].Text := '  ' + RPCBroker.User.Name;
      // zzzzzzandria 20081003 --------------------------------------------------- end
    end;
    UpdateSB;
    { Display the main application window }
    Show;
    Application.BringToFront;
  end;
end;

procedure TfrmMain.Disconnect;
begin
  if Assigned(RPCBroker) then begin
    Hide;
    { Disconnect and destroy the RPC Broker }
    RPCBroker.Connected := False;
    FreeAndNil(RPCBroker);
  end;
end;

procedure TfrmMain.AcFileExitExecute(Sender: TObject);
begin
  if FrmLog.FOptions.ValueUpdated then FrmLog.FOptions.SaveOptionList;
  Close;
end;
/// /////////////////////////////////////////////////////////////////////////////
/// /////////////////////////////////////////////////////////////////////////////
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.SetBackGroundColor(AReadOnly: Boolean);
var
  _Enabled: Boolean;
  _color: TColor;
begin
  if AReadOnly then begin
    PnlToolBar.Color := Preferences.IValue(OnColorReview);
    _color := Preferences.IValue(OnColorReview);
    _Enabled := False;
  end else begin
    PnlToolBar.Color := ClSilver;
    _color := Preferences.IValue(OnColorBackground);
    _Enabled := True;
  end;
  try
    FrmCover.PnlCover.Color := _color;
    FrmPre.PnlPreTreatment.Color := _color;
    FrmPost.PnlPostTreatment.Color := _color;
    FrmRxLab.PnlRXLabs.Color := _color;
    FrmFlow.PnlFlowSheet.Color := _color;
    FrmSummary.PnlSummary.Color := _color;
    FrmSubmit.PnlSubmit.Color := _color;
    FrmAccess.PnlAccess.Color := _color;
    FrmCover.SetReadOnly(not _Enabled);
    FrmPre.SetReadOnly(not _Enabled);
    FrmPost.SetReadOnly(not _Enabled);
    FrmRxLab.SetReadOnly(not _Enabled);
    FrmFlow.SetReadOnly(not _Enabled);
    FrmSummary.SetReadOnly(not _Enabled);
    FrmAccess.AccessReadOnly := not _Enabled;
  except
  end;
end;

procedure TfrmMain.SetMode(AMode: TShellMode);
begin
  FMode := AMode;
  case FMode of
    SmBlank: begin
        PnlLog.Visible := False;
        PnlToolBar.Visible := True { False };
        PnlBlank.Visible := True;
        PnlStudyInfo.Visible := False;
        PgcMain.Visible := False;
        LblPtName.Caption := '';
        LblPtDemographics.Caption := '  No Patient Selected';
        AcSave.Enabled := False;
        SbSelect.Caption := '&Select';
        SbSave.Caption := 'Sa&ve';
        MnuOptions.Caption := 'Options...';
        HelpContext := 1000;
        MiComments.Visible := False;
        if Assigned(FMenu) then MmShell.Unmerge(FMenu);
        // ResetOptions;
      end;
    SmLog: begin
        PnlStudyInfo.Visible := False;
        PnlLog.Visible := True;
        PnlToolBar.Visible := False;
        PnlBlank.Visible := False;
        PgcMain.Visible := False;
        FrmLog.Refresh;
        FrmLog.SetRole(Engine.CurrentOperatorMode);
        SbSelect.Caption := 'Select';
        SbSave.Caption := 'Save';
        MnuOptions.Caption := 'Patient Data...';
        HelpContext := 1009;
        MiComments.Visible := False;
        if Assigned(FMenu) then MmShell.Unmerge(FMenu);
      end;
    SmPatient: begin
        PnlLog.Visible := False;
        PnlToolBar.Visible := True;
        PnlBlank.Visible := False;
        PgcMain.Visible := True;
        PnlStudyInfo.Visible := True;
        SbSelect.Caption := '&Select';
        SbSave.Caption := 'Sa&ve';
        MnuOptions.Caption := 'Options...';
        HelpContext := 1001 + PgcMain.ActivePageIndex;
        ResetOptions;
        MiComments.Visible := True;
        if Assigned(FMenu) then MmShell.Merge(FMenu);
      end;
  end;
end;

// Performs actual selection of the patient
procedure TfrmMain.SelectPatient(APatient: TMDKRegisteredPatient);
begin
  // switch to the Cover page. Could be user parameter
  PgcMain.ActivePageIndex := 0;
  // setUp the main form
  AcShowPatientInfo.Enabled := APatient <> nil;
  AcShowPatientPostings.Enabled := APatient <> nil;
  if APatient = nil then begin
    Mode := SmBlank;
    Engine.CurrentPatient := nil;
    FrmFlow.TmrRefresh.Enabled := False;
    LblAppointmentInfo.Caption := '';
  end else begin
    FrmWait.WakeUp(PgcMain, 'Loading Patient Data');
    Mode := SmPatient;
    // Update Demographic info================================================
    FrmWait.AddLogLine(APatient.Name + #13#10);
    SetBackGroundColor(APatient.ReadOnly);
    // disable GUI updates
    FrmRxLab.Ignore := True;
    FrmPre.Ignore := True;
    FrmPost.Ignore := True;
    FrmSummary.Ignore := True;
    // Assigning new patient will force Engine to Save previous data
    // and SetUp CurrentSessionID
    Engine.CurrentPatient := APatient;
    Engine.GetLocation;
    // Main Form
    RefreshStudyStatus;
    // Update Forms===========================================================
    // frmAccess ===
    FrmWait.AddLogLine(Char(VK_TAB) + 'Patient Data:');
    FrmAccess.PatientID := APatient.ID;
    FrmAccess.StudyID := APatient.SessionID;
    FrmAccess.LoadPatientData;
    FrmAccess.FrameMDK_Comments.AcRefreshExecute(nil);
    FrmWait.AppendLogLine(GLoaded);
    // frmCover setup ===
    FrmCover.ReloadData;
    FrmCover.CbReadOnly.Checked := not Engine.IsItNewInfo;
    FrmCover.ActivateTabForm;
    FrmCover.RefreshGUI; // zzzzzzandria 20081002 patch 1.0.6.320
    // frmRXLab setup
    FrmWait.AddLogLine(Char(VK_TAB) + 'Rx and Lab Info:');
    FrmRxLab.TvLabs.Items.Clear;
    FrmRxLab.FrameMDK_Comments.AcRefreshExecute(nil);
    FrmWait.AppendLogLine(GLoaded);
    // frmPre
    FrmPre.FrameMDK_Comments.AcRefreshExecute(nil);
    // frmPost
    FrmPost.FrameMDK_Comments.AcRefreshExecute(nil);
    // frmFlow
    FrmFlow.FrameMDK_Comments.AcRefreshExecute(nil);
    FrmFlow.SetGridAlign(TaCenter); // will aliggn fields and titles
    FrmFlow.CmbAutoRefresh.Text := IntToStr(Preferences.IValue(OnRefreshRate) * 60);
    if APatient.ReadOnly then FrmFlow.TmrRefresh.Enabled := False
    else begin
      FrmFlow.TmrRefresh.Enabled := True;
      FrmFlow.AcRefreshExecute(nil);
    end;
    // frmSummary
    FrmSummary.SetUp;
    FrmSummary.FrameMDK_Comments.AcRefreshExecute(nil);
    // frmSubmit
    FrmSubmit.EdSignature.Text := '';
    FrmSubmit.CleanTV;
    FrmSubmit.SetupAdditionalReports;
    FrmSubmit.AcSubmit.Enabled := not APatient.ReadOnly;
    // enable GUI
    FrmRxLab.Ignore := False;
    FrmPre.Ignore := False;
    FrmPost.Ignore := False;
    FrmSummary.Ignore := False;
    FrmWait.LayDown;
    AcSave.Enabled := not APatient.ReadOnly;
    RefreshSubmitStatusPanel;
  end;
  UpdateSB;
end;

procedure TfrmMain.AcPatientSelectExecute(Sender: TObject);
var
  SID, ErrorMsg: string;
  Cp: TMDKRegisteredPatient;
begin
  if not Assigned(Engine) then Exit;
  AcSave.Enabled := False;          // zzzzzzandria 2007-09-20
  AcPatientSelect.Enabled := False; // zzzzzzandria 2007-09-20
  SID := '';
  if Assigned(Engine.CurrentPatient) and (Engine.CurrentPatient.SessionID <> '') then begin
    if not Engine.CurrentPatient.ReadOnly then begin
      SID := Engine.CurrentPatient.SessionID;
      AcSaveExecute(nil);
      if FrmStudies.ReleaseStudy(SID, ErrorMsg) = RcStudyStatusOK then
          Engine.Report(RtInfo, 'Study <' + SID + '> Released', '', 0, '', 'Release Study')
      else begin
        Engine.Report(RtError, 'Study <' + SID + '> Release Failed', '', 0, '', 'Release Study');
        if MessageDlg('Can not release study "' + SID + '" ' + #13#10 + 'Error found: ' + #13#10 + ErrorMsg + #13#10 +
          #13#10 + 'NOTE:' + #13#10 + 'Study could be released later by an ADMIN user' + #13#10#13#10 +
          'Do you want to continue without RELEASE?', MtConfirmation, [MbYes, MbNo], 0) <> MrYes then begin
          AcPatientSelect.Enabled := True; // zzzzzzandria 2007-09-20
          Exit;
        end;
      end;
    end;
  end;
  RefreshStudyStatus(True);
  Mode := SmBlank;
  Engine.CurrentPatient.ReadOnly := True; // to avoid RELEASE by timeout
  // {$IFDEF STUDY_STATUS_LIST}
  // cp := SelectStudyFromList(Left, Top, Height, Width);
  // {$ELSE}
  Cp := SelectStudy(Left, Top, Height, Width { , False } );
  // {$ENDIF}
  SelectPatient(Cp);
  AcPatientSelect.Enabled := True;                   // zzzzzzandria 2007-09-20
  AcSave.Enabled := (Cp <> nil) and not Cp.ReadOnly; // zzzzzzandria 2008-03-31
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FileExitExecute(Sender: TObject);
begin
  Close;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.AdjustInfoPanelPosition(AStep: Integer);
begin
  if AStep > 0 then PnlPtInfo.BevelInner := BvLowered
  else PnlPtInfo.BevelInner := BvNone;
  LblPtName.Top := LblPtName.Top + AStep;
  LblPtName.Left := LblPtName.Left + AStep;
  LblPtDemographics.Top := LblPtDemographics.Top + AStep;
  LblPtDemographics.Left := LblPtDemographics.Left + AStep;
end;

procedure TfrmMain.PnlPtInfoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  AdjustInfoPanelPosition(1);
  PnlPtInfo.Invalidate;
end;

procedure TfrmMain.PnlPtInfoMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  AdjustInfoPanelPosition(-1);
  if Engine.CurrentPatient <> nil then AcShowPatientInfoExecute(nil);
end;
/// ////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(Engine) and (Engine.CurrentPatient <> nil) and (Trim(LblStudyNum.Caption) <> '') then begin
{$IFNDEF AANTEST}
    if True { Preferences.bValue(onAutosave) } then AcSaveExecute(nil)
    else if not Engine.CurrentPatient.ReadOnly and
      (MessageDlg('Autosave option is set to FALSE.' + #13#10 + 'No data will be saved on Exit.' + #13#10 + 'Exit now?',
      MtConfirmation, [MbYes, MbNo], 0) <> MrYes) then begin
      Action := CaNone;
      Exit;
    end;
{$ENDIF}
  end;
  ShutDownKitchen;
end;

procedure TfrmMain.ShutDown;
var
  I: Integer;
begin // Close all modal forms here
  for I := 0 to Screen.CustomFormCount - 1 do begin
    if Screen.CustomForms[I] = Self then Continue;
    if FsModal in Screen.CustomForms[I].FormState then begin
      Screen.CustomForms[I].ModalResult := MrCancel;
      Screen.CustomForms[I].Close;
    end;
  end;
  AcSaveExecute(nil);
  ShutDownKitchen('Shut Down by Timeout');
  Application.Terminate;
end;

procedure TfrmMain.RefreshCurrentWindow;
begin
  try
    if FCurrentForm = nil then Exit;
  except
    Exit;
  end;
  if FCurrentForm = FrmFlow then FrmFlow.SetActionStatus
  else if FCurrentForm = FrmSummary then FrmSummary.SetActionStatus
  else if FCurrentForm = FrmPre then FrmPre.SetActionStatus
  else if FCurrentForm = FrmPost then FrmPost.SetActionStatus
  else if FCurrentForm = FrmRxLab then FrmRxLab.SetActionStatus;
end;

procedure TfrmMain.SetUpForm(AForm: TForm; ATab: TWinControl);
begin
  if AForm.Parent <> ATab then begin
    AForm.BorderStyle := BsNone;
    AForm.Parent := ATab;
    AForm.Align := AlClient;
    AForm.Show;
  end;
end;

procedure TfrmMain.AcShowLogExecute(Sender: TObject);
begin
  if Mode <> SmLog then begin
{$IFDEF LOG_DIALOG}
    FrmLog.ShowModal;
{$ELSE}
    Mode := SmLog;
{$ENDIF}
    ResetOptions;
  end else if (Engine.CurrentPatient.ID <> '') and (LblStudyNum.Caption <> '') then begin
    ResetOptions;
    Mode := SmPatient;
  end
  else Mode := SmBlank;
end;

procedure TfrmMain.AcSaveExecute(Sender: TObject);
begin
  AcSave.Enabled := False;          // zzzzzzandria 2007-09-20
  AcPatientSelect.Enabled := False; // zzzzzzandria 2007-09-20
  FrmCover.SaveData;
  FrmRxLab.SaveData;
  FrmFlow.SaveData;
  FrmSummary.SaveData;
  Engine.SaveCurrentPatientData;
  FrmPost.FrameMDK_Comments.AcRefresh.Execute;
  FrmPre.FrameMDK_Comments.AcRefresh.Execute;
  FrmRxLab.FrameMDK_Comments.AcRefresh.Execute;
  FrmAccess.FrameMDK_Comments.AcRefresh.Execute;
  FrmFlow.FrameMDK_Comments.AcRefresh.Execute;
  FrmSummary.FrameMDK_Comments.AcRefresh.Execute;
  AcSave.Enabled := True;          // zzzzzzandria 2007-09-20
  AcPatientSelect.Enabled := True; // zzzzzzandria 2007-09-20
end;

procedure TfrmMain.AcShowPatientInfoExecute(Sender: TObject);
begin
  if Engine.CurrentPatient.ID <> '' then begin
    if not Assigned(FrmInfo) then Application.CreateForm(TfrmInfo, FrmInfo);
    FrmInfo.MmInfo.Text := Engine.GetPatientInfo;
    FrmInfo.ShowModal;
    FreeAndNil(FrmInfo);
  end
  else MessageDlg(MsgSelectPatientFirst, MtWarning, [MbOK], 0);
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) and (SsShift in Shift) then AcShowLogExecute(nil)
  else if (Key = Word(Char('V'))) and (SsShift in Shift) and (SsCtrl in Shift) then
      ShowStatusMessage(CurrentExeVersion + ' ' + CurrentComments)
end;

procedure TfrmMain.HelpAboutExecute(Sender: TObject);
begin
  if not Assigned(GMVAboutDlg) then Application.CreateForm(TfrmGMV_AboutDlg, GMVAboutDlg);
  GMVAboutDlg.Execute;
end;

procedure TfrmMain.AcHelpIndexExecute(Sender: TObject);
begin
  Application.HelpCommand(HELP_INDEX, 1001); // this is a patch
//  ShellExecute(Handle,'open','Hemodialysis.hlp',nil,nil, SW_SHOWNORMAL);
end;

procedure TfrmMain.AcWebPageExecute(Sender: TObject);
var
  S: string;
begin
  S := Preferences.SValue(OnWebPageURL);
  ShellExecute(0, nil, PChar(S), nil, nil, SW_NORMAL)
end;

procedure TfrmMain.PgcMainChange(Sender: TObject);
var
  SCommentsFilter: string;
begin
  case PgcMain.ActivePageIndex of
    0: FCurrentForm := FrmCover;
    1: FCurrentForm := FrmRxLab;
    2: FCurrentForm := FrmAccess;
    3: FCurrentForm := FrmPre;
    4: FCurrentForm := FrmFlow;
    5: FCurrentForm := FrmPost;
    6: FCurrentForm := FrmSummary;
    7: FCurrentForm := FrmSubmit;
  end;
  PgcMain.HelpContext := 1001 + PgcMain.ActivePageIndex;
  SCommentsFilter := GetNotesContextFilter(PgcMain.ActivePageIndex);
  SetCDSFilter(Engine.NoteList_CDS, SCommentsFilter);
  Engine.NoteList_CDS.Filtered := True;
  if Assigned(FMenu) then MmShell.Unmerge(FMenu);
  FrmSubmit.EdSignature.Text := '';
  if PgcMain.ActivePage = TsCover then begin
    FrmCover.ActivateTabForm;
    MiComments.Enabled := False;
    FMenu := FrmCover.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsRxLab then begin
    FrmRxLab.ActivateTabForm;
    FMenu := FrmRxLab.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsPreTreatment then begin
    FrmPre.ActivateTabForm;
    FMenu := FrmPre.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsAccess then begin
    FrmAccess.ActivateTabForm;
    FMenu := FrmAccess.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsFlowSheet then begin
    FrmFlow.ActivateTabForm;
    FMenu := FrmFlow.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsPostTreatment then begin
    FrmPost.ActivateTabForm;
    FMenu := FrmPost.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsSummary then begin
    FrmSummary.ActivateTabForm;
    FMenu := FrmSummary.GetMainMenu;
  end;
  if PgcMain.ActivePage = TsSubmit then
    try
      RefreshSubmitStatusPanel;
      FrmSubmit.ActivateTabForm;
      RefreshStudyStatus;
      FMenu := FrmSubmit.GetMainMenu;
      FrmSubmit.AcSubmit.Enabled := (Pos('Error', LblStudyStatus.Caption) > 0) and
        (Length(FrmSubmit.EdSignature.Text) > DevOptions.IValue(DonMinESigLength));
    except
    end;
  if Assigned(FMenu) then MmShell.Merge(FMenu)
  else MiComments.Enabled := False;
end;

procedure TfrmMain.TimerTimer(Sender: TObject);
begin
  Timer.Enabled := False;
  StatusBar.Panels[0].Text := '';
  Screen.Cursor := CrDefault;
end;

procedure TfrmMain.StatusBarMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if SsShift in Shift then AcShowLogExecute(nil);
  if SsCtrl in Shift then AcShowGatewayInfoExecute(nil);
end;

procedure TfrmMain.StatusBarDblClick(Sender: TObject);
begin
//{$IFDEF AANTEST}
  //PnlCommentsControl.Visible := not PnlCommentsControl.Visible;
//  if Assigned(FrmFlow) then FrmFlow.PnlExtras.Visible := not FrmFlow.PnlExtras.Visible;
//{$ELSE}
  AcShowLogExecute(nil);
//{$ENDIF}
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  Application.HelpFile := ExtractFilePath(Application.ExeName) + '\Hemodialysis.hlp';
end;

// updates the status screen of the cdsStatus dataset
procedure TfrmMain.RefreshSubmitStatusPanel;
begin
  PgcMain.Images := ImageList1;
  try
    FrmCover.ReportStatus;
    FrmSummary.ReportStatus;
    FrmAccess.ReportStatus;
    FrmPre.ReportStatus;
    FrmPost.ReportStatus;
    FrmFlow.ReportStatus;
    FrmRxLab.ReportStatus;
    FrmSubmit.ReportStatus;
  except
  end;
end;

procedure TfrmMain.GoToPage(APage: string);
begin
  if APage = PnCover then PgcMain.ActivePage := TsCover;
  if APage = PnAccess then PgcMain.ActivePage := TsAccess;
  if APage = PnPre then PgcMain.ActivePage := TsPreTreatment;
  if APage = PnRxLab then PgcMain.ActivePage := TsRxLab;
  if APage = PnFlow then PgcMain.ActivePage := TsFlowSheet;
  if APage = PnPost then PgcMain.ActivePage := TsPostTreatment;
  if APage = PnSummary then PgcMain.ActivePage := TsSummary;
end;

procedure TfrmMain.AcOptionsShowExecute(Sender: TObject);
begin
  AcShowLogExecute(nil);
end;

procedure TfrmMain.ResetOptions;
var
  ITimeout: Integer;
begin
  if not Assigned(Engine) then Exit;
  Screen.Cursor := CrHourGlass;
  ShowStatusMessage(' Reloading Options...');
  ResetPreferences(Engine.GetSystemOptionByName(OnSysOptions), Engine.GetUserOptionByName(OnUserOptions));
  Preferences.Overwrite(Engine.GetUserOptionByName(OnUserSettings));
  Administrators.Overwrite(Engine.GetSystemOptionByName(OnAdministrators));
  // zzzzzzandria 2012-06-14 ICD-10 Remediation v.1.0.29.10
  GsESRD_ICD9 := GetValues(OnESRD_Diagnosys);
  GsESRD_ICD10 := GetValues(OnESRD_ICD10);
{$IFDEF RPCLOG}
  AddEvent('ESRD ICD-10 list Update', GetDescribedItem('ESRD ICD10', GsESRD_ICD10));
  AddEvent('ESRD ICD-9  list Update', GetDescribedItem('ESRD ICD9', GsESRD_ICD9));
{$ENDIF}
  if RPCBroker <> nil then
    try
      ITimeout := StrToIntDef(Preferences.SValue(OnBrokerTimeout), 30);
      RPCBroker.RPCTimeLimit := ITimeout;
    except
      on E: Exception do ShowMessage(E.Message);
    end;
  DmData.UpdateFlowsheetIndex(Preferences.BValue(OnReverseFlowsheetOrder));
  AssignList(FrmRxLab.DbcbRxDialyser.Items, Engine.GetSystemOptionByName(OnDialyzerList));
  AssignList(FrmPost.DbcTransportation.Items, Engine.GetSystemOptionByName(OnTransType));
  AssignList(FrmPre.DbcTransportation.Items, Engine.GetSystemOptionByName(OnTransType));
  AssignList(FrmRxLab.DbcbAC_Type.Items, Engine.GetSystemOptionByName(OnAntiCoagulants));
  // frmCover.RefreshGUI; zzzzzzandria 2012-06-13 ICD-10 Remediation v.1.0.29.10
  AssignList(FrmPre.DbeEduKey.Items, Engine.GetSystemOptionByName(OnEducationCodes));
  FrmPre.SetUp;
  FrmPost.RefreshGUI;
  UpdateSB;
  Engine.MedList_CDS.FieldByName(FnML_Date).Visible := DevOptions.SValue(DonShowMedicineDate) = 'TRUE';
  Engine.FLowsheet_CDS.FieldByName(FnFS_Date).Visible := DevOptions.SValue(DonShowFlowsheetDate) = 'TRUE';
  // TDateTimeField(Engine.MedList_CDS.FieldByName(fnML_Time)).DisplayFormat := Preferences.sValue(onTimeFormat);
  // TDateTimeField(Engine.Flowsheet_CDS.FieldByName(fnFS_Time)).DisplayFormat := Preferences.sValue(onTimeFormat);
  // frmFlow.btnInvalidNote.Visible := Engine.CurrentOperatorMode = rnAdmin;
  FrmFlow.CmbAutoRefresh.Text := IntToStr(Preferences.IValue(OnRefreshRate) * 60);
  if FrmFlow.FLeftToRefresh > Preferences.IValue(OnRefreshRate) * 1000 * 60 then
      FrmFlow.FLeftToRefresh := Preferences.IValue(OnRefreshRate) * 1000 * 60;
  TmGateway.Interval := DevOptions.IValue(DonGatewayRequestTimeout) * 1000;
  ITimeout := StrToIntDef(Engine.UserTimeout, 1000);
{$IFNDEF AANTEST}
  if ITimeout > MAXIMUM_TIMEOUT_SEC then ITimeout := MAXIMUM_TIMEOUT_SEC;
  if ITimeout < MINIMUM_TIMEOUT_SEC then ITimeout := MINIMUM_TIMEOUT_SEC;
{$ENDIF}
  UpdateTimeOutInterval(ITimeout);
  FrmSummary.SetUp;
  FrmSubmit.SetUp;
  if Assigned(FrmListEdit) then FrmListEdit.SetQuantityLimit(DevOptions.IValue(DonMaxProcedureQuantity));
  ShowStatusMessage(' Options Reloaded');
  AcShowStatusPanel.Checked := Preferences.BValue(OnShowStatusPanel);
  AcSetPending.Enabled := Preferences.BValue(OnAllowUserResetStudyStatus) and
    (Pos('Error', LblStudyStatus.Caption) > 0);
  N6.Enabled := Preferences.BValue(OnAllowUserResetStudyStatus);
  if Mode <> SmBlank then SetBackGroundColor(Engine.CurrentPatient.ReadOnly)
  else SetBackGroundColor(False);
  case PgcMain.ActivePageIndex of
    0: begin
         FrmCover.ReportStatus;
         FrmCover.RefreshGUI;
       end;
    1: FrmRxLab.ReportStatus;
    2: FrmPre.ReportStatus;
    3: FrmAccess.UpdateGUI;
    4: FrmFlow.ReportStatus;
    5: FrmPost.ReportStatus;
    6: FrmSummary.ReportStatus;
  end;
  Screen.Cursor := CrDefault;
end;

procedure TfrmMain.AcReloadOptionsExecute(Sender: TObject);
begin
  ResetOptions;
end;

procedure TfrmMain.PgcMainChanging(Sender: TObject; var AllowChange: Boolean);
var
  S: string;
  Ts: TTabSheet;
begin
  Ts := nil;
  if Sender is TPageControl then Ts := (Sender as TPageControl).ActivePage;
  if not Assigned(Ts) then Exit;
  if Ts = TsCover then begin
    FrmCover.ReportStatus;
    if Engine.CurrentPatient.ReadOnly then Exit;
    if not FrmCover.CanDeactivate(S) then begin
      S := 'Form is not completed:' + #13#10 + #13#10 + S;
      case MessageDlg(S + #13#10 + 'Exit this tab?', MtConfirmation, [MbYes, MbNo], 0) of
        MrYes: AllowChange := True;
        MrNo: AllowChange := False;
      end;
    end;
  end else begin
    AllowChange := True;
    if (Ts = TsAccess) then FrmAccess.ReportStatus
    else if (Ts = TsPreTreatment) then FrmPre.ReportStatus
    else if (Ts = TsPostTreatment) then FrmPost.ReportStatus
    else if (Ts = TsSummary) then FrmSummary.ReportStatus
    else if (Ts = TsRxLab) then FrmRxLab.ReportStatus
    else if (Ts = TsFlowSheet) then FrmFlow.ReportStatus;
  end;
end;

procedure TfrmMain.TmGatewayTimer(Sender: TObject);
var
  S: string;
begin
  try // zzzzzzandria 2007-08-06 build 312 update #31
    S := Engine.FRenalController.GetGatewayRunningStatus + '    ';
  except
    S := 'Unknown    ';
  end;
  StatusBar.Panels[SbIndex_GatewayStatus].Text := ' CP Gateway: ' + S;
  UpdateSB;
end;

procedure TfrmMain.AcShowGatewayInfoExecute(Sender: TObject);
begin
  TmGatewayTimer(nil);
  MessageDlg(Engine.GetGatewayInfo, MtInformation, [MbOK], 0);
end;

procedure TfrmMain.AcSaveVitalsExecute(Sender: TObject);
begin
  try
    Engine.SubmitVitalsData;
  except
  end;
end;

procedure TfrmMain.AcSaveFlowsheetExecute(Sender: TObject);
begin
  try
    Engine.SubmitFlowsheet;
  except
  end;
end;

procedure TfrmMain.AcUserManualExecute(Sender: TObject);
var
  S: string;
begin
  S := DevOptions.SValue(DonWebUserManualURL);
  ShellExecute(0, nil, PChar(S), nil, nil, SW_NORMAL)
end;

procedure TfrmMain.RefreshStudyStatus;
var
  S: string;
  Cc: TColor;
begin
  Cc := ClWindowText;
  LblStudyNum.Font.Color := Cc;
  LblLocationID.Font.Color := Cc;
  LblStudyDate.Font.Color := Cc;
  AcSetPending.Enabled := False;
  if AcClear then begin
    LblStudyNum.Caption := '';
    StatusBar.Panels[SbIndex_StudyID].Text := '';
    LblStudyStatus.Caption := '';
    LblLocationID.Caption := '';
    LblStudyDate.Caption := '';
    LblAppointmentInfo.Caption := '';
    LblPtName.Caption := '';
    LblPtDemographics.Caption := '  No Patient Selected';
    PnlToolBar.Color := ClSilver;
  end else begin
    LblLocationID.Caption := Engine.LocationName;
    LblStudyNum.Caption := Engine.CurrentPatient.SessionID;
    StatusBar.Panels[SbIndex_StudyID].Text := ' ' + Engine.CurrentPatient.SessionID;
    S := Engine.GetStudyStatus(Engine.CurrentPatient.SessionID);
    if Trim(S) <> '' then S := Trim(S) + '.'
    else S := 'Unknown. ';
    LblStudyStatus.Caption := S;
    if Pos('Error', LblStudyStatus.Caption) > 0 then LblStudyStatus.Font.Color := ClRed
    else LblStudyStatus.Font.Color := Cc;
    AcSetPending.Enabled := Preferences.BValue(OnAllowUserResetStudyStatus) and
      (Pos('Error', LblStudyStatus.Caption) > 0);
    LblAppointmentInfo.Caption := Piece(Engine.GetAppointmentInfo, '^', 2);
    if Pos('have met', LblAppointmentInfo.Caption) > 0 then LblAppointmentInfo.Font.Color := Cc
    else LblAppointmentInfo.Font.Color := ClRed;
    LblAppointmentInfo.Left := LblStudyStatus.Left + LblStudyStatus.Width + 6;
    LblPtName.Caption := Uppercase(Engine.CurrentPatient.Name);
    LblPtDemographics.Caption := Engine.CurrentPatient.Description + Engine.VendorPtID;
    LblStudyDate.Caption := Piece(Engine.StudyDate, ' ', 1);
  end;
  Invalidate; // zzzzzzandria 061006
end;

procedure TfrmMain.AcShowStatusPanelExecute(Sender: TObject);
begin
  if UserOptions.BValue(OnShowStatusPanel) then UserOptions.SetValue(OnShowStatusPanel, 'FALSE')
  else UserOptions.SetValue(OnShowStatusPanel, 'TRUE');
  AcShowStatusPanel.Checked := UserOptions.BValue(OnShowStatusPanel);
  Engine.SetUserOptionByName(OnUserOptions, UserOptions.ValueList.Text);
  Preferences.Overwrite(UserOptions.ValueList.Text);
  FrmSubmit.SetUp;
  RefreshSubmitStatusPanel;
end;

procedure TfrmMain.PgcMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  I, ICount: Integer;
const
  IDuck = 4;
begin
  if (SsCtrl in Shift) and (Button = MbRight) then begin
    ICount := 0;
    for I := 0 to PgcMain.PageCount - 2 do
      if PgcMain.Pages[I].ImageIndex < 2 then Inc(ICount);
    if ICount = PgcMain.PageCount - 1 then
      for I := 1 to PgcMain.PageCount - 2 do PgcMain.Pages[I].ImageIndex := IDuck;
  end;
end;

procedure TfrmMain.ShowStatusMessage(AString: string);
begin
  StatusBar.Panels[0].Text := AString;
  Application.ProcessMessages;
  Timer.Enabled := True;
end;

procedure TfrmMain.AcShowGUIExecute(Sender: TObject);
begin
  Mode := SmPatient;
end;

procedure TfrmMain.AcSaveRPCResultsExecute(Sender: TObject);
begin
{$IFDEF AANTEST}
  SaveRPCResults := not SaveRPCResults;
  AcSaveRPCResults.Checked := SaveRPCResults;
{$ELSE}
  SaveRPCResults := False;
{$ENDIF}
end;

procedure TfrmMain.AcSetPendingExecute(Sender: TObject);
begin
  if not Assigned(Engine) then Exit;
  Engine.SetStudyStatusPending(Engine.CurrentPatient.SessionID);
  RefreshStudyStatus;
  try
    FrmSubmit.SetSubmitStatus(LblStudyStatus.Caption);
  except
  end;
end;

procedure TfrmMain.StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
begin
  with StatusBar.Canvas do begin
    FillRect(Rect);
    if (Pos(': Up', Panel.Text) = 0) then Font.Color := ClRed
    else Font.Color := ClWindowText;
    TextOut(Rect.Left + 2, Rect.Top + 2, Panel.Text);
  end;
end;

procedure TfrmMain.AppException(Sender: TObject; E: Exception);
begin
  // Application.ShowException(E);
  // Application.Terminate;
end;

procedure TfrmMain.ShowOldStyleComments1Click(Sender: TObject);
begin
  ShowOldStyleComments1.Checked := not ShowOldStyleComments1.Checked;
  FrmRxLab.PnlRxNotes.Visible := ShowOldStyleComments1.Checked;
  FrmRxLab.SpbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;
  FrmPre.PnlPreNotes.Visible := ShowOldStyleComments1.Checked;
  FrmPre.SpbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;
  FrmPost.PnlPostNotes.Visible := ShowOldStyleComments1.Checked;
  FrmPost.SpbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;
  FrmAccess.PnlCommentsFix.Visible := ShowOldStyleComments1.Checked;
  FrmSummary.GbOverallComments.Visible := ShowOldStyleComments1.Checked;
  FrmSummary.SpbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;
end;

procedure TfrmMain.AcRPCLogExecute(Sender: TObject);
begin
{$IFDEF RPCLOG}
  ShowEventLog(False);
{$ENDIF}
end;

procedure TfrmMain.AcGatewayWatchExecute(Sender: TObject);
begin
  AcGatewayWatch.Checked := not AcGatewayWatch.Checked;
  TmGateway.Enabled := AcGatewayWatch.Checked;
end;

end.
