unit fMDK_OptionName;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     options name input form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_OptionName.pas $
  *
  * $History: fMDK_OptionName.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:15p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TdlgOption = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    EdName: TEdit;
    Label2: TLabel;
    EdValue: TEdit;
    procedure EdNameKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdValueKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdNameChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DlgOption: TdlgOption;

function EditOption(AName, AValue: string): Integer;

implementation

{$R *.dfm}

function EditOption(AName, AValue: string): Integer;
begin
  if not Assigned(DlgOption) then Application.CreateForm(TdlgOption, DlgOption);
  DlgOption.EdName.Text := AName;
  DlgOption.EdValue.Text := AValue;
  DlgOption.ActiveControl := DlgOption.EdName;
  DlgOption.EdName.SelectAll;
  Result := DlgOption.ShowModal;
end;

procedure TdlgOption.EdNameKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = Vk_RETURN then EdValue.SetFocus;
end;

procedure TdlgOption.EdValueKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = Vk_RETURN) and OKBtn.Enabled then ModalResult := MrOK;
end;

procedure TdlgOption.EdNameChange(Sender: TObject);
begin
  OKBtn.Enabled := (EdName.Text <> '') and (EdValue.Text <> '');
end;

end.
