unit fMDK_Report;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 12/06/07 9:24a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Report definition form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_Report.pas $
  *
  * $History: fMDK_Report.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 3/28/07    Time: 3:32p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 10/25/06   Time: 11:03a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 7/12/06    Time: 9:41a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:15p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ActnList, Buttons, StdCtrls, ComCtrls, Grids, DBGrids,
  ImgList, AppEvnts, DbClient, System.Actions;

type
  TfrmMDK_Report = class(TForm)
    Panel1: TPanel;
    ActionList1: TActionList;
    AcTemplateLoad: TAction;
    AcTemplateSave: TAction;
    AcTemplateProcess: TAction;
    AcTemplateSend: TAction;
    AcReportPrint: TAction;
    AcReportSave: TAction;
    AcReportSend: TAction;
    AcVerifySyntax: TAction;
    AcReportNew: TAction;
    PcMain: TPageControl;
    TsReport: TTabSheet;
    TsTemplate: TTabSheet;
    Panel5: TPanel;
    Panel4: TPanel;
    Panel7: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton5: TSpeedButton;
    MmResult: TMemo;
    Panel3: TPanel;
    ReTemplate: TRichEdit;
    PnlKeywords: TPanel;
    Panel8: TPanel;
    CmbFilter: TComboBox;
    DbgKeywords: TDBGrid;
    DlgOpen: TOpenDialog;
    ImageList1: TImageList;
    BitBtn1: TBitBtn;
    CbAutoProcess: TCheckBox;
    Spl: TSplitter;
    LbKeywords: TListBox;
    Splitter1: TSplitter;
    DlgSave: TSaveDialog;
    Panel2: TPanel;
    Panel6: TPanel;
    BitBtn5: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn6: TBitBtn;
    CkbKeywords: TCheckBox;
    procedure AcTemplateProcessExecute(Sender: TObject);
    procedure AcTemplateSaveExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CkbKeywordsClick(Sender: TObject);
    procedure AcVerifySyntaxExecute(Sender: TObject);
    procedure PcMainChange(Sender: TObject);
    procedure AcTemplateLoadExecute(Sender: TObject);
    procedure DbgKeywordsDblClick(Sender: TObject);
    procedure LbKeywordsDblClick(Sender: TObject);
    procedure AcReportSaveExecute(Sender: TObject);
  private
    FReportName: string;
    procedure Process;
    procedure PaintSyntax;
    procedure SetUp(AName: string);
  public
    property ReportName: string read FReportName write SetUp;
  end;

var
  FrmMDK_Report: TfrmMDK_Report;

implementation

uses
  UMDK_Engine, DMDK_Data, UMDK_Common, UMDK_ReportEngine, UMDK_Dictionary;

{$R *.dfm}

procedure TfrmMDK_Report.AcTemplateProcessExecute(Sender: TObject);
begin
  Process;
  if PcMain.ActivePage <> TsReport then PcMain.ActivePage := TsReport;
end;

procedure TfrmMDK_Report.Process;
begin
  MmResult.Lines.Text := Engine.GetReportValue(ReTemplate.Lines.Text);
end;

procedure TfrmMDK_Report.PaintSyntax;
begin
  UMDK_ReportEngine.PaintSyntax(ReTemplate);
end;

procedure TfrmMDK_Report.SetUp(AName: string);
var
  S: string;
begin
  FReportName := AName;
  try
    S := Engine.GetSystemOptionByName(AName);
    if Pos('-1', S) <> 1 then ReTemplate.Lines.Text := S
    else ReTemplate.Lines.Text := '';
    MmResult.Clear;
    PaintSyntax;
  except
  end;
end;

procedure TfrmMDK_Report.AcTemplateSaveExecute(Sender: TObject);
begin
  Engine.SetSystemOptionByName(FReportName, ReTemplate.Lines.Text);
end;

procedure TfrmMDK_Report.FormCreate(Sender: TObject);
begin
  try
    DbgKeywords.Columns[0].FieldName := FnDict_Tag;
    DbgKeywords.Columns[1].FieldName := FnDict_Comments;
  except
  end;
end;

procedure TfrmMDK_Report.CkbKeywordsClick(Sender: TObject);
begin
  if PnlKeywords.Visible then Spl.Align := AlLeft;
  PnlKeywords.Visible := CkbKeywords.Checked;
  if PnlKeywords.Visible then Spl.Align := AlRight;
end;

procedure TfrmMDK_Report.AcVerifySyntaxExecute(Sender: TObject);
begin
  PaintSyntax;
end;

procedure TfrmMDK_Report.PcMainChange(Sender: TObject);
begin
  case PcMain.ActivePageIndex of
    0: if CbAutoprocess.Checked and Assigned(Engine.CurrentPatient) then AcTemplateProcess.Execute;
    1: PaintSyntax;
  end;
end;

procedure TfrmMDK_Report.AcTemplateLoadExecute(Sender: TObject);
var
  S: string;
begin
  S := DlgOpen.Title;
  DlgOpen.Title := 'Load Report Template';
  if DlgOpen.Execute then ReTemplate.Lines.LoadFromFile(DlgOpen.FileName);
  DlgOpen.Title := S;
end;

procedure TfrmMDK_Report.DbgKeywordsDblClick(Sender: TObject);
var
  Dbe: TCustomMemo;
  S: string;
  procedure CopyKeyword;
  begin
    S := TClientDataSet(DbgKeyWords.DataSource.DataSet).FieldByName(FnDict_Tag).AsString;
    S := '<' + S + '>';
    if (S = '<>') then Exit;
    Dbe.SelText := S;
  end;

begin
  Dbe := TCustomMemo(ReTemplate);
  CopyKeyword;
end;

procedure TfrmMDK_Report.LbKeywordsDblClick(Sender: TObject);
var
  Dbe: TCustomMemo;
  S: string;
  procedure CopyKeyword;
  begin
    S := LbKeywords.Items[LbKeywords.ItemIndex];
    S := '<' + S + '>';
    if (S = '<>') then Exit;
    Dbe.SelText := S;
  end;

begin
  Dbe := TCustomMemo(ReTemplate);
  try
    CopyKeyword;
  except
  end;
end;

procedure TfrmMDK_Report.AcReportSaveExecute(Sender: TObject);
begin
  if DlgSave.Execute then ReTemplate.Lines.SaveToFile(DlgSave.FileName);
end;

end.
