unit fMDK_SelectProvider;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Provider selection form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_SelectProvider.pas $
  *
  * $History: fMDK_SelectProvider.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
}
interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  ODBController_Renal, Buttons, ExtCtrls;

type
  TdlgSelectProvider = class(TForm)
    Panel3: TPanel;
    BbSelect: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    PnlTarget: TPanel;
    LblTitle: TLabel;
    EdTarget: TComboBox;
    Panel4: TPanel;
    Label2: TLabel;
    LbProviders: TListBox;
    BitBtn5: TBitBtn;
    PnlOptions: TPanel;
    Label1: TLabel;
    CkbVistA: TRadioButton;
    RadioButton2: TRadioButton;
    Bevel1: TBevel;
    procedure EdTargetKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BbSelectClick(Sender: TObject);
    procedure LbProvidersKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure LbProvidersDblClick(Sender: TObject);
    procedure EdTargetEnter(Sender: TObject);
    procedure EdTargetExit(Sender: TObject);
    procedure EdTargetKeyPress(Sender: TObject; var Key: Char);
    procedure CkbVistAClick(Sender: TObject);
  private
    FDBC: TDBController_Renal;
    FID: TStringList;
    FRequestType: Integer;
    function SetSelection: Boolean;
  public
    ProviderName, ProviderID: string;
    property DBC: TDBController_Renal read FDBC write FDBC;
    procedure CleanUp;
    procedure DoSearch;
  end;

var
  DlgSelectProvider: TdlgSelectProvider;

function SelectProvider(ATarget: string; AController: TDBController_Renal; RequestType: Integer = 0): string;

implementation

uses
  UROR_CommonUtils, UMDK_Common, Dialogs;

var
  SHistory0, SHistory1, SHistory2, SHistory3, SHistory4: string;

{$R *.dfm}

function SelectProvider(ATarget: string; AController: TDBController_Renal; RequestType: Integer = 0): string;
begin
  if not Assigned(DlgSelectProvider) then Application.CreateForm(TdlgSelectProvider, DlgSelectProvider);
  with DlgSelectProvider do begin
    EdTarget.Enabled := True;
    PnlOptions.Visible := False;
    FRequestType := RequestType;
    case FRequestType of
      0: begin
          EdTarget.Items.Text := SHistory0;
          Caption := 'Select Provider';
          LblTitle.Caption := '&Enter first characters of the name and press "Return":'
        end;
      1: begin
          EdTarget.Items.Text := SHistory1;
          Caption := 'Select Facility';
          LblTitle.Caption := '&Enter first characters of the facility and press "Return":'
        end;
      2: begin
          EdTarget.Items.Text := SHistory2;
          Caption := 'Select Administrator';
          LblTitle.Caption := '&Enter first characters of the administrator name and press "Return":'
        end;
      3: begin
          EdTarget.Items.Text := SHistory3;
          Caption := 'Select Application User';
          LblTitle.Caption := '&Enter first characters of the application user name and press "Return":'
        end;
      4: begin
          EdTarget.Items.Text := SHistory4;
          Caption := 'Select TIU Title of the CP Class Document';
          LblTitle.Caption := '&Enter first characters of the TIU Note Title and press "Return":'
        end;
      5: begin
          PnlTarget.Align := AlBottom;
          PnlOptions.Visible := True;
          PnlTarget.Align := AlTop;
          EdTarget.Items.Text := SHistory0;
          Caption := 'Select Provider';
          LblTitle.Caption := '&Enter first characters of the name and press "Return":';
        end;
    end;
    CleanUp;
    if FRequestType = 5 then CkbVistAClick(nil);
    if EdTarget.Enabled then ActiveControl := EdTarget;
    EdTarget.Text := ATarget;
    DBC := AController;
    if ATarget <> '' then DoSearch;
    if ShowModal = MrOK then Result := ProviderName + '^' + ProviderID
    else Result := '';
    case FRequestType of
      0, 5: begin
          SHistory0 := EdTarget.Items.Text;
        end;
      1: SHistory1 := EdTarget.Items.Text;
      2: SHistory2 := EdTarget.Items.Text;
      3: SHistory3 := EdTarget.Items.Text;
      4: SHistory4 := EdTarget.Items.Text;
    end;
  end;
end;

procedure TdlgSelectProvider.EdTargetKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_Return) and (EdTarget.Text <> '') then DoSearch;
end;

procedure TdlgSelectProvider.DoSearch;
var
  I: Integer;
  SL: TStringList;
  S: string;
begin
  SL := TStringList.Create;
  case FRequestType of
    0, 5: FDBC.LookupProvider(EdTarget.Text, S);
    1: FDBC.LookupFacility(EdTarget.Text, S);
    2, 3: FDBC.LookupAdministrator(EdTarget.Text, S);
    4: S := FDBC.GetCPTIUTitles(EdTarget.Text);
  end;
  SL.Text := S;
  if SL.Count > 1 then begin
    SL.Delete(0);
    FID.Clear;
    for I := 0 to SL.Count - 1 do begin
      FID.Add(Piece(SL[I], '^', 1));
      SL[I] := Piece(SL[I], '^', 2);
    end;
    if EdTarget.Items.IndexOf(EdTarget.Text) < 0 then EdTarget.Items.Add(EdTarget.Text);
  end
  else SL.Text := Piece(S, '^', 2);
  LbProviders.Items.Text := SL.Text;
  if Pos('No mat', SL.Text) <> 1 then ACtiveControl := LbProviders
  else begin
    EdTarget.SelStart := Length(EdTarget.Text) - 1;
    EdTarget.SelLength := 1;
  end;
  SL.Free;
end;

procedure TdlgSelectProvider.FormCreate(Sender: TObject);
begin
  FID := TStringList.Create;
end;

procedure TdlgSelectProvider.FormDestroy(Sender: TObject);
begin
  FID.Free;
end;

procedure TdlgSelectProvider.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Escape then ModalResult := MrCancel;
end;

procedure TdlgSelectProvider.BbSelectClick(Sender: TObject);
begin
  if SetSelection then ModalResult := MrOK;
end;

procedure TdlgSelectProvider.LbProvidersKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Return then begin
    if SetSelection then ModalResult := MrOK;
  end;
end;

function TdlgSelectProvider.SetSelection: Boolean;
var
  S: string;
begin
  if LbProviders.ItemIndex < 0 then LbProviders.ItemIndex := 0;
  Result := False;
  try
    ProviderName := LbProviders.Items[LbProviders.ItemIndex];
    if ProviderName = '- Other -' then begin
      S := InputBox(Caption, 'Name', '');
      if S <> '' then begin
        ProviderName := S;
        ProviderID := S;
        Result := True;
      end;
    end else begin
      ProviderID := FID[LbProviders.ItemIndex];
      Result := True;
    end;
  except
  end;
end;

procedure TdlgSelectProvider.LbProvidersDblClick(Sender: TObject);
begin
  if SetSelection then ModalResult := MrOK;
end;

procedure TdlgSelectProvider.CleanUp;
begin
  FID.Clear;
  LbProviders.Items.Clear;
  BbSelect.Enabled := False;
  ProviderID := '';
  ProviderName := '';
end;

procedure TdlgSelectProvider.EdTargetEnter(Sender: TObject);
begin
  BbSelect.Enabled := False;
end;

procedure TdlgSelectProvider.EdTargetExit(Sender: TObject);
begin
  BbSelect.Enabled := LbProviders.Items.Text <> '';
end;

procedure TdlgSelectProvider.EdTargetKeyPress(Sender: TObject; var Key: Char);
begin
  Key := Upcase(Key);
end;

procedure TdlgSelectProvider.CkbVistAClick(Sender: TObject);
var
  Sl: TStringList;
  I: Integer;
  S: string;
begin
  EdTarget.Enabled := CkbVista.Checked;
  LbProviders.Items.Clear;
  FID.Clear;
  if not CkbVistA.Checked then begin
    FDBC.GetSystemOption(OnNephrologiests, S);
    Sl := TStringList.Create;
    Sl.Text := S;
    LbProviders.Items.Add('- Other -');
    for I := 0 to Sl.Count - 1 do begin
      LbProviders.Items.Add(Sl.Values[Sl.Names[I]]);
      FID.Add(Sl.Names[I]);
    end;
    Sl.Free;
  end;
end;

initialization

SHistory0 := '';
SHistory1 := '';
SHistory2 := '';
SHistory3 := '';
SHistory4 := '';

end.
