unit fMDK_Studies;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, ExtCtrls, ComCtrls, Buttons, UMDK_Patients, ActnList, ImgList, Menus, DB, DBClient,
  DBCtrls, UMDK_Options, UMDK_Common, System.Actions;

type
  TfrmStudies = class(TForm)
    PnlMain: TPanel;
    ActionList1: TActionList;
    AcGetActiveStudies: TAction;
    IlStatus: TImageList;
    AcUpdateTableByActiveStudyList: TAction;
    AcDisable: TAction;
    AcEnable: TAction;
    AcReview: TAction;
    AcRefresh: TAction;
    AcSelect: TAction;
    TmrRefresh: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Refresh2: TMenuItem;
    Select2: TMenuItem;
    Review1: TMenuItem;
    Enable2: TMenuItem;
    Disable2: TMenuItem;
    Options1: TMenuItem;
    ShowDetails1: TMenuItem;
    N2: TMenuItem;
    AcAutorefresh: TAction;
    AcShowLegend: TAction;
    ShowLegend1: TMenuItem;
    AcShowDetails: TAction;
    N1: TMenuItem;
    ShowHideDetails1: TMenuItem;
    Cancel1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Refresh1: TMenuItem;
    Select1: TMenuItem;
    Review2: TMenuItem;
    Enable1: TMenuItem;
    Disable1: TMenuItem;
    N4: TMenuItem;
    Autorefresh2: TMenuItem;
    ShowLegend3: TMenuItem;
    ShowHideDetails3: TMenuItem;
    Cancel2: TMenuItem;
    AcShowDisabledStudies: TAction;
    N3: TMenuItem;
    ShowDisabledStudies1: TMenuItem;
    CdsStudyList: TClientDataSet;
    DsStudyList: TDataSource;
    AcGetTableXML: TAction;
    AcSaveTableXML: TAction;
    N6: TMenuItem;
    ShowDisabledStudies2: TMenuItem;
    AcClearAccessHistory: TAction;
    AcLinkTables: TAction;
    AcLockHistoryTable: TAction;
    AcUnLockHistoryTable: TAction;
    AcShowLog: TAction;
    PnlCancel: TPanel;
    PnlActiveStudyList: TPanel;
    GrbActiveStudyList: TGroupBox;
    PnlStudyList: TPanel;
    PnlLegendz: TPanel;
    Image2: TImage;
    Image4: TImage;
    Label3: TLabel;
    Label6: TLabel;
    Image1: TImage;
    Label4: TLabel;
    LblReviewed: TLabel;
    ImReviewed: TImage;
    PnlStatusTable: TPanel;
    DbgStatus: TDBGrid;
    PnlDetails: TPanel;
    Re: TRichEdit;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel18: TPanel;
    AcOpenStudyList: TAction;
    LblAutorefresh: TLabel;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton17: TSpeedButton;
    AcClose: TAction;
    PnlLegend: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DbgStatusDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure AcRefreshExecute(Sender: TObject);
    procedure AcReviewExecute(Sender: TObject);
    procedure DbgStatusTitleClick(Column: TColumn);
    procedure TmrRefreshTimer(Sender: TObject);
    procedure AcAutorefreshExecute(Sender: TObject);
    procedure AcShowLegendExecute(Sender: TObject);
    procedure AcShowDetailsExecute(Sender: TObject);
    procedure DbgStatusDblClick(Sender: TObject);
    procedure DbgStatusKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AcShowDisabledStudiesExecute(Sender: TObject);
    procedure DsStudyListDataChange(Sender: TObject; Field: TField);
    procedure AcDisableExecute(Sender: TObject);
    procedure AcEnableExecute(Sender: TObject);
    procedure AcSelectExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PnlActiveStudyListResize(Sender: TObject);
    procedure AcCloseExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    FAutorefresh: Boolean;
    FIgnore: Boolean;
    FRefreshRate: Integer;
    FCount: Integer;
    FIgnoreTimer: Boolean;
    FIgnoreCDSChange: Boolean;
    FSelectedFieldName: string;
    FHistorySelectedFieldName: string;
    FActiveStudyList: TStringList;
    FSelectedPatient: TMDKRegisteredPatient;
    procedure FreeActiveStudyList;
    procedure AddActiveStudy(ARP: TMDKRegisteredPatient);
    function LocateStudyByID(AnID: string): Boolean;
    function SetStudyStatus(AStatus: string; out ErrorMsg: string): Integer;
    procedure SelectPatient(AReadOnly: Boolean);
    procedure ResetRefreshRate;
    procedure SetDisabledFilter;
    procedure CreateStudyListCDS;
    function AccessRegistered(APatientID: string): Boolean;
    procedure SaveBooleanOption(AName: string; AValue: Boolean; AType: string = OtUser);
    procedure SetActionsActiveStatus(AValue: Boolean);
    function GetSelectedPatient: TMDKRegisteredPatient;
    function SetUseStatus(NewStatus: string; RequiredStatuses: array of string; const StOK: Integer;
      var ErrorMsg: string; AccessRegistrationNeeded: Boolean = False; KeepLock: Boolean = False): Integer;
    procedure UpdateActionStatuses;
    procedure UpdateStudyDetails;
  public
    property SelectedStudy: TMDKRegisteredPatient read GetSelectedPatient;
    function GetStudyStatus(AnID: string): string;
    function ReleaseStudy(AnID: string; var MsgError: string): Integer;
  end;

var
  FrmStudies: TfrmStudies;

const
  RcStudyList                           = 1000;
  RcStudyNotFound                       = RcStudyList + 1;
  RcStudyStatusOK                       = RcStudyList + 10;
  RcStudyStatusLockFailed               = RcStudyList + 12;
  RcStudyStatusChanged                  = RcStudyList + 13;
  RcStudyStatusWrong                    = RcStudyList + 14;
  RcStudyStatusUnLockFailed             = RcStudyList + 15;
  RcStudyStatusAccessRegistrationFailed = RcStudyList + 16;
  RcStudyStatusChangeFailed             = RcStudyList + 17;
  RcTableUpdateFailed                   = RcStudyList + 18;

function SelectStudy(ALeft, ATop, AHeight, AWidth: Integer; Refresh: Boolean = True): TMDKRegisteredPatient;
procedure InitStudyList;

implementation

uses
  DMDK_Data, UMDK_Engine, UMDK_Utils, UMDK_CDSCommon, System.UITypes,
  ODBController_Renal, UROR_CommonUtils, FMDK_Wait, FMDK_Info;

const
  SnInUse     = 'IN USE';
  SnEnable    = 'ENABLED';
  SnDisable   = 'DISABLED';
  IsEnabled   = 0;
  IsDisabled  = 1;
  IsInUse     = 2;
  IsUnknown   = 3;
  IsSensitive = 5;
  IsSortGray  = 8;
  ClInUse     = $00FFFDE6;
  ClEnabled   = ClWindow;
  ClDisabled  = $00E8E8E8;
  ClUnknown   = ClLime;

{$R *.dfm}

procedure InitStudyList;
begin
  if not Assigned(FrmStudies) then begin
    Application.CreateForm(TfrmStudies, FrmStudies);
    FrmStudies.TmrRefresh.Enabled := False;
    FrmStudies.FSelectedFieldName := FnSL_StudyID;
    FrmStudies.FHistorySelectedFieldName := FnSL_StudyID;
  end;
end;

function SelectStudy(ALeft, ATop, AHeight, AWidth: Integer; Refresh: Boolean = True): TMDKRegisteredPatient;
begin
  Screen.Cursor := CrHourGlass;
  InitStudyList;
  FrmStudies.Left := ALeft;
  FrmStudies.Top := ATop;
  FrmStudies.Height := AHeight;
  FrmStudies.Width := AWidth;
  FrmWait.WakeUp(nil, 'Refreshing Study List');
  if Refresh then FrmStudies.AcRefresh.Execute;
  Screen.Cursor := CrDefault;
  FrmWait.LayDown;
  if FrmStudies.ShowModal = MrOK then Result := FrmStudies.SelectedStudy
  else Result := nil;
end;
/// /////////////////////////////////////////////////////////////////////////////
/// /////////////////////////////////////////////////////////////////////////////
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.FormCreate(Sender: TObject);
begin
  inherited;
  FIgnoreCDSChange := True;
  CreateStudyListCDS;
  FActiveStudyList := TStringList.Create;
  FSelectedPatient := TMDKRegisteredPatient.Create('', '', '', Now, '', '', '', '', '', '');
  FIgnoreCDSChange := False;
end;

procedure TfrmStudies.FormDestroy(Sender: TObject);
begin
  FreeActiveStudyList;
  if Assigned(FSelectedPatient) then FreeAndNil(FSelectedPatient);
  inherited;
end;

procedure TfrmStudies.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  TmrRefresh.Enabled := False;
end;

procedure TfrmStudies.CreateStudyListCDS;
  procedure CreateSL(ADS: TClientDataSet);
  begin
    if not FileExists(ADS.FileName) then begin
      NewStringField(ADS, FnSL_StudyID, 'Study #', 10, 40);
      NewStringField(ADS, FnSL_PatientID, 'Patient ID', 8, 22);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      NewBooleanField(ADS, FnSL_Sensitive, FnSL_Sensitive, 8);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      NewStringField(ADS, FnSL_Name, 'Patient Name', 30, 40);
      NewStringField(ADS, FnSL_Sex, 'Sex', 4, 4);
      NewDateTimeField(ADS, FnSL_DOB, 'DOB', 11);
      NewStringField(ADS, FnSL_SSN, 'SSN', 12, 20);
      NewDateTimeField(ADS, FnSL_CheckedIn, 'Checked In Time', 20, GMDK_DateTimeFMT);
      NewStringField(ADS, FnSL_Status, 'Status', 10, 20);
      NewStringField(ADS, FnSL_StatusOld, 'Old Status', 10, 20);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      NewStringField(ADS, FnSL_StatusBy, 'Status By', 20, 20);
      NewDateTimeField(ADS, FnSL_StatusTime, 'Since', 20, GMDK_DateTimeFMT);
      NewStringField(ADS, FnSL_Comments, 'Workstation', 20, 200);
      NewStringField(ADS, FnSL_LockStatus, 'VistA Lock', 5, 20);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      NewStringField(ADS, FnSL_LockedBy, 'VistA Locked By', 20, 20);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      NewDateTimeField(ADS, FnSL_LastModified, 'Last Modified', 12);
{$IFNDEF AANTEST}
      ADS.FieldList.Fields[ADS.FieldList.Count - 1].Visible := False;
{$ENDIF}
      ADS.IndexFieldNames := 'StudyID';
      ADS.CreateDataSet;
    end;
    ADS.Open;
  end;

begin
  CreateSL(CdsStudyList);
end;

/// /////////////////////////////////////////////////////////////////////////////
procedure TfrmStudies.ResetRefreshRate;
begin
  FRefreshRate := Preferences.IValue(OnStudyListRefreshRate);
  if FRefreshRate < 7 then FRefreshRate := 7;
  FCount := FRefreshRate;
  FAutorefresh := Preferences.BValue(OnStudyListAutorefresh);
  AcAutorefresh.Checked := FAutorefresh;
  TmrRefresh.Enabled := FAutorefresh;
  if not AcAutorefresh.Checked then LblAutorefresh.Caption := 'Autorefresh: Off';
  PnlDetails.Visible := UserSettings.BValue(OnShowStudyDetails);
  PnlLegend.Visible := UserSettings.BValue(OnShowStudyDetailsLegend);
  AcShowLegend.Checked := PnlLegend.Visible;
  AcShowDetails.Checked := PnlDetails.Visible;
  AcShowDisabledStudies.Checked := Preferences.BValue(OnShowDisabledStudies);
  // acShowDisabledStudies.Enabled := Preferences.bValue(onAllowUserControlStudyStatus);
  CdsStudyList.DisableControls;
  SetDisabledFilter;
  CdsStudyList.EnableControls;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.UpdateStudyDetails;
  function CurrText: TTextAttributes;
  begin
    if Re.SelLength > 0 then Result := Re.SelAttributes
    else Result := Re.DefAttributes;
  end;

begin
  if not PnlDetails.Visible then Exit;
  if FIgnore then Exit;
  with Re do begin
    Lines.Clear;
    Refresh;
    if (CdsStudyList.Active) and (CdsStudyList.RecordCount > 0) then begin
      Lines.Add(CdsStudyList.FieldByName(FnSL_Name).AsString);
      SelStart := 0;
      SelLength := Length(CdsStudyList.FieldByName(FnSL_Name).AsString);
      CurrText.Style := [FsBold];
      CurrText.Size := Font.Size + 2;
      if CdsStudyList.FieldByName(FnSL_Sensitive).AsBoolean then begin
        Lines.Add('   SSN: * SENSITIVE *');
        Lines.Add('   DOB: * SENSITIVE *');
      end else begin
        Lines.Add('   SSN: ' + CdsStudyList.FieldByName(FnSL_SSN).AsString);
        Lines.Add('   DOB: ' + FormatDateTime('MM/DD/YYYY', CdsStudyList.FieldByName(FnSL_DOB).AsDateTime));
      end;
      Lines.Add('   Sex: ' + CdsStudyList.FieldByName(FnSL_Sex).AsString);
      Lines.Add('');
      Lines.Add('');
      Lines.Add('Checked Into CP User: ');
      Lines.Add('   Checked in: ' + CdsStudyList.FieldByName(FnSL_CheckedIn).AsString);
      Lines.Add('   Study #: ' + CdsStudyList.FieldByName(FnSL_StudyID).AsString);
      Lines.Add('   Study Status: ' + CdsStudyList.FieldByName(FnSL_Status).AsString);
    end;
    SelStart := 0;
  end;
end;

procedure TfrmStudies.SetActionsActiveStatus(AValue: Boolean);
begin
  AcClose.Enabled := AValue;
  AcRefresh.Enabled := AValue;
  AcSelect.Enabled := AValue;
  AcReview.Enabled := AValue;
  AcEnable.Enabled := AValue;
  AcDisable.Enabled := AValue;
end;

procedure TfrmStudies.UpdateActionStatuses;
var
  Dataset: TDataset;
  Status: string;
begin
  Dataset := DbgStatus.DataSource.Dataset;
  if not Assigned(Dataset) then Exit;
  if not Dataset.Active then Exit;
  if Dataset.RecordCount < 1 then begin
    SetActionsActiveStatus(False);
    Re.Text := '';
  end else begin
    Status := Dataset.FieldByName(FnSL_Status).AsString;
    AcEnable.Enabled := (Status = SnDisabled) and (Preferences.BValue(OnAllowUserControlStudyStatus) = True);
    AcDisable.Enabled := (Status = SnEnabled) and (Preferences.BValue(OnAllowUserControlStudyStatus) = True);
    AcSelect.Enabled := (Status = SnEnabled);
    AcReview.Enabled := True;
  end;
  AcRefresh.Enabled := True; // not Preferences.bValue(onStudyListAutorefresh);
  AcClose.Enabled := True;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.DbgStatusDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  Dg: TDBGrid;
  Field: TField;
  Dataset: TDataset;
  BSensitive: Boolean;
  Pattern, Risk: string;
  RR: TRect;
begin
  Dg := TDBGrid(Sender);
  Dataset := Dg.DataSource.Dataset;
  Field := Dataset.FieldByName(FnSL_Status);
  Risk := Field.AsString;
  try
    BSensitive := Dataset.FieldByName(FnSL_Sensitive).AsBoolean;
  except
    BSensitive := False;
  end;
  if Sender = DbgStatus then Pattern := FSelectedFieldName
  else Pattern := FHistorySelectedFieldName;
  if (GdSelected in State) then begin
    Dg.Canvas.Font.Color := ClWhite;
    Dg.Canvas.Brush.Color := ClNavy;
    if Pattern = Column.FieldName then Dg.Canvas.Font.Style := [FsBold]
    else Dg.Canvas.Font.Style := [];
  end else begin
    Dg.Canvas.Font.Color := ClPurple;
    Dg.Canvas.Brush.Color := ClUnknown;
    if Risk = SnEnabled then Dg.Canvas.Font.Color := ClBlack;
    if Risk = SnEnabled then Dg.Canvas.Brush.Color := ClEnabled;
    if Risk = SnInUse then Dg.Canvas.Font.Color := ClBlue;
    if Risk = SnInUse then Dg.Canvas.Brush.Color := ClInUse;
    if Risk = SnDisabled then Dg.Canvas.Font.Color := ClRed;
    if Risk = SnDisabled then Dg.Canvas.Brush.Color := ClDisabled;
    if Pattern = Column.FieldName then begin
      Dg.Canvas.Font.Style := [FsBold];
      Dg.Canvas.Font.Color := ClPurple;
      if Rect.Right - Rect.Left > Dg.Canvas.TextWidth(Column.DisplayName) + 8 then
          IlStatus.Draw(Dg.Canvas, Rect.Right - 20, 1, IsSortGray, True);
    end
    else Dg.Canvas.Font.Style := [];
  end;
  with Dg do begin
    if Columns[DataCol].FieldName = FnSL_StudyID then begin
      Canvas.FillRect(Rect);
      if Risk = SnInUse then IlStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, IsInUse, True)
      else if Risk = SnDisabled then IlStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, IsDisabled, True)
      else if Risk = SnEnabled then IlStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, IsEnabled, True)
      else IlStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, IsUnknown, True);
      RR := Rect;
      RR.Left := Rect.Left + 20;
      DefaultDrawColumnCell(RR, DataCol, Column, State);
    end else if (Columns[DataCol].FieldName = FnSL_SSN) or (Columns[DataCol].FieldName = FnSL_DOB) then begin
      if BSensitive then begin
        Canvas.FillRect(Rect);
        IlStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, IsSensitive, True);
        IlStatus.Draw(Canvas, Rect.Left + 14, Rect.Top, IsSensitive, True);
        IlStatus.Draw(Canvas, Rect.Left + 24, Rect.Top, IsSensitive, True);
      end
      else DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end else if (Columns[DataCol].FieldName = FnSL_StatusTime) and
      (Pos('12/30/1899', Dataset.FieldByName(FnSL_StatusTime).AsString) = 1) then begin
      Dg.Canvas.Font.Color := Dg.Canvas.Brush.Color;
      DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end
    else DefaultDrawColumnCell(Rect, DataCol, Column, State);
  end;
end;

// ..............................................................................

procedure TfrmStudies.PnlActiveStudyListResize(Sender: TObject);
begin
  LblAutorefresh.Left := GrbActiveStudyList.Width - LblAutorefresh.Width - 8;
end;

procedure TfrmStudies.AcCloseExecute(Sender: TObject);
begin
  ModalResult := MrCancel;
end;

procedure TfrmStudies.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := MrCancel;
end;
/// /////////////////////////////////////////////////////////////////////////////

function TfrmStudies.LocateStudyByID(AnID: string): Boolean;
begin
  try
    Result := CdsStudyList.Locate(FnSL_StudyID, VarArrayOf([AnID]), []);
  except
    Result := False;
  end
end;

procedure TfrmStudies.SelectPatient(AReadOnly: Boolean);
begin
  FSelectedPatient.ID := CdsStudyList.FieldByName(FnSL_PatientID).AsString;
  FSelectedPatient.SSN := CdsStudyList.FieldByName(FnSL_SSN).AsString;
  FSelectedPatient.Name := CdsStudyList.FieldByName(FnSL_Name).AsString;
  FSelectedPatient.DOB := CdsStudyList.FieldByName(FnSL_DOB).AsDateTime;
  FSelectedPatient.SessionID := CdsStudyList.FieldByName(FnSL_StudyID).AsString;
  FSelectedPatient.Sex := CdsStudyList.FieldByName(FnSL_Sex).AsString;
  FSelectedPatient.ReadOnly := AReadOnly;
end;

procedure TfrmStudies.AddActiveStudy(ARP: TMDKRegisteredPatient);
begin
  if not LocateStudyByID(ARP.SessionID) then begin
    CdsStudyList.Insert;
    CdsStudyList.FieldByName(FnSL_StudyID).AsString := ARP.SessionID;
    CdsStudyList.FieldByName(FnSL_PatientID).AsString := ARP.ID;
    CdsStudyList.FieldByName(FnSL_Name).AsString := ARP.Name;
    CdsStudyList.FieldByName(FnSL_DOB).AsString := FormatDateTime('mm/dd/yyyy', ARP.DOB);
    CdsStudyList.FieldByName(FnSL_Sex).AsString := ARP.Sex;
    CdsStudyList.FieldByName(FnSL_SSN).AsString := ARP.SSN;
    CdsStudyList.FieldByName(FnSL_CheckedIn).AsString := ARP.StudyCheckin;
    CdsStudyList.FieldByName(FnSL_Sensitive).AsBoolean := Engine.IsDataSensitive(ARP.ID);
  end
  else CdsStudyList.Edit;
  try
    // if (cdsStudyList.FieldByName(fnSL_StatusTime).AsDateTime <> aRP.StatusDate) or
    // (cdsStudyList.FieldByName(fnSL_StatusTime).AsString = '') then
    begin
      CdsStudyList.FieldByName(FnSL_LockStatus).AsString := ARP.LockStatus;
      CdsStudyList.FieldByName(FnSL_LockedBy).AsString := ARP.LockedBy;
      CdsStudyList.FieldByName(FnSL_LastModified).AsDateTime := ARP.LastModified;
      CdsStudyList.FieldByName(FnSL_Status).AsString := ARP.StudyStatus;
      CdsStudyList.FieldByName(FnSL_StatusBy).AsString := Engine.GetUserNameByID(ARP.StatusBy);
      CdsStudyList.FieldByName(FnSL_StatusTime).AsDateTime := ARP.StatusDate;
      CdsStudyList.FieldByName(FnSL_Comments).AsString := ARP.Workstation;
      CdsStudyList.Post;
    end;
  except
  end;
end;

procedure TfrmStudies.SetDisabledFilter;
begin
  if AcShowDisabledStudies.Checked then CdsStudyList.Filtered := False
  else begin
    CdsStudyList.Filter := FnSL_Status + '<>''' + SnDisabled + '''';
    CdsStudyList.Filtered := True;
  end
end;

function TfrmStudies.AccessRegistered(APatientID: string): Boolean;
var
  SL: TStringList;
  SAccessInfo, SInfo: string;
  SWarning: string;
begin
  if CdsStudyList.FieldByName(FnSL_Sensitive).AsBoolean then begin
    SL := TStringList.Create;
    SAccessInfo := Engine.GetPatientAccessInfo(APatientID);
    SL.Text := SAccessInfo;
    SInfo := SL[0];
    SL.Delete(0);
    SSecurityWarning := SL.Text;
    SWarning := SL.Text + #13#10 + '          Do you want to continue?';
    SL.Free;
    if SInfo = '0' then Result := True
    else if SInfo = '1' then Result := MessageDlg(SWarning, MtWarning, [MbYes, MbNo], 0) = MrYes
    else if SInfo = '2' then begin
      if MessageDlg(SWarning, MtWarning, [MbYes, MbNo], 0) <> MrYes then Result := False
      else begin
        Engine.GetPatientBulletinInfo(APatientID);
        Result := True;
      end;
    end else if SInfo = '-1' then begin
      Result := False;
      MessageDlg('Access registration is not completed'#13#10 + 'RPC/API failed' + #13#10 +
        'Required field is not defined', MtWarning, [MbOK], 0);
    end else begin
      MessageDlg(SSecurityWarning, MtWarning, [MbYes], 0);
      Result := False;
    end;
  end
  else Result := True;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.DsStudyListDataChange(Sender: TObject; Field: TField);
begin
  if FIgnoreCDSChange then Exit;
  UpdateActionStatuses;
  UpdateStudyDetails;
end;

procedure TfrmStudies.TmrRefreshTimer(Sender: TObject);
begin
  if FIgnoreTimer then Exit;
  Dec(FCount);
  if FCount < 1 then begin
    TmrRefresh.Enabled := False;
    AcRefreshExecute(nil);
  end
  else LblAutorefresh.Caption := Format('Autorefresh in %d sec', [FCount]);
end;

type
  TMyDBGrid = class(TDBGrid)
  end;

procedure TfrmStudies.DbgStatusTitleClick(Column: TColumn);
var
  I: Longint;
begin
  I := TMyDBGrid(DbgStatus).LeftCol;
  CdsStudyList.DisableControls;
  if FSelectedFieldName = Column.FieldName then begin
  end else begin
    FSelectedFieldName := Column.FieldName;
    CdsStudyList.IndexFieldNames := FSelectedFieldName;
  end;
  CdsStudyList.EnableControls;
  TMyDBGrid(DbgStatus).LeftCol := I;
end;

procedure TfrmStudies.DbgStatusDblClick(Sender: TObject);
begin
  if AcSelect.Enabled then AcSelect.Execute
  else AcReview.Execute;
end;

procedure TfrmStudies.DbgStatusKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Return then DbgStatusDblClick(nil)
  else if (Key = VK_Delete) and (SsCtrl in Shift) and (SsShift in Shift) and (Engine.CurrentOperatorMode = RnADMIN) then
  begin
    if MessageDlg('Delete Study <' + CdsStudyList.FieldByName(FnSL_StudyID).AsString + '> information?', MtConfirmation,
      [MbOK, MbCancel], 0) = MrOK then begin
      Key := 0;
      CdsStudyList.Delete;
      AcSaveTableXML.Execute;
    end;
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.SaveBooleanOption(AName: string; AValue: Boolean; AType: string = OtUser);
var
  SValue: string;
  Options: TUserOptions;
begin
  if AType = OtUser then Options := UserOptions
  else if AType = OtSystem then Options := SysOptions
  else if AType = OtDeveloper then Options := DevOptions
  else if AType = OtUserSettings then Options := UserSettings
  else Exit;
  if AValue then SValue := 'TRUE'
  else SValue := 'FALSE';
  Options.SetValue(AName, SValue);
  if AType = OtSystem then begin
    Engine.SaveSystemOptions;
    Preferences.Overwrite(SysOptions.ValueList.Text);
    Preferences.Overwrite(UserOptions.ValueList.Text);
    Preferences.Overwrite(UserSettings.ValueList.Text);
  end else if AType = OtUser then begin
    Engine.SaveUserOptions;
    Preferences.Overwrite(UserOptions.ValueList.Text);
    Preferences.Overwrite(UserSettings.ValueList.Text);
  end else if AType = OtUserSettings then begin
    Engine.SaveUserOptions;
    Preferences.Overwrite(UserSettings.ValueList.Text);
  end
end;

procedure TfrmStudies.AcShowLegendExecute(Sender: TObject);
begin
  PnlLegend.Visible := not PnlLegend.Visible;
  AcShowLegend.Checked := PnlLegend.Visible;
  SaveBooleanOption(OnShowStudyDetailsLegend, AcShowLegend.Checked, OtUserSettings);
end;

procedure TfrmStudies.AcShowDetailsExecute(Sender: TObject);
begin
  FIgnoreCDSChange := True;
  PnlDetails.Visible := not PnlDetails.Visible;
  AcShowDetails.Checked := PnlDetails.Visible;
  SaveBooleanOption(OnShowStudyDetails, AcShowDetails.Checked, OtUserSettings);
  FIgnoreCDSChange := False;
  UpdateStudyDetails;
end;

procedure TfrmStudies.AcShowDisabledStudiesExecute(Sender: TObject);
begin
  AcShowDisabledStudies.Checked := not AcShowDisabledStudies.Checked;
  SaveBooleanOption(OnShowDisabledStudies, AcShowDisabledStudies.Checked, OtUser { Settings } );
  SetDisabledFilter;
end;

// ..............................................................................

procedure TfrmStudies.FreeActiveStudyList;
var
  Ap: TMDKRegisteredPatient;
begin
  if Assigned(FActiveStudyList) then begin
    while FActiveStudyList.Count > 0 do
      try
        Ap := TMDKRegisteredPatient(FActiveStudyList.Objects[0]);
        if Ap <> nil then Ap.Free;
        FActiveStudyList.Delete(0);
      except
      end;
    FreeAndNil(FActiveStudyList);
  end;
end;

procedure TfrmStudies.AcAutorefreshExecute(Sender: TObject);
begin
  AcAutorefresh.Checked := not AcAutorefresh.Checked;
  TmrRefresh.Enabled := AcAutorefresh.Checked;
  SaveBooleanOption(OnStudyListAutorefresh, AcAutorefresh.Checked, OtUserSettings);
  if not AcAutorefresh.Checked then LblAutorefresh.Caption := 'Autorefresh: Off'
  else begin
    LblAutorefresh.Caption := 'Autorefresh: On';
    ResetRefreshRate;
  end;
end;

procedure TfrmStudies.AcRefreshExecute(Sender: TObject);
var
  SID: string;
  FNow: TDateTime;

  procedure FixStatuses;
  var
    SXML: string;
    ACDS: TClientDataSet;
    BM: TBookmark;
    DT: TDateTime;
    SStudyID, SStatus, SStatusAt, SWS: string;

    procedure ProcessDisabledRecord;
    begin
      SStatusAt := ACDS.FieldByName(FnSL_StatusTime).AsString;
      DT := StrToDateTime(SStatusAt);
      SStatusAt := FloatToStr(WindowsDateTimeToFMDateTime(DT));
      SWS := ACDS.FieldByName(FnSL_Comments).AsString;
      if Engine.FRenalController.LockStudy(StrToInt(SStudyID)) then begin
        SStatus := Engine.FRenalController.SetStudyUseStatus(SStudyID, '2', Engine.UserDUZ, SStatusAt, SWS);
        if Pos('-', SStatus) <> 1 then begin
          CdsStudyList.Edit;
          CdsStudyList.FieldByName(FnSL_Status).AsString := 'DISABLED';
          CdsStudyList.FieldByName(FnSL_Comments).AsString := SWS;
          CdsStudyList.Post;
          ACDS.Delete;
        end
        else ACDS.Next;
        Engine.FRenalController.UnLockStudy(StrToInt(SStudyID));
      end
      else ACDS.Next;
    end;

  begin
    SXML := Engine.GetSystemOptionByName(OnStudyListTable);
    if (SXML <> '') and (SXML <> #13#10) then begin
      BM := CdsStudyList.GetBookmark;
      ACDS := TClientDataSet.Create(Self);
      ACDS.XMLData := SXML;
      ACDS.Open;
      if ACDS.Active then begin
        while not ACDS.Eof do begin
          SStudyID := ACDS.FieldByName(FnSL_StudyID).AsString;
          if LocateStudyByID(SStudyID) then begin
            SStatus := ACDS.FieldByName(FnSL_Status).AsString;
            if SStatus = 'DISABLED' then ProcessDisabledRecord
            else ACDS.Delete;
          end
          else ACDS.Delete;
        end;
        ACDS.MergeChangeLog;
        if ACDS.RecordCount < 1 then Engine.SetSystemOptionByName(OnStudyListTable, '')
        else Engine.SetSystemOptionByName(OnStudyListTable, ACDS.XMLData);
      end;
      FreeAndNil(ACDS);
      CdsStudyList.GotoBookmark(BM);
      CdsStudyList.FreeBookmark(BM);
    end;
  end;

  function GetCurrentSTudyID: string;
  begin
    Result := '';
    if (CdsStudyList.RecordCount > 0) and not CdsStudyList.BOF then
      try
        Result := CdsStudyList.FieldByName(FnSL_StudyID).AsString;
      except
      end;
  end;

  procedure SetCDSByActiveStudyList;
  var
    I: Integer;
    Rp: TMDKRegisteredPatient;

    procedure CleanUpStudyList;
    begin
      CdsStudyList.EmptyDataSet; // zzzzzzandria 2007-12-05
      CdsStudyList.MergeChangeLog;
    end;

  begin
    CleanUpStudyList;
    for I := 0 to FActiveStudyList.Count - 1 do
      if Assigned(FActiveStudyList.Objects[I]) then begin
        Rp := TMDKRegisteredPatient(FActiveStudyList.Objects[I]);
        if Rp.StudyStatus = 'IN_USE' then Rp.StudyStatus := 'IN USE'
        else if Rp.StudyStatus = 'ACTIVE' then Rp.StudyStatus := 'ENABLED';
        AddActiveStudy(Rp);
      end;
  end;

begin
  SetActionsActiveStatus(False); // zzzzzzandria 2007-09-19
  TmrRefresh.Enabled := False;
  FIgnoreCDSChange := True;
  CdsStudyList.DisableControls;
  LblAutorefresh.Caption := 'Refreshing...';
  LblAutorefresh.Refresh;
  GrbActiveStudyList.Refresh;
  Re.Text := '';
  Re.Refresh;
  SID := GetCurrentSTudyID;
  FNow := Now;
  FrmWait.AddLogLine(Char(VK_TAB) + 'Getting VistA data...');
  FreeActiveStudyList;
  FActiveStudyList := NewRegisteredPatientList(Engine.GetPatientList);
  FrmWait.AppendLogLine(Char(VK_TAB) + FormatDateTime('ss.zzz', Now - FNow));
  FNow := Now;
  FrmWait.AddLogLine(Char(VK_TAB) + 'Updating Study List...');
  SetCDSByActiveStudyList;
  FrmWait.AppendLogLine(Char(VK_TAB) + FormatDateTime('ss.zzz', Now - FNow));
  FixStatuses;
  ResetRefreshRate;
  LocateStudyByID(SID);
  UpdateActionStatuses; // zzzzzzandria 2007-09-19
  UpdateStudyDetails;
  CdsStudyList.EnableControls;
  FIgnoreCDSChange := False;
end;

function TfrmStudies.GetSelectedPatient: TMDKRegisteredPatient;
begin
  Result := FSelectedPatient;
end;
/// /////////////////////////////////////////////////////////////////////////////

function TfrmStudies.SetStudyStatus(AStatus: string; out ErrorMsg: string): Integer;
var
  SStatusByName, SStatusOld, SStatus, SWS, SStudyID, SStatusAt, SStatusBy: string;
  DT: TDateTime;
begin
  SStatusOld := CdsStudyList.FieldByName(FnSL_Status).AsString;
  SStudyID := CdsStudyList.FieldByName(FnSL_StudyID).AsString;
  SStatusBy := Engine.UserDUZ;
  SStatusByName := Engine.CurrentOperatorID;
  SWS := GetWorkstationName;
  DT := Now;
  SStatusAt := FloatToStr(WindowsDateTimeToFMDateTime(DT));
  if AStatus = 'DISABLED' then SStatus := '2'
  else SStatus := '1';
  if Pos('-', Engine.FRenalController.SetStudyUseStatus(SStudyID, SStatus, SStatusBy, SStatusAt, SWS)) = 1 then begin
    Result := RcStudyStatusChangeFailed;
    ErrorMsg := 'Failed to change Use Status';
    SStatus := SStatusOld;
  end else begin
    Result := RcStudyStatusOK;
    SStatus := AStatus;
  end;
  try
    if not(CdsStudyList.State = DsEdit) then CdsStudyList.Edit;
    CdsStudyList.FieldByName(FnSL_Status).AsString := SStatus;
    CdsStudyList.FieldByName(FnSL_StatusBy).AsString := SStatusByName;
    CdsStudyList.FieldByName(FnSL_StatusTime).AsDateTime := DT;
    CdsStudyList.FieldByName(FnSL_Comments).AsString := SWS;
    CdsStudyList.Post;
  except
    on E: Exception do begin
      Result := RcTableUpdateFailed;
      ErrorMsg := E.Message;
    end;
  end;
end;

function TfrmStudies.SetUseStatus(NewStatus: string; RequiredStatuses: array of string; const StOK: Integer;
  var ErrorMsg: string; AccessRegistrationNeeded: Boolean = False; KeepLock: Boolean = False): Integer;
var
  SID: string;
  IID: Integer;

  function IsRequiredStatus(AStatus: string): Boolean;
  var
    I: Integer;
  begin
    Result := False;
    for I := low(RequiredStatuses) to high(RequiredStatuses) do begin
      if AStatus <> RequiredStatuses[I] then Continue;
      Result := True;
      Break;
    end;
  end;

begin
  if AccessRegistrationNeeded and not AccessRegistered(CdsStudyList.FieldByName(FnSL_PatientID).AsString) then begin
    Result := RcStudyStatusAccessRegistrationFailed;
    Exit;
  end;
  FIgnore := True;
  if IsRequiredStatus(CdsStudyList.FieldByName(FnSL_Status).AsString) then begin
    IID := CdsStudyList.FieldByName(FnSL_StudyID).AsInteger;
    if Engine.FRenalController.LockStudy(IID) then begin
      SID := CdsStudyList.FieldByName(FnSL_StudyID).AsString;
      Result := SetStudyStatus(NewStatus, ErrorMsg);
      if Result = StOK then Engine.Report(RtInfo, NewStatus, '', 0, '', 'Set Study Status')
      else Engine.Report(RtError, 'Set Study <' + SID + '> status' + NewStatus + ' Failed', '', 0, '',
          'Set Study Status');
      if not KeepLock then
        if not Engine.FRenalController.UnLockStudy(IID) then Result := RcStudyStatusUnLockFailed;
    end else begin
      ErrorMsg := 'Lock failed. Study could being edited by another user';
      Result := RcStudyStatusLockFailed;
    end;
  end else begin
    ErrorMsg := 'Wrong Status';
    Result := RcStudyStatusWrong;
  end;
  FIgnore := False;
end;

procedure ExplainResult(AStudy, AStatus: string; ARC: Integer);
var
  S: string;
begin
  case ARC of
    RcStudyStatusOK:;
    RcStudyStatusLockFailed: S := 'Lock Failed';
    RcStudyStatusUnLockFailed: S := 'Unlock Failed';
    RcStudyStatusWrong: S := 'Wrong Status';
  end;
  if S <> '' then MessageDlg(S, MtWarning, [MbOK], 0);
end;

procedure TfrmStudies.AcDisableExecute(Sender: TObject);
var
  S: string;
begin
  ExplainResult('', '', SetUseStatus(SnDisabled, [SnEnabled], RcStudyStatusOK, S));
end;

procedure TfrmStudies.AcEnableExecute(Sender: TObject);
var
  S: string;
begin
  ExplainResult('', '', SetUseStatus(SnEnabled, [SnDisabled], RcStudyStatusOK, S));
end;

procedure TfrmStudies.AcSelectExecute(Sender: TObject);
var
  I: Integer;
  SStatus, ErrorMsg, SID: string;
begin
  // Hide;
  SetActionsActiveStatus(False); // zzzzzzandria 2007-09-19
  SID := CdsStudyList.FieldByName(FnSL_StudyID).AsString;
  // acRefresh.Execute;
  if LocateStudyByID(SID) then begin
    SStatus := CdsStudyList.FieldByName(FnSL_Status).AsString;
    if (SStatus = SnEnabled) or (SStatus = '') then begin
      I := SetUseStatus(SnInUse, [SnEnabled], RcStudyStatusOK, ErrorMsg, True, True);
      case I of
        RcStudyStatusOK: begin
            LocateStudyByID(SID);
            SelectPatient(False);
            ModalResult := MrOK;
          end;
      else begin
          Show;
          Engine.Report(RtError, 'Study <' + SID + '> selection failed.' + #13#10 + ErrorMsg, '', 0, '',
            'Select Study');
          MessageDlg('Study <' + SID + '> selection failed.' + #13#13 + ErrorMsg + #13#13 +
            'Try select study again later.', MtInformation, [MbOK], 0);
        end;
      end;
    end else begin
      Show;
      MessageDlg('Study can not be selected for update' + #13#13 + 'Study:  "' + SID + '"' + #13 + 'Status: "' + SStatus
        + '"' + #13 + 'Set by:  ' + CdsStudyList.FieldByName(FnSL_StatusBy).AsString + #13 + 'On:      ' +
        CdsStudyList.FieldByName(FnSL_StatusTime).AsString + #13 + 'W/S:     ' + CdsStudyList.FieldByName(FnSL_Comments)
        .AsString + #13#13 + 'Try again later', MtWarning, [MbOK], 0);
    end;
  end
  else Show;
  UpdateActionStatuses; // zzzzzzandria 2007-09-19
end;

procedure TfrmStudies.AcReviewExecute(Sender: TObject);
begin
  SetActionsActiveStatus(False);
  if AccessRegistered(CdsStudyList.FieldByName(FnSL_PatientID).AsString) then begin
    SelectPatient(True);
    ModalResult := MrOK;
  end;
  UpdateActionStatuses; // zzzzzzandria 2007-09-19
end;

function TfrmStudies.GetStudyStatus(AnID: string): string;
var
  BM: TBookmark;
begin
  Result := 'Unknown';
  CdsStudyList.DisableControls;
  try
    BM := CdsStudyList.GetBookmark;
    if LocateStudyByID(AnID) then Result := CdsStudyList.FieldByName(FnSL_Status).AsString;
    CdsStudyList.GotoBookmark(BM);
    CdsStudyList.FreeBookmark(BM);
  except
  end;
  CdsStudyList.EnableControls;
end;

function TfrmStudies.ReleaseStudy(AnID: string; var MsgError: string): Integer;
var
  IID: Integer;
begin
  IID := StrToIntDef(AnID, -1);
  if IID < 0 then begin
    Result := IID;
    MsgError := 'Error converting <' + AnID + '> to integer';
  end else begin
    if not LocateStudyByID(AnID) then begin
      Result := RcStudyNotFound;
      MsgError := 'Study <' + AnID + '> not found';
    end else begin
      if Engine.FRenalController.UnLockStudy(IID) then begin
        Result := RcStudyStatusOK;
        MsgError := '';
      end else begin
        Result := RcStudyStatusUnLockFailed;
        MsgError := Engine.FRenalController.ResultInfo;
      end;
    end;
  end;
end;

end.
