unit frMDK_Assessment;
{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 4/18/07
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     frMDK_Assessment definition
  *       Notes:
  *
  ================================================================================
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Fr_Simple, ExtCtrls, IMDK_Assessment, StdCtrls, ComCtrls, ImgList, ToolWin, ActnList,
  Buttons, System.Actions;

type
  TAccessInfo = record
    R: Boolean;
    W: Boolean;
    M: Boolean;
  end;

  TfrAssessment = class(TfrSimpleFrame)
    PnlCaption: TPanel;
    Re: TRichEdit;
    ActionList1: TActionList;
    AcUpdate: TAction;
    Panel1: TPanel;
    ImageList1: TImageList;
    PnlButtons2d: TPanel;
    SpeedButton1: TSpeedButton;
    AcRefresh: TAction;
    PnlButtons3D: TPanel;
    BitBtn1: TBitBtn;
    procedure AcUpdateExecute(Sender: TObject);
    procedure AcRefreshExecute(Sender: TObject);
  private
    { Private declarations }
    FAccessInfo: TAccessInfo;
    FAssessment: I_Assessment;
  public
    { Public declarations }
    property AccessInfo: TAccessInfo read FAccessInfo write FAccessInfo;
    property Assessment: I_Assessment read FAssessment;
    procedure SetAssessmentInterface(AnInterface: I_Assessment);
    procedure SetAssessmentCaption(ACaption: string);
    procedure FreeInterface;
  end;

var
  FrAssessment: TfrAssessment;

function NewAssessmentFrame(ACaption: string; AnInterface: I_Assessment; AParent: TWinControl): TfrAssessment;

implementation

uses
  UMDK_ReportEngine;

{$R *.dfm}

function NewAssessmentFrame(ACaption: string; AnInterface: I_Assessment; AParent: TWinControl): TfrAssessment;
begin
  Result := TfrAssessment.Create(nil);
  Result.SetAssessmentInterface(AnInterface);
  Result.SetAssessmentCaption(ACaption);
end;

procedure TfrAssessment.SetAssessmentInterface(AnInterface: I_Assessment);
begin
  FAssessment := AnInterface;
end;

procedure TfrAssessment.SetAssessmentCaption(ACaption: string);
begin
  PnlCaption.Caption := ACaption;
end;

procedure TfrAssessment.FreeInterface;
begin
  FAssessment := nil;
end;

procedure TfrAssessment.AcUpdateExecute(Sender: TObject);
var
  S: string;
begin
  inherited;
  if Assigned(FAssessment) then begin
    S := Re.Text;
    S := FAssessment.UpdateAssessmentText(S);
    if S <> Re.Text then
      try
        Re.Text := S;
        PaintSyntax(Re, False);
      except
      end;
  end;
end;

procedure TfrAssessment.AcRefreshExecute(Sender: TObject);
begin
  inherited;
  if Assigned(FAssessment) then
    try
      Re.Text := FAssessment.GetAssessmentText;
      PaintSyntax(Re, False);
    except
    end;
end;

end.
