program Hemodialysis;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 7/29/08 10:38a $
*       Site Name:    Hines OIFO
*       Date Created: 4/29/07
*       Developers:   dddddddddomain.user@domain.ext
*       Description:  Contains the application project file
*       Notes:  Updated to use ICD 10 codes against Patch 29. 06/12/12 Joe Carney
*
================================================================================
*
}
{%File 'BuildHistory.txt'}

uses
  Forms,
  Windows,
  Dialogs,
  SysUtils,
  fMDK_Main in 'Forms\fMDK_Main.pas' {frmMain},
  uMDK_Patients in 'Objects\uMDK_Patients.pas',
  dMDK_Data in 'Forms\dMDK_Data.pas' {dmData: TDataModule},
  fMDK_Access in 'Tabs\fMDK_Access.pas' {frmAccess},
  fMDK_Cover in 'Tabs\fMDK_Cover.pas' {frmCover},
  fMDK_Log in 'Tabs\fMDK_Log.pas' {frmLog},
  uMDK_VASite in 'VascularAccess\uMDK_VASite.pas',
  fMDK_VAAdd in 'VascularAccess\fMDK_VAAdd.pas' {dlgAPAdd},
  uMDK_VADataSet in 'VascularAccess\uMDK_VADataSet.pas',
  fMDK_RxLab in 'Tabs\fMDK_RxLab.pas' {frmRxLab},
  fMDK_Pre in 'Tabs\fMDK_Pre.pas' {frmPre},
  fMDK_Post in 'Tabs\fMDK_Post.pas' {frmPost},
  fMDK_Flowsheet in 'Tabs\fMDK_Flowsheet.pas' {frmFlow},
  fMDK_Summary in 'Tabs\fMDK_Summary.pas' {frmSummary},
  fMDK_Blank in 'Tabs\fMDK_Blank.pas' {frmBlank},
  uMDK_Summary in 'Objects\uMDK_Summary.pas',
  uMDK_InstrumentRecord in 'Objects\uMDK_InstrumentRecord.pas',
  uMDK_Engine in 'Objects\uMDK_Engine.pas',
  oDBController_Renal in 'CLIO\oDBController_Renal.pas',
  oDBController in 'CLIO\oDBController.pas',
  fMDK_VADelete in 'VascularAccess\fMDK_VADelete.pas' {frmVADelete},
  fMDK_FlowSheetEdit in 'Forms\fMDK_FlowSheetEdit.pas' {frmFlowSheetEdit},
  uMDK_Info in 'Objects\uMDK_Info.pas',
  fMDK_Info in 'Forms\fMDK_Info.pas' {frmInfo},
  uMDK_MedList in 'Objects\uMDK_MedList.pas',
  uMDK_Common in 'Objects\uMDK_Common.pas',
  uGMV_VersionInfo in '..\Utils\uGMV_VersionInfo.pas',
  fGMV_AboutDlg in 'Forms\fGMV_AboutDlg.pas' {frmGMV_AboutDlg},
  uGMV_CRC32 in '..\Utils\uGMV_CRC32.pas',
  fMDK_Wait in '..\Utils\fMDK_Wait.pas' {frmWait},
  oDBConnection in 'CLIO\oDBConnection.pas',
  uXML in '..\Utils\uXML.pas',
  oInterfaces in 'CLIO\oInterfaces.pas',
  fMDK_Report in 'Forms\fMDK_Report.pas' {frmMDK_Report},
  fMDK_Options in 'Forms\fMDK_Options.pas' {frmMDK_Options},
  uMDK_Options in 'Objects\uMDK_Options.pas',
  uMDK_ReportList in 'Objects\uMDK_ReportList.pas',
  fMDK_CDS in 'Forms\fMDK_CDS.pas' {frmMDK_CDS},
  uROR_Resources in '..\ROR\uROR_Resources.pas',
  uROR_CommonUtils in '..\ROR\uROR_CommonUtils.pas',
  fROR_PCall in '..\ROR\fROR_PCall.pas' {RPCErrorForm},
  uMDK_Vitals in 'Objects\uMDK_Vitals.pas',
  fMDK_BugReport in 'Forms\fMDK_BugReport.pas' {frmBugReport},
  fMDK_Submit in 'Tabs\fMDK_Submit.pas' {frmSubmit},
  fMDK_Medication in 'Forms\fMDK_Medication.pas' {dlgMEdit},
  fMDK_TIUNote in 'Forms\fMDK_TIUNote.pas' {frmNote},
  uMDK_TIUNote in 'Objects\uMDK_TIUNote.pas',
  uMDK_BillingInfo in 'Objects\uMDK_BillingInfo.pas',
  fMDK_ListEdit in 'Forms\fMDK_ListEdit.pas' {frmListEdit},
  uMDK_Fresenius in 'Instruments\uMDK_Fresenius.pas',
  fMDK_SorAndFilter in 'Forms\fMDK_SorAndFilter.pas' {dlgSort},
  fMDK_OptionName in 'Forms\fMDK_OptionName.pas' {dlgOption},
  fMDK_HospitalSelector in 'Forms\fMDK_HospitalSelector.pas' {frmMDK_HospitalSelector},
  uMDK_MDateTime in 'Objects\uMDK_MDateTime.pas',
  fMDK_DateRangeSelector in 'Forms\fMDK_DateRangeSelector.pas' {frmGMV_DateRange},
  uMDK_ReportEngine in 'Objects\uMDK_ReportEngine.pas',
  iMDK_VitalsQualifiers in 'Interfaces\iMDK_VitalsQualifiers.pas',
  uMDK_Notes in 'Objects\uMDK_Notes.pas',
  fMDK_Toolbox in 'Forms\fMDK_Toolbox.pas' {frmToolbox},
  uMDK_Utils in '..\Utils\uMDK_Utils.pas',
  fMDK_FallAssessement in 'Forms\fMDK_FallAssessement.pas' {FallAssessment},
  fMDK_ReloadFlowsheet in 'Forms\fMDK_ReloadFlowsheet.pas' {dlg_ReloadFlowsheet},
  uMDK_SubmitHistory in 'Objects\uMDK_SubmitHistory.pas',
  fMDK_DictionaryEdit in 'Forms\fMDK_DictionaryEdit.pas' {frmMDK_DictionaryEdit},
  fMDK_SelectProvider in 'Forms\fMDK_SelectProvider.pas' {dlgSelectProvider},
  uMDK_Dictionary in 'Objects\uMDK_Dictionary.pas',
  uMDK_CDSCommon in '..\Utils\uMDK_CDSCommon.pas',
  uMDK_VitalsAgent in 'Objects\uMDK_VitalsAgent.pas',
  fGMV_TimeOutManager in '..\Utils\fGMV_TimeOutManager.pas' {frmGMV_TimeOutManager},
  uMDK_Gambro in 'Instruments\uMDK_Gambro.pas',
  uMDK_Flowsheet in 'Objects\uMDK_Flowsheet.pas',
  fMDK_AddOptions in 'Forms\fMDK_AddOptions.pas' {frmAddOptions},
  uROR_RPCBroker in '..\ROR\uROR_RPCBroker.pas',
  fMDK_LocalLogin in 'Forms\fMDK_LocalLogin.pas' {dlgLocalLogin},
  uMDK_LocalDB in 'Objects\uMDK_LocalDB.pas',
  fMDK_Select in 'Forms\fMDK_Select.pas' {dlgSelectItem},
  uMDK_Timeline in 'Objects\uMDK_Timeline.pas',
  fMDK_Timeline in 'Forms\fMDK_Timeline.pas' {frmTimeline},
  frMDK_Comments in 'Frames\frMDK_Comments.pas' {FrameMDK_Comments: TFrame},
  frMDK_StudyNoteSection in 'Frames\frMDK_StudyNoteSection.pas' {FrameStudyNoteSection: TFrame},
  fMDK_Comments in 'Forms\fMDK_Comments.pas' {frmComment},
  fMDK_PainAssessmentDLG in 'Forms\fMDK_PainAssessmentDLG.pas' {dlgPainAssessment},
  frMDK_TIUNotes in 'Frames\frMDK_TIUNotes.pas' {FrameMDK_TIUNotes: TFrame},
  uMDK_Workflow in 'Objects\uMDK_Workflow.pas',
  uMDK_FieldFactory in 'Objects\uMDK_FieldFactory.pas',
  fr_Simple in 'Frames\fr_Simple.pas' {frSimpleFrame: TFrame},
  frMDK_Assessment in 'Frames\frMDK_Assessment.pas' {frAssessment: TFrame},
  iMDK_Assessment in 'Interfaces\iMDK_Assessment.pas',
  iMDK_Presenter in 'Interfaces\iMDK_Presenter.pas',
  uMDK_FallsCollector in 'Services\uMDK_FallsCollector.pas',
  uMDK_SrvController in 'Services\uMDK_SrvController.pas',
  fMDK_DateTimeSelector in 'Forms\fMDK_DateTimeSelector.pas' {dlgDateTime},
  uMDK_PainCollector in 'Services\uMDK_PainCollector.pas',
  fMDK_GeneralInfoDLG in 'Forms\fMDK_GeneralInfoDLG.pas' {frmGeneralInfo},
  uMDK_GeneralInfoCollector in 'Services\uMDK_GeneralInfoCollector.pas',
  fMDK_ListDLG in 'Forms\fMDK_ListDLG.pas' {frmDefaults},
  fMDK_Studies in 'Forms\fMDK_Studies.pas' {frmStudies},
  iMDK_DBConnection in 'Interfaces\iMDK_DBConnection.pas',
  uMDK_RPCEvent in '..\UTILS\uMDK_RPCEvent.pas',
  uZZ_RPCEvent in '..\ZZZ\uZZ_RPCEvent.pas',
  fZZ_EventLog in '..\ZZZ\fZZ_EventLog.pas' {frmEventLog},
  uZZ_DescribedItem in '..\ZZZ\uZZ_DescribedItem.pas';

{$R *.res}

{$IFNDEF AANTEST}
 { $ DEFINE AANTEST}// Remove for production
{$ENDIF}
{$IFDEF SINGLE_COPY}

var
  Mutex: THandle;

begin
  Mutex := CreateMutex(nil, True, 'Hemodialysis-Alpha');
  if (Mutex <> 0) and (GetLastError = 0) then
{$ENDIF}
    begin
      ApplicationSessionID := FormatDateTime('yyyy-mm-dd hh:mm:ss.zzz', Now);

      Application.Initialize;
      Application.CreateForm(TfrmBlank, frmBlank);
  SplashOn;
      if GMVConnect then
        begin
         // SplashOff;  // 09/18/2012 zzzzzzcarnej
          Application.CreateForm(TdmData, dmData);
          Application.CreateForm(TfrmMDK_Report, frmMDK_Report);
          Application.CreateForm(TfrmMDK_CDS, frmMDK_CDS);
          Application.CreateForm(TfrmLog, frmLog);
          Application.CreateForm(TfrmCover, frmCover);
          Application.CreateForm(TfrmAccess, frmAccess);
          Application.CreateForm(TfrmRxLab, frmRxLab);
          Application.CreateForm(TfrmPre, frmPre);
          Application.CreateForm(TfrmPost, frmPost);
          Application.CreateForm(TfrmFlow, frmFlow);
          Application.CreateForm(TfrmSummary, frmSummary);
          Application.CreateForm(TfrmSubmit, frmSubmit);
          Application.CreateForm(TfrmMain, frmMain);
          Application.CreateForm(TfrmWait, frmWait);
          Application.CreateForm(TfrmListEdit, frmListEdit);
          if not frmMain.Connect then
            Application.Terminate
          else
            begin
              InitTimeOut(frmMain.ShutDown);
              UpdateTimeOutInterval(1000);
              Application.Title := 'Hemodialysis Application';
              Application.HelpFile := 'Hemodialysis.hlp';
              frmMain.pnlToolbar.Visible := True;;
              frmMain.UpdateSB;
              frmMain.acPatientSelectExecute(nil);
              Application.Run;
              ShutDownTimeOut;
            end;
      end
    else
      Application.Terminate;
{$IFDEF SINGLE_COPY}
      if Mutex <> 0 then
        CloseHandle(Mutex);
    end
  else
    begin
      ShowMessage('Sorry, only one copy of the application is available...');
    end;
{$ENDIF}
end.

