unit uMDK_MedList;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Medication List object
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_MedList.pas $
  *
  *       $ History: uMDK_MedList.pas $
}
interface

uses
  SysUtils, DB, DBClient;

const
  fnML_ID = 'ID'; // zzzzzzandria 20070412
  // fnML_TYPE = 'TYPE_ID'; // zzzzzzandria 20070412
  fnML_ParentID       = 'ParentID'; // zzzzzzandria 20070412
  fnML_PatientID      = 'PatientID';
  fnML_StudyID        = 'StudyID';
  fnML_Date           = 'StudyDate';
  fnML_Time           = 'DateTime';
  fnML_Status         = 'Status';
  fnML_StatusDate     = 'StatusDate';
  fnML_StatusBy       = 'StatusBy';
  fnML_Source         = 'Source';
  fnML_StatusReasonID = 'StatusReasonID';
  fnML_Medication     = 'Medication';
  fnML_Dose           = 'Dose';
  fnML_Rout           = 'Route';
  // PO, IP, IV, IM, Sucutaneous, topical, sublingual, intradermal
  fnML_Units    = 'Units';
  fnML_Reason   = 'Reason';
  fnML_GivenBy  = 'GivenBy';
  fnML_Outcome  = 'Outcome';
  stML_DELETED  = 'DELETED';
  stML_REPLACED = 'REPLACED';
procedure CreateMedListCDS(aCDS: TClientDataSet; aMaster: TDataSource);
procedure setMedListFields(aCDS: TClientDataSet);
procedure setMedListSpecificFields(aCDS: TClientDataSet);

implementation

uses
  uMDK_CDSCommon, uMDK_Common, uMDK_Summary;

procedure setMedListSpecificFields(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnML_Medication, 'Medication', 20, 200);
    NewFloatField(aCDS, fnML_Dose, 'Dose');
    NewStringField(aCDS, fnML_Units, 'Units', 6, 12);
    NewStringField(aCDS, fnML_Rout, 'Route', 6, 12);
    NewStringField(aCDS, fnML_GivenBy, 'Given By', 20, 50);
    NewStringField(aCDS, fnML_Reason, 'Reason', 40, 200);
    NewStringField(aCDS, fnML_Outcome, 'Outcome', 40, 1000);
  except
  end;
end;

procedure setMedListFields(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnML_ID, fnML_ID, LENGTH_ID, LENGTH_ID);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_ParentID, fnML_ParentID, LENGTH_ID, LENGTH_ID);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_PatientID, '#', 4, 20);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_StudyID, 'Study #', 4, 20);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewDateTimeField(aCDS, fnML_Date, 'Date', 8, gMDK_DateFMT);
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
    NewTimeField(aCDS, fnML_Time, 'Time', 8, gMDK_TimeFMT);
    TDateTimeField(aCDS.FieldList.Fields[aCDS.FieldList.Count - 1]).EditMask := '00:00:00';
    NewStringField(aCDS, fnML_Status, '  ', 4, 8);
    NewDateTimeField(aCDS, fnML_StatusDate, 'DateTime', 8, gMDK_DateTimeFMT);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_StatusBy, 'StatusBy', 8, 60);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_StatusReasonID, fnML_StatusReasonID, 8, 60);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    NewStringField(aCDS, fnML_Source, fnML_Source, 4, 20);
{$IFDEF AANTEST}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := True;
{$ELSE}
    aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
    setMedListSpecificFields(aCDS);
  except
  end;
end;

procedure CreateMedListCDS(aCDS: TClientDataSet; aMaster: TDataSource);
begin
  try
    setMedListFields(aCDS);
    aCDS.CreateDataSet;
    aCDS.AddIndex('MedList_Index', { fnML_StudyID + ';'+ } fnML_Date + ';' + fnML_Time, [ixDescending]);
    aCDS.IndexDefs.Update;
    aCDS.IndexName := 'MedList_Index';
    aCDS.Filter := fnML_Status + '<>''' + stML_DELETED + ''' and ' + fnML_Status + '<>''' + stML_REPLACED + '''';
    aCDS.Filtered := True;
  except
  end;
end;

end.
