unit uMDK_ReportList;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     ReportList object
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_ReportList.pas $
  *
  *       $ History: uMDK_ReportList.pas $
}
interface

uses
  Classes, Controls, Dialogs;

type
  TMDK_ReportList = class(TObject)
  private
    fReportList: TStringList;
  public
    constructor Create;
    destructor Destroy; override;
    function NewReport: string;
    property NameList: TStringList read fReportList write fReportList;
  end;

implementation

uses
  System.UITypes;

constructor TMDK_ReportList.Create;
begin
  inherited;
  fReportList := TStringList.Create;
end;

destructor TMDK_ReportList.Destroy;
begin
  fReportList.Free;
  inherited;
end;

function TMDK_ReportList.NewReport: string;
var
  s, InputString: string;
const
  CancelString = '%Cancel';
begin
  repeat
    s := '';
    Result := '';
    InputString := '?';
    InputString := InputBox('New Report', 'New Report Name:', InputString);
    if (InputString <> '') then begin
      if fReportList.IndexOf(InputString) < 0 then begin
        fReportList.Add(InputString);
        Result := InputString;
      end else if MessageDlg('Report name invalid or report with the name' + #13 + #13 + InputString + #13 + #13 +
        'already exists. Would You like to input another name?', mtWarning, [mbYes, mbNo], 0) <> mrYes then begin
        s := CancelString;
        Result := '';
      end;
    end;
  until s <> CancelString;
end;

end.
