unit uMDK_FallsCollector;

interface

uses
  iMDK_Assessment, Forms, Controls;

type
  TSrvFallsCollector = class(TInterfacedObject, I_Assessment)
  private
    fAssessmentType: Integer;
    procedure setAssessmentType(aValue: Integer);
  public
    property AssessmentType: Integer read fAssessmentType write setAssessmentType;
    function getAssessmentText: string;
    function updateAssessmentText(aText: string): string;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

function NewSrvFallsCollector(aType: Integer): TSrvFallsCollector;

implementation

uses
  fMDK_FallAssessement, dMDK_Data, uMDK_Summary, uMDK_Engine, SysUtils;

function NewSrvFallsCollector(aType: Integer): TSrvFallsCollector;
begin
  Result := TSrvFallsCollector.Create;
  Result.AssessmentType := aType;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TSrvFallsCollector.setAssessmentType(aValue: Integer);
begin
  fAssessmentType := aValue;
end;

function TSrvFallsCollector.getAssessmentText: string;
begin
  try
    Result := dmData.cdsSummary.FieldByName(fnS_FallAssessment).AsString;
  except
    Result := '';
  end;
end;

function TSrvFallsCollector.updateAssessmentText(aText: string): string;
begin
  Result := '';
  if not Assigned(FallAssessment) then
    try
      Application.CreateForm(TFallAssessment, FallAssessment);
    except
      Exit;
    end;
  FallAssessment.edAge.Text := Engine.CurrentPatient.Age;
  if FallAssessment.ShowModal <> mrCancel then begin
    Result := FallAssessment.Report.Text;
    try
      dmData.cdsSummary.Edit;
      dmData.cdsSummary.FieldByName(fnS_FallAssessment).AsString := Result;
      dmData.cdsSummary.Post;
    except
      Result := aText;
    end;
  end
  else Result := aText;
  FreeAndNil(FallAssessment);
end;

function TSrvFallsCollector._AddRef;
begin
  Result := -1;
end;

function TSrvFallsCollector._Release;
begin
  Result := -1;
end;

end.
