unit fMDK_Cover;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 10/07/08 1:30p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Cover form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Build309/Tabs/fMDK_Cover.pas $
  *
  *       $ History: fMDK_Cover.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, DBCtrls, DB, UMDK_Info, XMLIntf, ActnList, Buttons, Grids, DBGrids, Mask,
  Menus, FrMDK_TIUNotes, DBClient, ImgList, UMDK_GeneralInfoCollector, Fr_Simple, FrMDK_Assessment, Trpcb,
  CCOWRPCBroker, System.Actions;

type
  TfrmCover = class(TForm)
    PnlCover: TPanel;
    ActionList1: TActionList;
    AcGetInfectionData: TAction;
    AcSelectProvider: TAction;
    Panel2: TPanel;
    PnlPostingsAndInfectiousDeseases: TPanel;
    PnlTreatmentInfo: TPanel;
    PnlInfo: TPanel;
    Label18: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label38: TLabel;
    Label40: TLabel;
    PnlSchedule: TPanel;
    Bevel11: TBevel;
    Label17: TLabel;
    CbReadOnly: TCheckBox;
    PnlTransplantStatus: TPanel;
    DbcWIP: TDBCheckBox;
    DbcReferred: TDBCheckBox;
    RbNonCandidate: TRadioButton;
    RbCandidate: TRadioButton;
    AcReadOnly: TAction;
    DbeCTDate: TDBEdit;
    DbeDiagnosisDate: TDBEdit;
    DbcESRD: TDBComboBox;
    DbeInitialTherapy: TDBEdit;
    DbcModality: TDBComboBox;
    DbcCodeStatus: TDBComboBox;
    BtnSelectProvider: TBitBtn;
    PnlTreatmentHistory: TPanel;
    ScbDetails: TScrollBox;
    PnlInfectiousDiseases: TPanel;
    MmPostings: TRichEdit;
    SpltDetails: TSplitter;
    PnlDiseases: TPanel;
    PnlInfectiousToolbar: TPanel;
    TvVaccination: TTreeView;
    Label2: TLabel;
    PnlPostingsToolbar: TPanel;
    LblDetailsTitle: TLabel;
    PnlPostings: TPanel;
    PopupMenu: TPopupMenu;
    AcFormat: TAction;
    Format1: TMenuItem;
    DbcbMon: TDBCheckBox;
    DbcbTue: TDBCheckBox;
    DbcbWed: TDBCheckBox;
    DbcbTh: TDBCheckBox;
    DbcbFri: TDBCheckBox;
    DbcbSat: TDBCheckBox;
    DbcbSun: TDBCheckBox;
    Splitter1: TSplitter;
    Bevel1: TBevel;
    Label5: TLabel;
    PnlCurrentTreatmentToolbar: TPanel;
    Label12: TLabel;
    PnlPatientHistory: TPanel;
    PnlTreatmentHistoryToolbar: TPanel;
    Label13: TLabel;
    PnlSelectedStudyToolbar: TPanel;
    Label14: TLabel;
    PgcHistory: TPageControl;
    TsSummary: TTabSheet;
    PnlPast: TPanel;
    PnlTiming: TPanel;
    Bevel5: TBevel;
    Label170: TLabel;
    Label353: TLabel;
    Label6: TLabel;
    Label156: TLabel;
    DbtStarted: TDBText;
    DbtFinished: TDBText;
    DbtDInstrument: TDBText;
    DbtDAdjusted: TDBText;
    Label7: TLabel;
    Panel15: TPanel;
    Bevel6: TBevel;
    Label84: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label96: TLabel;
    Label98: TLabel;
    Label199: TLabel;
    Label3: TLabel;
    Label45: TLabel;
    Label37: TLabel;
    Label146: TLabel;
    DbtPreBPseat: TDBText;
    DbtPreBPStand: TDBText;
    DbtSH_PostPulse: TDBText;
    DbtSH_PostTemp: TDBText;
    DbtSH_PostWeight: TDBText;
    LblUPostBPSeat: TLabel;
    LblUPostBPStand: TLabel;
    DbtPostBPStand: TDBText;
    DbtPostBPSeat: TDBText;
    LblUPostPulse: TLabel;
    LblUPostPulseStanding: TLabel;
    LblUPostTemp: TLabel;
    LblUPostWeight: TLabel;
    LblUGoalWeight: TLabel;
    DbtSH_GoalWeight: TDBText;
    DbtSH_PreWeight: TDBText;
    DbtSH_PreTemp: TDBText;
    DbtSH_PostPulseStanding: TDBText;
    DbtSH_PrePulse: TDBText;
    DbtSH_PrePulseStanding: TDBText;
    PnlSummary: TPanel;
    Bevel4: TBevel;
    Label173: TLabel;
    Label175: TLabel;
    Label181: TLabel;
    Label183: TLabel;
    Label177: TLabel;
    Label179: TLabel;
    Label185: TLabel;
    Label187: TLabel;
    Label189: TLabel;
    Label192: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    DbtTotUF: TDBText;
    DbtTotLP: TDBText;
    DbtmeanURF: TDBText;
    DbtMeanTMP: TDBText;
    DbtAvBFR: TDBText;
    DbtAvDFR: TDBText;
    DbtMeanTemp: TDBText;
    DbtMeanConduct: TDBText;
    DbtTotKT: TDBText;
    DbtTotKTV: TDBText;
    DbtURR: TDBText;
    DbtEstVol: TDBText;
    Panel6: TPanel;
    DbtStudyNumber: TDBText;
    Cds: TClientDataSet;
    Ds: TDataSource;
    IlStatus: TImageList;
    DbeNephrologist: TDBEdit;
    AcDiagnosisDate: TAction;
    AcTherapyDate: TAction;
    BbDiagnosisDate: TBitBtn;
    BbInitialTherapy: TBitBtn;
    AcTreatmentDate: TAction;
    Panel1: TPanel;
    BbTreatmentDate: TBitBtn;
    GeneralInfo: TfrAssessment;
    ActionList2: TActionList;
    AcPrint: TAction;
    PrintDialog1: TPrintDialog;
    ImgDemoBackground: TImage;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    LblSelectedStudy: TLabel;
    CoverMainMenu: TMainMenu;
    MiDocuments: TMenuItem;
    Print1: TMenuItem;
    DbtSelectedDate: TDBText;
    Bevel2: TBevel;
    DbtStudySessionDate: TDBEdit;
    SplInfo: TSplitter;
    PnlInfoAssessment: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure RbNonCandidateClick(Sender: TObject);
    procedure MmPostingsSelectionChange(Sender: TObject);
    procedure AcGetInfectionDataExecute(Sender: TObject);
    procedure AcSelectProviderExecute(Sender: TObject);
    procedure AcReadOnlyExecute(Sender: TObject);
    procedure DbeDiagnosisDateChange(Sender: TObject);
    procedure DbeCTDateContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure DbeCTDateEnter(Sender: TObject);
    procedure DbeDiagnosisDateEnter(Sender: TObject);
    procedure DbeCTDateExit(Sender: TObject);
    procedure AcFormatExecute(Sender: TObject);
    procedure AcDiagnosisDateExecute(Sender: TObject);
    procedure AcTherapyDateExecute(Sender: TObject);
    procedure AcTreatmentDateExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AcPrintExecute(Sender: TObject);
    procedure PgcHistoryChange(Sender: TObject);
    procedure DbeDiagnosisDateExit(Sender: TObject);
    procedure DbeCTDateChange(Sender: TObject);
    procedure DbeDiagnosisDateContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
  private
    DBG: TDBGrid;
    FField: TField;
    FActive: TObject;
    FIgnore: Boolean;
    FAllergiesTxt: string;
    FDirectivesTxt: string;
    FWarningsTxt: string;
    FVaccinationTxt: string;
{$IFDEF GENERALINFO_FRAME}
    FGeneralInfoCollector: TSrvGeneralInfoCollector;
{$ENDIF}
    procedure SetWarnings(AValue: string);
    procedure SetAllergies(AValue: string);
    procedure SetDirectives(AValue: string);
    procedure SetVaccination(AValue: string);
    procedure SetMemo;
    procedure SetMemoItem(AName, AValue, ADefault: string);
    procedure MapFields;
    procedure SetUpLayout;
    procedure DbgHistoryDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure SetESRD;
  public
    property Ignore: Boolean read FIgnore write FIgnore;
    property AllergiesTxt: string read FAllergiesTxt write SetAllergies;
    property DirectivesTxt: string read FDirectivesTxt write SetDirectives;
    property WarningsTxt: string read FWarningsTxt write SetWarnings;
    property VaccinationTxt: string read FVaccinationTxt write SetVaccination;
    procedure ReportStatus;
    procedure ReloadData;
    procedure RefreshGUI;
    procedure SetReadOnly(AReadOnly: Boolean);
    procedure DBGridDblClick(Sender: TObject);
    procedure RefreshTIU;
    procedure DbgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ActivateTabForm;
    procedure SaveData;
    function CanDeactivate(var Reason: string): Boolean;
    function GetMainMenu: TMainMenu;
    procedure SetMainMenuVisible(AValue: Boolean);
  end;

var
  FrmCover: TfrmCover;

implementation

uses
  UROR_CommonUtils, DMDK_Data, UMDK_Engine, UMDK_Summary, UXML,
  UMDK_Common, UMDK_Options, UMDK_CDSCommon, FMDK_SelectProvider,
  UMDK_ReportEngine, UMDK_Dictionary, FMDK_DictionaryEdit, Printers, FMDK_Submit, UMDK_Notes, FMDK_DateTimeSelector,
{$IFDEF RPCLOG}
  FZZ_EventLog, UZZ_DescribedItem,
{$ENDIF}
  FMDK_Studies;
{$R *.dfm}

function IsValidDateString(AString: string): Boolean;
begin
  Result := False;
  try
    StrToDateTime(AString);
    Result := True;
  except
  end;
end;

procedure TfrmCover.MapFields;
begin
  DbtStudySessionDate.DataField := FnS_SessionDate; // Summary Session Date
  DbtStudyNumber.DataField := FnS_SessionID;
  DbeCTDate.DataField := FnI_StudyDate; // Study Info Date
  DbcESRD.DataField := FnI_Diagnosis;
  DbeDiagnosisDate.DataField := FnI_DiagnosisDate;
  DbeInitialTherapy.DataField := FnI_TherapyDate;
  DbcModality.DataField := FnI_Modality;
  DbcCodeStatus.DataField := FnI_CodeStatus;
  DbeNephrologist.DataField := FnI_Nephrologist;
  DbcbMon.DataField := FnI_Mon;
  DbcbTue.DataField := FnI_Tue;
  DbcbWed.DataField := FnI_Wed;
  DbcbTh.DataField := FnI_Thu;
  DbcbFri.DataField := FnI_Fri;
  DbcbSat.DataField := FnI_Sat;
  DbcbSun.DataField := FnI_sun;
  DbtSH_PreWeight.DataField := FnS_PreWeight;
  DbtSH_PostWeight.DataField := FnS_PostWeight;
  DbtSH_GoalWeight.DataField := FnS_RxGoalWeight;
  DbtSH_PreTemp.DataField := FnS_PreTemp;
  DbtSH_PrePulse.DataField := FnS_PrePulseSeated;
  DbtSH_PrePulseStanding.DataField := FnS_PrePulseStanding;
  DbtSH_PostTemp.DataField := FnS_PostTemp;
  DbtSH_PostPulse.DataField := FnS_PostPulseSeated;
  DbtSH_PostPulseStanding.DataField := FnS_PostPulseStanding;
  // Transplant Status /////////////////////////////////////////////////////////
  DbcWIP.DataField := FnS_TrnWIP;
  DbcReferred.DataField := FnS_TrnReferred;
  DbtStarted.DataField := FnS_TreatmentStarted;
  DbtFinished.DataField := FnS_TreatmentFinished;
  DbtDInstrument.DataField := FnS_TreatmentDuration;
  DbtDAdjusted.DataField := FnS_TreatmentDurationManual;
  DbtTotUF.DataField := FnS_TotalUF;
  DbtTotLP.DataField := FnS_TotalLP;
  DbtmeanURF.DataField := FnS_MeanUFR;
  DbtMeanTMP.DataField := FnS_MeanTMP;
  DbtAvDFR.DataField := FnS_AverageDFR;
  DbtAvBFR.DataField := FnS_AverageBFR;
  DbtMeanConduct.DataField := FnS_MeanConductivity;
  DbtMeanTemp.DataField := FnS_MeanTemp;
  DbtTotKTV.DataField := FnS_TotalKTV;
  DbtTotKT.DataField := FnS_TotalKT;
  DbtURR.DataField := FnS_TotalURR;
  DbtEstVol.DataField := FnS_TotalEUV; // zzzzzzandria 20070531
  DbtSelectedDate.DataField := FnS_SessionDate;
  Preferences.BValue(OnShowPatientTreatmentHistory);
end;

procedure TfrmCover.FormCreate(Sender: TObject);
  function CreateHistoryDBG(AParent: TWinControl): TDBGrid;
  var
    _DBG: TDBGrid;
    procedure SetupColumn(ATitleCaption, AFieldName: string; AWidth: Integer = 65; AColor: TColor = ClNavy);
    var
      DBC: TColumn;
    begin
      DBC := _DBG.Columns.Add;
      DBC.Font.Color := AColor;
      DBC.Title.Caption := ATitleCaption;
      DBC.Title.Alignment := TaRightJustify;
      DBC.Alignment := TaRightJustify;
      DBC.Width := AWidth;
      DBC.FieldName := AFieldName;
    end;

  begin
    _DBG := TDBGrid.Create(AParent);
    _DBG.Parent := PnlTreatmentHistory;
    _DBG.Align := AlClient;
    _DBG.ParentColor := True;
    _DBG.Ctl3D := False;
    _DBG.ReadOnly := True;
    _DBG.BorderStyle := BsNone;
    _DBG.FixedColor := Preferences.IValue(OnReadOnlyFieldColor);
    _DBG.Options := _DBG.Options - [DgColLines, DgTabs] + [DgRowSelect];
    _DBG.OnDblClick := DBGridDblClick;
    _DBG.OnDrawColumnCell := DbgHistoryDrawColumnCell;
    _DBG.OnKeyDown := DbgKeyDown;
    SetupColumn('Check In Date', FnS_SessionDate, 75, ClWindowText);
    SetupColumn('IA BF', FnS_IABF);
    SetupColumn('APV @ 0', FnS_AVP0);
    SetupColumn('VP @ 0', FnS_VP0);
    SetupColumn('VP @ 200', FnS_VP200, 75);
    SetupColumn('Study #', FnS_SessionID, 50);
    SetupColumn('Comments', 'Comments', 75);
    // setupColumn('Received Last Rec.', fnS_LastRecord, 40); // zzzzzzandria 20091015
    _DBG.DataSource := DmData.DsStudyHistory;
    _DBG.Show;
    Result := _DBG;
  end;

begin
  FIgnore := True;
  MapFields;
  DBG := CreateHistoryDBG(PnlTreatmentHistory);
{$IFDEF GENERALINFO_FRAME}
  FGeneralInfoCollector := NewSrvGeneralInfoCollector;
  GeneralInfo.SetAssessmentInterface(FGeneralInfoCollector);
  GeneralInfo.SetAssessmentCaption('General Information');
  PnlInfoAssessment.Visible := True;
  PnlTreatmentInfo.Visible := False;
{$ELSE}
  PnlInfoAssessment.Visible := False;
  SplInfo.Visible := False;
  PnlPostingsAndInfectiousDeseases.Align := AlClient;
{$ENDIF}
  FIgnore := False;
end;

procedure TfrmCover.SetMemoItem(AName, AValue, ADefault: string);
var
  ILen: Integer;
begin
  FIgnore := True;
  with MmPostings do begin
    ILen := Length(AName);
    Lines.Add(AName);
    SelStart := SelStart - ILen - 2;
    SelLength := ILen;
    if AValue = '' then Lines.Add(ADefault)
    else Lines.Add(AValue);
  end;
  FIgnore := False;
end;

procedure TfrmCover.SetMemo;
begin
  FIgnore := True;
  with MmPostings do begin
    Clear;
    SetMemoItem('Allergies', FAllergiesTxt, 'None');
    SetMemoItem('Clinical Warnings', FWarningsTxt, 'None');
    SetMemoItem('Advanced Directives', FDirectivesTxt, 'None');
  end;
  FIgnore := False;
end;

procedure TfrmCover.SetVaccination(AValue: string);
var
  ASL: TStringList;
  SItem, SDate, SValue, SReaction, S: string;
  I: Integer;
  SMG, STB, SPPD, SHepA, SHepB, SHepBSAntigen, SHepBSAntibody, SHepBVac, SHepC, SHepCSAntibody, SVac, SPN,
    SInfl: string;
{$IFDEF AANTEST}
  TnUnknown,
{$ENDIF}
  TnHA, TnHB, TnHC, TnVac, TnTB, TnHBSB, TnHBSAG, TnHBV, TnHCSA, TnPPD, TnInfl, TnPne, Tvn: TTreeNode;
  function FindNode(AKey: string): TTreeNode;
  var
    J: Integer;
  begin
    Result := nil;
    for J := 0 to TvVaccination.Items.Count - 1 do
      if Piece(TvVaccination.Items[J].Text, '--', 1) = Piece(AKey, '--', 1) then begin
        Result := TvVaccination.Items[J];
        Exit;
      end;
  end;
  function FindMatch(AKey: string): TTreeNode;
  var
    Ss: string;
    Kn: TTreeNode;
  begin
    Kn := nil;
    Ss := Piece(AKey, '^', 1);
    if Ss = 'PPD' then Kn := TnPPD
    else if Ss = 'HEPATITIS A' then Kn := TnHA
    else if Ss = 'HEPATITIS B' then Kn := TnHBV
    else if Ss = 'FLU' then Kn := TnInfl
    else if Ss = 'PNEUMOCOCCAL' then Kn := TnPne;
    Result := Kn;
  end;
  procedure BlankNode(ANode: TTreeNode);
  const
    Ss = 'No data available';
  begin
    if ANode.Count <> 0 then Exit;
    ANode.Text := ANode.Text + ' -- ' + Ss;
    ANode.Collapse(True);
  end;
  procedure BlankLabNode(ANode: TTreeNode);
  const
    Ss = 'No data available. Check Lab Results.';
  begin
    if ANode.Count <> 0 then Exit;
    ANode.Text := ANode.Text + ' -- ' + Ss;
    ANode.Collapse(True);
  end;

const
  _Hep_A     = 'Hepatitis A';
  _Hep_B     = 'Hepatitis B';
  _Hep_B_SAg = 'Surface Antigen';
  _Hep_B_SAb = 'Surface Antibody';
  _Hep_B_V   = 'Hepatitis B Vaccine Series';
  _Hep_C     = 'Hepatitis C';
  _Hep_C_SAb = 'Surface Antibody';
  _TB        = 'TB';
  _PPD       = 'PPD';
  _Vac       = 'Vaccines';
  _Infl      = 'Influenza';
  _PV        = 'Pneumococcal Vaccine';
  _NDA       = '    No data available';
  _NDALab    = '    No data available. Check Lab Results.';
  _Tab_      = '    ';
  function CheckNoData(AValue, ADefault, ANDA: string): string;
  begin
    Result := AValue;
    if Trim(AValue) = Trim(ADefault) then Result := Result + ANDA;
  end;

begin
  FVaccinationTxt := AValue;
  SMG := _Tab_ + _Tab_;
  SHepA := _Hep_A;
  SHepB := _Hep_B;
  SHepBSAntigen := _Tab_ + _Hep_B_SAg;
  SHepBSAntibody := _Tab_ + _Hep_B_SAb;
  SHepBVac := _Tab_ + _Hep_B_V;
  SHepC := _Hep_C;
  SHepCSAntibody := _Tab_ + _Hep_C_SAb;
  STB := _TB;
  SPPD := _Tab_ + _PPD;
  SVac := _Vac;
  SInfl := _Tab_ + _Infl;
  SPN := _Tab_ + _PV;
  TvVaccination.Items.Clear;
  with TvVaccination do begin
    TnHA := Items.AddChild(nil, _Hep_A);
    TnHB := Items.AddChild(nil, _Hep_B);
    TnHBSB := Items.AddChild(TnHB, _Hep_B_SAb);
    TnHBSAG := Items.AddChild(TnHB, _Hep_B_SAg);
    TnHBV := Items.AddChild(TnHB, _Hep_B_V);
    TnHC := Items.AddChild(nil, _Hep_C);
    TnHCSA := Items.AddChild(TnHC, _Hep_C_SAb);
    TnTB := Items.AddChild(nil, _TB);
    TnPPD := Items.AddChild(TnTB, _PPD);
    TnVac := Items.AddChild(nil, _Vac);
    TnInfl := Items.AddChild(TnVac, _Infl);
    TnPne := Items.AddChild(TnVac, _PV);
{$IFDEF AANTEST}
    TnUnknown := Items.AddChild(nil, 'Unknown');
{$ENDIF}
  end;
  ASL := TStringList.Create;
  ASL.Text := AValue;
  try
    for I := 0 to ASL.Count - 1 do begin
      try
        S := ASL[I];
        if Pos('Vaccination:', S) = 1 then Continue;
        SItem := Piece(S, '^', 1);
        SValue := Piece(S, '^', 2);
        SReaction := Piece(S, '^', 3);
        if SReaction <> '' then SReaction := ' (' + SReaction + ')';
        if Pos('.', SValue) = 0 then SValue := SValue + '.0'; // Patch zzzzzzandria 050414
        try
          SDate := FormatDateTime(GMDK_DateFMT, FMDateTimeToWindowsDateTime(StrToFloat(SValue)));
        except
          SDate := 'Unknown';
        end;
      except
      end;
      Tvn := FindMatch(S);
      if Tvn <> nil then begin
        S := SItem + ' -- ' + SDate{$IFDEF AANTEST} + '  ' + SReaction{$ENDIF};
        if Tvn = TnPPD then SPPD := SPPD + _CR_ + '<' + SMG + S + '>' { + _CR_ }
        else if Tvn = TnHA then SHepA := SHepA + _CR_ + '<' + SMG + S + '>' { + _CR_ }
        else if Tvn = TnHB then SHepB := SHepB + _CR_ + '<' + SMG + S + '>' { + _CR_ }
        else if Tvn = TnHBV then SHepBVac := SHepBVac + _CR_ + '<' + SMG + S + '>' { + _CR_ }
        else if Tvn = TnInfl then SInfl := SInfl + _CR_ + '<' + SMG + S + '>' { + _CR_ }
        else if Tvn = TnPne then SPN := SPN + _CR_ + '<' + SMG + S + '>' { + _CR_ };
        TvVaccination.Items.AddChild(Tvn, S);
      end
{$IFDEF AANTEST}
      else TvVaccination.Items.AddChild(TnUnknown, S);
{$ENDIF}
    end;
  except
  end;
  ASL.Free;
  TnHA.Expand(False);
  TnHB.Expand(False);
  TnHC.Expand(False);
  TnPPD.Expand(False);
  TnVac.Expand(False);
  TnTB.Expand(False);
  BlankNode(TnHA);       // := Items.AddChild(nil,'Hepatitis A');
  BlankNode(TnHB);       // tnHB := tvn;
  BlankLabNode(TnHBSB);  // tnHBSB := Items.AddChild(tvn,'Surface Antibody');
  BlankLabNode(TnHBSAG); // tnHBSAG := Items.AddChild(tvn,'Surface Antigen');
  BlankNode(TnHBV);      // tnHBV := Items.AddChild(tvn,'Hepatitis B Vaccine Series');
  BlankNode(TnHC);       // tnHC := tvn;
  BlankLabNode(TnHCSA);  // tnHCSA := Items.AddChild(tvn,'Surface Antibody');
  BlankNode(TnPPD);      // tnPPD := Items.AddChild(tvn,'PPD');
  BlankNode(TnInfl);     // tnInfl := Items.AddChild(tvn,'Influenza');
  BlankNode(TnPne);      // tnPne := Items.AddChild(tvn,'Pneumococcal Vaccine');
  TvVaccination.FullCollapse;
  TnHA.Collapse(False);
  TnHB.Collapse(False);
  TnHC.Collapse(False);
  if not Preferences.BValue(OnShowInfectionTree) then begin
    SetMemoItem('Infectious Diseases', CheckNoData(SHepA, _Hep_A, _NDA) + _CR_ +
      // CheckNoData(sHepB,_Hep_B,_NDA) +  _CR_+
      SHepB + _CR_ + CheckNoData(SHepBSAntigen, _Hep_B_SAg, _CR_ + _Tab_ + '<' + _NDALab + '>') + _CR_ +
      CheckNoData(SHepBSAntibody, _Hep_B_SAb, _CR_ + _Tab_ + '<' + _NDALab + '>') + _CR_ + CheckNoData(SHepBVac,
      _Hep_B_V, _NDA) + _CR_ + SHepC + _CR_ + CheckNoData(SHepCSAntibody, _Hep_C_SAb,
      _CR_ + _Tab_ + '<' + _NDALab + '>') + _CR_ + STB + _CR_ + CheckNoData(SPPD, _PPD, _NDA) + _CR_ + SVac + _CR_ +
      CheckNoData(SInfl, _Infl, _NDA) + _CR_ + CheckNoData(SPN, _PV, _NDA) + _CR_, 'No data available');
    PaintSyntax(MmPostings, False);
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.RbNonCandidateClick(Sender: TObject);
begin
  if Ignore then Exit;
  try
    DmData.CdsSummary.Edit;
    DmData.CdsSummary.FieldByName(FnS_TrnCandidate).AsBoolean := RbCandidate.Checked;
    if not RbCandidate.Checked then begin
      DmData.CdsSummary.FieldByName(FnS_TrnWIP).AsBoolean := False;
      DmData.CdsSummary.FieldByName(FnS_TrnReferred).AsBoolean := False;
    end;
    DmData.CdsSummary.Post;
  except
  end;
  DbcWIP.Enabled := RbCandidate.Checked;
  DbcReferred.Enabled := RbCandidate.Checked;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.SetWarnings(AValue: string);
begin
  FWarningsTxt := AValue;
end;

procedure TfrmCover.SetAllergies(AValue: string);
begin
  FAllergiesTxt := AValue;
end;

procedure TfrmCover.SetDirectives(AValue: string);
begin
  FDirectivesTxt := AValue;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.MmPostingsSelectionChange(Sender: TObject);
begin
  if not Ignore then Exit;
  if (MmPostings.SelLength > 0) and (MmPostings.SelStart >= 0) then begin
    MmPostings.SelAttributes.Color := ClNavy;
    MmPostings.SelAttributes.Style := [FsBold];
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.AcGetInfectionDataExecute(Sender: TObject);
begin
  VaccinationTxt := Engine.PatientVaccination;
end;

procedure TfrmCover.AcSelectProviderExecute(Sender: TObject);
var
  S: string;
begin
  S := SelectProvider('', Engine.FRenalController, 5);
  S := Piece(S, '^', 1);
  if S <> '' then begin
    try
      if DmData.CdsInfo.State <> DsEdit then DmData.CdsInfo.Edit;
      DbeNephrologist.Text := S;
      DmData.CdsInfo.Post;
    except
      on E: Exception do ShowMessage(E.Message);
    end;
  end;
end;

procedure TfrmCover.AcReadOnlyExecute(Sender: TObject);
var
  BReadOnly: Boolean;
  procedure SetUpField(AF: TDBEdit);
  begin
    AF.Enabled := not BReadOnly;
    CheckDBField(AF);
  end;
  procedure SetUpComboField(AF: TDBComboBox);
  begin
    AF.Enabled := not BReadOnly;
    CheckDBField(AF);
  end;

begin
  BReadOnly := CbReadOnly.Checked;
  PnlInfo.Enabled := not BReadOnly;
  PnlSchedule.Enabled := not BReadOnly;
  DbcbMon.Enabled := not BReadOnly;
  DbcbTue.Enabled := not BReadOnly;
  DbcbWed.Enabled := not BReadOnly;
  DbcbTh.Enabled := not BReadOnly;
  DbcbFri.Enabled := not BReadOnly;
  DbcbSat.Enabled := not BReadOnly;
  DbcbSun.Enabled := not BReadOnly;
  BtnSelectProvider.Enabled := not BReadOnly;
  BbDiagnosisDate.Enabled := not BReadOnly;
  BbInitialTherapy.Enabled := not BReadOnly;
  BbTreatmentDate.Enabled := not BReadOnly;
  SetUpField(DbtStudySessionDate);
  SetUpField(DbeCTDate);
  SetUpComboField(DbcESRD);
  SetUpField(DbeDiagnosisDate);
  SetUpField(DbeInitialTherapy);
  SetUpComboField(DbcModality);
  SetUpComboField(DbcCodeStatus);
  SetUpField(DbeNephrologist);
  DbeNephrologist.ReadOnly := True; // build 312 update #28
  RbCandidate.Enabled := not BReadOnly;
  RbNonCandidate.Enabled := not BReadOnly;
  DbcWIP.Enabled := not BReadOnly and RbCandidate.Checked;
  DbcReferred.Enabled := not BReadOnly and RbCandidate.Checked;
end;

procedure TfrmCover.SetUpLayout;
begin
  if Preferences.BValue(OnShowInfectionTree) then begin
    SpltDetails.Visible := True;
    SpltDetails.Align := AlRight;
    PnlInfectiousDiseases.Visible := True;
    PnlPostings.Align := AlLeft;
    PnlPostings.Width := 135;
    SpltDetails.Align := AlLeft;
    LblDetailsTitle.Caption := 'Recent Postings';
  end else begin
    SpltDetails.Align := AlRight;
    SpltDetails.Visible := False;
    PnlInfectiousDiseases.Visible := False;
    PnlPostings.Align := AlClient;
    LblDetailsTitle.Caption := 'Recent Postings && Infectious Diseases';
  end;
{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.PnlToolbar.Color := Preferences.IValue(OnColorToolbar);
{$ENDIF}
  PnlCurrentTreatmentToolbar.Color := Preferences.IValue(OnColorToolbar);
  PnlTreatmentHistoryToolbar.Color := Preferences.IValue(OnColorToolbar);
  PnlInfectiousToolbar.Color := Preferences.IValue(OnColorToolbar);
  PnlPostingsToolbar.Color := Preferences.IValue(OnColorToolbar);
  PnlSelectedStudyToolbar.Color := Preferences.IValue(OnColorToolbar);
  SetReadOnly(Engine.CurrentPatient.ReadOnly);
end;

procedure TfrmCover.DbeDiagnosisDateChange(Sender: TObject);
begin
  if FIgnore then Exit;
  if (Sender is TDBEdit) and (TDBEdit(Sender).Field.Name = FnI_DiagnosisDate) then
    if TDBEdit(Sender).Field.AsString = '12/30/1899' then TDBEdit(Sender).Text := ''
    else SetESRD; // zzzzzzandria 2012-06-13. v.1.0.29.10 ICD-10 Remediation
  ReportStatus;
end;

procedure TfrmCover.ReloadData;
begin
  AllergiesTxt := Engine.PatientAllergies;
  DirectivesTxt := Engine.PatientDirectives;
  WarningsTxt := Engine.PatientWarnings;
  // zzzzzzandria 20081003 1.0.6.320 ------------------------------------- begin
  VaccinationTxt := Engine.PatientVaccination; // uncommented on 20081003
  // zzzzzzandria 20081003 1.0.6.320 --------------------------------------- end
  RbCandidate.Checked := DmData.CdsSummary.FieldByName(FnS_TrnCandidate).AsBoolean;
  RbNonCandidate.Checked := not DmData.CdsSummary.FieldByName(FnS_TrnCandidate).AsBoolean;
end;

(* *) // zzzzzzandria 2012-09-13 uncommented
function GetValues(AnOptionName: string): string;
var
  Sl: TStringList;
  I: Integer;
begin
  Sl := nil;
  try
    Result := '';
    Sl := TStringList.Create;
    Sl.Text := Engine.GetSystemOptionByName(AnOptionName);
    for I := 0 to Sl.Count - 1 do Result := Result + Piece(Sl[I], '=', 2) + #13#10;
  finally
    Sl.Free;
  end;
end;
(* *) // zzzzzzandria 2012-08-13

procedure UpdateField(AField: TDBComboBox; SText: string);
var
  SOldValue: string;
begin
  try
    SOldValue := AField.Text;
    AField.Items.Text := SText;
    if SOldValue <> '' then
      try
        AField.Text := SOldValue;
      except
        on E: Exception do ShowMessage(E.Message);
      end;
  except
  end;
end;

procedure TfrmCover.RefreshGUI;
begin
  DmData.CdsInfo.DisableControls;
  DBG.FixedColor := Preferences.IValue(OnReadOnlyFieldColor);
  ScbDetails.Color := Preferences.IValue(OnReadOnlyFieldColor);
  PnlTreatmentHistory.Color := Preferences.IValue(OnReadOnlyFieldColor);
  TvVaccination.Color := Preferences.IValue(OnReadOnlyFieldColor);
  MmPostings.Color := Preferences.IValue(OnReadOnlyFieldColor);
  // reSummaryReport.Color := Preferences.iValue(onReadOnlyFieldColor);
  RbCandidate.Checked := DmData.CdsSummary.FieldByName(FnS_TrnCandidate).AsBoolean;
  RbNonCandidate.Checked := not DmData.CdsSummary.FieldByName(FnS_TrnCandidate).AsBoolean;
  SetMemo;
  SetVaccination(VaccinationTxt);
  // set up units
  LblUPostTemp.Caption := GetDictionaryUnits('cdsSummary', FnS_PreTemp, 'F');
  // Patch 29 (ICD-10 Remediation) zzzzzzandria 2012-06-13
  // updateField(dbcESRD, getValues(onESRD_Diagnosys));
  SetESRD;
  UpdateField(DbcModality, GetValues(OnModalities));
  UpdateField(DbcCodeStatus, GetValues(OnCodeStatuses));
  // dbcNephrologist.Items.Text := getValues(onNephrologiests);
  DmData.CdsInfo.EnableControls;
{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.Re.Color := Preferences.IValue(OnReadOnlyFieldColor);
  GeneralInfo.PnlButtons2D.Visible := not DevOptions.BValue(DonWindowsXPTheme);
  GeneralInfo.PnlButtons3D.Visible := DevOptions.BValue(DonWindowsXPTheme);
{$ENDIF}
  AcReadOnly.Execute; // 2008-04-24 zzzzzzandria
  SetUpLayout;        // 2008-04-18
end;

procedure TfrmCover.DbeCTDateContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// zzzzzzandria 2007-07-12 b. 312 #26
  Exit;                    // zzzzzzandria 20070326 no access to dictionary
{$ENDIF}
  if Engine.CurrentOperatorMode <> RnAdmin then Exit;
  WinCon := TWinControl(Sender);
  // dbeCTDateEnter(Sender);
  PopupMenu.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
end;

procedure TfrmCover.DbeCTDateEnter(Sender: TObject);
begin
  FField := GetActiveField(Sender);
  FActive := Sender;
end;

procedure TfrmCover.DbeCTDateExit(Sender: TObject);
begin
  if not CbReadOnly.Checked then CheckDBField(Sender);
  FField := nil;
  FActive := nil;
end;

procedure TfrmCover.AcFormatExecute(Sender: TObject);
begin
  if FField = nil then Exit;
  try
    UpdateColumnField(FField, FField.DataSet.Name, FField.FieldName);
    CheckDBField(FActive);
  except
  end;
end;

procedure TfrmCover.SetReadOnly(AReadOnly: Boolean);
begin
  // update to support read only access;
  AcReadOnly.Enabled := not AReadOnly;
  PnlTreatmentInfo.Enabled := not AReadOnly;
  PnlCurrentTreatmentToolbar.Enabled := not AReadOnly;
  if not PnlTreatmentInfo.Enabled then PnlTreatmentInfo.Color := Preferences.IValue(OnColorReview)
  else PnlTreatmentInfo.Color := Preferences.IValue(OnColorBackground);
end;

procedure TfrmCover.DbgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  // add code for special actions on DBG
end;

procedure TfrmCover.ActivateTabForm;
begin
{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.AcRefresh.Execute;
{$ENDIF}
  PgcHistoryChange(nil);
end;

procedure TfrmCover.ReportStatus;
var
  S: string;
  function GetFieldReport(AValue, ALabel: string): string;
  begin
    if AValue = '' then Result := ALabel
    else Result := '';
  end;

begin
  SetUpLayout;
  S := '';
  S := S + GetFieldReport(DbeCTDate.Text, 'CurrentTreatment Date, ');
  S := S + GetFieldReport(DbeDiagnosisDate.Text, 'Diagnosis Date, ');
  S := S + GetFieldReport(DbeInitialTherapy.Text, 'Initial Therapy Date, ');
  S := S + GetFieldReport(DbeNephrologist.Text, 'Attending Nephrologist, ');
  S := S + GetFieldReport(DbcESRD.Text, 'ESRD Code, ');
  S := S + GetFieldReport(DbcModality.Text, 'Modality, ');
  S := S + GetFieldReport(DbcCodeStatus.Text, 'Code Status, ');
  if S <> '' then begin
    S := 'Required Fields without data: ' + S;
    S := Copy(S, 1, Length(S) - 2);
    Engine.ReportStatus(PnCover, 1, S);
  end
  else Engine.ReportStatus(PnCover, 0, 'OK');
end;

function TfrmCover.CanDeactivate(var Reason: string): Boolean;
begin
  Reason := '';
  Result := True;
end;

procedure TfrmCover.DBGridDblClick(Sender: TObject);
begin
  RefreshTIU;
end;

procedure TfrmCover.RefreshTIU;
var
  Sl: TStringList;
  Ii: Integer;
  SSL: string;
  Re: TRichEdit;
  SKeyword, STIUID, STIUNote, SValue: string;
const
  IiFalls   = 3;
  IiSummary = 1;
  IiTIU     = 2;
  procedure ReScroll(Memo: TRichEdit; AScrollCode: SmallInt);
  var
    ScrollMessage: TWMVScroll;
    I: Integer;
  begin
    ScrollMessage.Msg := WM_VScroll;
    for I := 0 to Memo.Lines.Count do begin
      ScrollMessage.ScrollCode := AScrollCode; // sb_Top; //sb_LineDown;
      ScrollMessage.Pos := 0;
      Memo.Dispatch(ScrollMessage);
    end;
  end;
  function GetAllNotesReport(AStudy: string): string;
  var
    S: string;
  begin
    Result := '';
    if Engine.FRenalController.GetStudyItem('704.202', '.5', AStudy, S) then begin
      try
        if Cds.Active then Cds.Active := False;
        Cds.XMLData := S;
        Cds.Active := True;
        Result := GetNotesReport('', Cds);
      except
      end;
    end;
  end;
  function GetEdit(ACaption: string; ANum: Integer; AnIndex: Integer): TRichEdit;
  var
    Ts: TTabSheet;
    I: Integer;
  begin
    Result := nil;
    if ANum < PgcHistory.PageCount then Ts := PgcHistory.Pages[ANum]
    else begin
      I := PgcHistory.PageCount;
      repeat
        Ts := TTabSheet.Create(PgcHistory);
        Ts.Name := 'ts_' + IntToStr(I);
        Ts.PageControl := PgcHistory;
        Ts.ImageIndex := AnIndex;
        Ts.Caption := ACaption;
        Result := TRichEdit.Create(Ts);
        Result.Parent := Ts;
        Result.Align := AlClient;
        Result.Show;
        Result.ScrollBars := SsBoth;
        Result.ParentColor := True;
        Result.ReadOnly := True;
        Result.BorderStyle := BsNone;
        Result.WordWrap := False;
        Result.Font.Name := 'Courier New';
        Result.Color := Preferences.IValue(OnReadOnlyFieldColor);
        Inc(I);
      until I >= ANum;
    end;
    if Ts <> nil then
      for I := 0 to Ts.ComponentCount - 1 do
        if Ts.Components[I] is TRichEdit then begin
          Result := TRichEdit(Ts.Components[I]);
          Ts.ImageIndex := AnIndex;
          Ts.TabVisible := True;
          Ts.Caption := ACaption;
          Break
        end;
  end;
  procedure HideTabs;
  var
    I: Integer;
  begin
    if PgcHistory.PageCount - 1 < 1 then Exit;
    try
      for I := 1 to PgcHistory.PageCount - 1 do PgcHistory.Pages[I].TabVisible := False;
    except
    end;
  end;

begin
  try
    HideTabs;
    SValue := Engine.GetNotesByStudyID(DbtStudyNumber.Caption);
    LblSelectedStudy.Caption := DbtStudyNumber.Caption;
    if (SValue <> '') and DevOptions.BValue(OnShowPatientTreatmentHistory) then begin
      Sl := TStringList.Create;
      Sl.Text := SValue;
      // ReSummaryReport.Lines.Text := '';   vjaishandria 2008-04-23
      for Ii := 0 to Sl.Count - 1 do begin
        SSL := Sl[Ii];
        if Pos('-1', SSL) = 1 then Continue;
        STIUID := Piece(SSL, '^', 1);
        STIUNote := Engine.GetNoteByNum(STIUID, STIUID);
        SKeyword := Preferences.SValue(OnReportKeyword);
        if Pos(SKeyword, STIUNote) <> 0 then begin
          Re := GetEdit('Results (TIU ' + STIUID + ')', Ii + 2, IiSummary);
        end else begin
          SKeyword := DevOptions.SValue(DonFallRiskKeyword);
          if Pos(SKeyword, STIUNote) <> 0 then Re := GetEdit('TIU ' + STIUID, Ii + 2, IiFalls)
          else Re := GetEdit('TIU ' + STIUID, Ii + 2, IiTIU);
        end;
        if Assigned(Re) then begin
          Re.Lines.Text := STIUNote;
          ReScroll(Re, Sb_Top);
        end;
      end;
      // reScroll(reSummaryReport, sb_top); zzzzzzandria 2008-04-23
      Sl.Free;
    end;
  except
  end;
  PgcHistoryChange(nil);
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.AcDiagnosisDateExecute(Sender: TObject);
var
  SDate: string;
begin
  SDate := DbeDiagnosisDate.Text;
  if GetDateTime('Select Diagnosis Date', 'mm/dd/yyyy', SDate) = MrOK then
    try
      // fIgnore := True;
      if DmData.CdsInfo.State <> DsEdit then DmData.CdsInfo.Edit;
      DbeDiagnosisDate.Text := SDate;
      // fIgnore := False;
      DmData.CdsInfo.Post;
      SetESRD; // zzzzzzandria 2012-06-13 v.1.0.29.10
    except
      on E: Exception do ShowMessage(E.Message);
    end;
end;

procedure TfrmCover.AcTherapyDateExecute(Sender: TObject);
var
  SDate: string;
begin
  SDate := DbeInitialTherapy.Text;
  if GetDateTime('Select Initial Therapy Date', 'mm/dd/yyyy', SDate) = MrOK then
    try
      // fIgnore := True;
      if DmData.CdsInfo.State <> DsEdit then DmData.CdsInfo.Edit;
      DbeInitialTherapy.Text := SDate;
      // fIgnore := False;
      DmData.CdsInfo.Post;
    except
      on E: Exception do ShowMessage(E.Message);
    end;
end;

procedure TfrmCover.AcTreatmentDateExecute(Sender: TObject);
var
  SDate: string;
begin
  SDate := DbeCTDate.Text;
  if GetDateTime('Select Treatment Date', 'mm/dd/yyyy', SDate) = MrOK then
    try
      // fIgnore := True;
      if DmData.CdsInfo.State <> DsEdit then DmData.CdsInfo.Edit;
      DbeCTDate.Text := SDate;
      // fIgnore := False;
      DmData.CdsInfo.Post;
      (*
        // zzzzzzandria 2007-07-09 ----------------------------------------- Start
        if dmData.cdsSummary.State <> dsEdit then
        dmData.cdsSummary.Edit;
        dbtStudySessionDate.Text := sDate;
        dmData.cdsSummary.Post;
        // zzzzzzandria 2007-07-09 ------------------------------------------- End
      *)
    except
      on E: Exception do ShowMessage(E.Message);
    end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.DbgHistoryDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  Field: TField;
  DataSet: TDataSet;
  SText, Risk: string;
  I: Integer;
begin
  DataSet := DmData.CdsStudyHistory;
  Field := DataSet.FieldByName(FnS_SessionID);
  SText := Field.AsString;
  Risk := FrmStudies.GetStudyStatus(SText); // 2007-11-17 Active Study List fix
  if Risk = 'Unknown' then DBG.DefaultDrawColumnCell(Rect, DataCol, Column, State)
  else begin
    if not(GdFocused in State) then DBG.Canvas.Font.Color := ClRed;
    if DBG.Columns[DataCol].FieldName = 'Comments' then begin
      SText := 'Not submitted';
      I := DBG.Canvas.TextWidth(SText);
      DBG.Canvas.FillRect(Rect);
      DBG.Canvas.TextRect(Rect, Rect.Right - 3 - I, Rect.Top + 2, SText);
    end
    else DBG.DefaultDrawColumnCell(Rect, DataCol, Column, State);
  end;
end;

procedure TfrmCover.SaveData;
begin
  try
    if dmData.CdsInfo.State in [dsEdit, dsInsert] then
      DmData.CdsInfo.Post;
  except
  end;
end;

procedure TfrmCover.FormDestroy(Sender: TObject);
begin
{$IFDEF GENERALINFO_FRAME}
  if Assigned(FGeneralInfoCollector) then
    try
      GeneralInfo.FreeInterface;
      FreeAndNil(FGeneralInfoCollector);
    except
    end;
{$ENDIF}
  inherited;
end;

procedure TfrmCover.AcPrintExecute(Sender: TObject);
var
  I: Integer;
  Re: TRichEdit;
  ImgBackground: TBitmap;
  Ts: TTabSheet;
  S: string;
begin
  if PrintDialog1.Execute then
    with Printer do begin
{$IFDEF DEMO}
      if CmdLineSwitch(['/DEMO']) then ImgBackground := ImgDemoBackground.Picture.Bitmap
      else
{$ENDIF}
          ImgBackground := nil;
      S := '';
      Re := nil;
      Ts := PgcHistory.ActivePage;
      for I := 0 to Ts.ComponentCount - 1 do
        if Ts.Components[I] is TRichEdit then begin
          Re := TRichEdit(Ts.Components[I]);
          S := Re.Lines.Text;
          Printer.Canvas.Font.Assign(Re.Font);
          Break;
        end;
      if (S <> '') and Assigned(Re) then PrintReportString(Printer, S, ImgBackground)
    end;
end;

procedure TfrmCover.PgcHistoryChange(Sender: TObject);
begin
  AcPrint.Enabled := PgcHistory.ActivePageIndex > 0;
end;

function TfrmCover.GetMainMenu: TMainMenu;
begin
  Result := CoverMainMenu;
end;

procedure TfrmCover.SetMainMenuVisible(AValue: Boolean);
begin
  MiDocuments.Visible := AValue;
end;

// zzzzzzandria 2012-06-14. ICD10 Remediation. v. 1.0.29.10 ============== begin
procedure TfrmCover.SetESRD;
var
  Sfmdate, S, SImpDate: string;
begin
  S := DbcESRD.Text;
  // add logic to determine which codes to load based on Date Criteria. zzzzzzcarnej
  // change validation date from treatment date to diagnosis date per RSD 09/21/2012 zzzzzzcarnej
  // added new call to md widget, to return system implentation datge  engine.GetVistaImpDate 09/21/2012 zzzzzzcarnej
  if DbeDiagnosisDate.Text = '' then // should only be issue at startup zzzzzzcarnej
    // updateField(dbcESRD, getValues(onESRD_Diagnosys))
      UpdateField(DbcESRD, GsESRD_ICD9)
  else
    try
      SImpDate := Engine.GetVistaImpDate;
      // if StrToDateTime(dbeDiagnosisDate.Text) >= StrToDateTime(engine.getVistaImpDate) then   //make it GT or EQ  jwc
      Sfmdate := Trim(Engine.ConvertToFmDate(StrToDateTime(DbeDiagnosisDate.Text)));
      // switch to this 09/26/2012 zzzzzzcarnej
      if Sfmdate < Trim(SImpDate) then begin
        if (S <> '') and (Pos(S, GsESRD_ICD9) = 0) then DbcESRD.Clear;
        UpdateField(DbcESRD, GsESRD_ICD9);
      end else begin
        if (S <> '') and (Pos(S, GsESRD_ICD10) = 0) then DbcESRD.Clear;
        UpdateField(DbcESRD, GsESRD_ICD10);
      end;
    except
      on E: Exception do ShowMessage(E.Message);
    end;
{$IFDEF RPCLOG}
  AddEvent('Dates compare', GetDescribedItem('Dates Compare', 'ICD Implementation date: ' + SImpDate + #13#10 +
    'Procedure Date:          ' + Sfmdate));
  AddEvent('ESRD Set', GetDescribedItem('ESRD Value Set', DbcESRD.Text));
{$ENDIF}
end;
// zzzzzzandria 2012-06-14. ICD10 Remediation. v. 1.0.29.10 ================ end

procedure TfrmCover.DbeDiagnosisDateEnter(Sender: TObject);
begin
  FField := GetActiveField(Sender);
  FActive := Sender;
end;

procedure TfrmCover.DbeDiagnosisDateExit(Sender: TObject);
begin
  if not CbReadOnly.Checked then CheckDBField(Sender);
  FField := nil;
  FActive := nil;
end;

procedure TfrmCover.DbeCTDateChange(Sender: TObject);
begin
  if FIgnore then Exit;
  if (Sender is TDBEdit) and (TDBEdit(Sender).Field.Name = FnI_StudyDate) then
    if TDBEdit(Sender).Field.AsString = '12/30/1899' then TDBEdit(Sender).Text := ''
end;

procedure TfrmCover.DbeDiagnosisDateContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// zzzzzzandria 2007-07-12 b. 312 #26
  Exit;                    // zzzzzzandria 20070326 no access to dictionary
{$ENDIF}
  if Engine.CurrentOperatorMode <> RnAdmin then Exit;
  WinCon := TWinControl(Sender);
  DbeDiagnosisDateEnter(Sender);
  PopupMenu.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
end;

end.
