unit fMDK_Post;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 4/23/08 12:06p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Post treatment form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Build309/Tabs/fMDK_Post.pas $
  *
  *       $ History: fMDK_Post.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DB, uMDK_Summary, Mask, DBCtrls, Menus, ActnList, uMDK_Vitals, frMDK_Comments, Buttons,
  ComCtrls, ImgList, fr_Simple, frMDK_Assessment, iMDK_Presenter, uMDK_FallsCollector, uMDK_PainCollector,
  System.Actions;

type
  TfrmPost = class(TForm, I_DataPresenter)
    pnlPostTreatment: TPanel;
    Panel14: TPanel;
    pnlPostPain: TPanel;
    pnlPostNotes: TPanel;
    lblNotes: TLabel;
    dbmComments: TDBMemo;
    Panel1: TPanel;
    Panel71: TPanel;
    Panel108: TPanel;
    Bevel59: TBevel;
    Label296: TLabel;
    Label302: TLabel;
    Label303: TLabel;
    Label304: TLabel;
    Label305: TLabel;
    Label306: TLabel;
    Label307: TLabel;
    Label318: TLabel;
    Label319: TLabel;
    Label320: TLabel;
    Label325: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    dbePulseStanding: TDBEdit;
    dbePulseSeated: TDBEdit;
    dbeDiasStand: TDBEdit;
    dbeDiasSit: TDBEdit;
    dbeSysSit: TDBEdit;
    dbeSysStand: TDBEdit;
    Panel20: TPanel;
    Bevel54: TBevel;
    Label284: TLabel;
    Label271: TLabel;
    Label316: TLabel;
    dbeTemp: TDBEdit;
    Panel21: TPanel;
    Bevel53: TBevel;
    Label270: TLabel;
    Label269: TLabel;
    Label285: TLabel;
    Label17: TLabel;
    Label21: TLabel;
    Label313: TLabel;
    Label312: TLabel;
    dbeGoal: TDBEdit;
    dbeDryWeight: TDBEdit;
    dbeWeight: TDBEdit;
    Panel109: TPanel;
    Bevel60: TBevel;
    Label308: TLabel;
    Label309: TLabel;
    dbeResp: TDBEdit;
    Panel7: TPanel;
    Label2: TLabel;
    Panel8: TPanel;
    dbrgEdema: TDBRadioGroup;
    Panel5: TPanel;
    Label1: TLabel;
    Panel6: TPanel;
    dbrgSOB: TDBRadioGroup;
    Panel9: TPanel;
    Panel105: TPanel;
    Bevel57: TBevel;
    Label290: TLabel;
    dbcAlert: TDBCheckBox;
    dbcConfused: TDBCheckBox;
    dbcSedated: TDBCheckBox;
    dbcUnresponsive: TDBCheckBox;
    dbcLethargic: TDBCheckBox;
    dbcRestless: TDBCheckBox;
    dbcPostAmbulatory: TDBCheckBox;
    dbcPostOriented: TDBCheckBox;
    Panel87: TPanel;
    Label429: TLabel;
    dbcVomiting: TDBCheckBox;
    dbcHypotension: TDBCheckBox;
    dbcSyncope: TDBCheckBox;
    dbeOther: TDBEdit;
    dbcCramping: TDBCheckBox;
    dbcOther: TDBCheckBox;
    dbcStable: TDBCheckBox;
    Panel86: TPanel;
    Label426: TLabel;
    Panel13: TPanel;
    Panel16: TPanel;
    dbrgMedicationAdministered: TDBRadioGroup;
    Panel64: TPanel;
    Label358: TLabel;
    Label9: TLabel;
    Bevel4: TBevel;
    Panel11: TPanel;
    Panel12: TPanel;
    dbrgWeightAchieved: TDBRadioGroup;
    Panel28: TPanel;
    dbcPostOrientedText: TDBRadioGroup;
    Panel29: TPanel;
    Bevel7: TBevel;
    Label7: TLabel;
    dbcTransportation: TDBComboBox;
    ActionList1: TActionList;
    acFormat: TAction;
    pupFormat: TPopupMenu;
    Format1: TMenuItem;
    PopupMenu1: TPopupMenu;
    MenuItem1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    FrameMDK_Comments: TFrameMDK_Comments;
    acPain: TAction;
    spltDetails: TSplitter;
    alPain: TActionList;
    acEdit: TAction;
    ImageList1: TImageList;
    pnlComments: TPanel;
    pnlPostAssessment: TPanel;
    pnlPostToolbar: TPanel;
    Label8: TLabel;
    ActionList2: TActionList;
    acMoveComments: TAction;
    acShowOldComments: TAction;
    mnMain: TMainMenu;
    Comments1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    Edit2: TMenuItem;
    Notes1: TMenuItem;
    frFallsAssessment: TfrAssessment;
    spbUpdateOldComments: TSpeedButton;
    N2: TMenuItem;
    Refresh2: TMenuItem;
    miFallsRiskEvaluation: TMenuItem;
    PainAssessment: TfrAssessment;
    procedure FormCreate(Sender: TObject);
    procedure dbcOtherClick(Sender: TObject);
    procedure dbeWeightDblClick(Sender: TObject);
    procedure dbeWeightChange(Sender: TObject);
    procedure dbeWeightExit(Sender: TObject);
    procedure dbmCommentsChange(Sender: TObject);
    procedure dbcPostOrientedClick(Sender: TObject);
    procedure dbmCommentsEnter(Sender: TObject);
    procedure dbcAlertExit(Sender: TObject);
    procedure acFormatExecute(Sender: TObject);
    procedure dbeGoalChange(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure dbcTransportationContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure acEditExecute(Sender: TObject);
    procedure acMoveCommentsExecute(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure frFallsAssessmentSpeedButton1Click(Sender: TObject);
    procedure miFallsRiskEvaluationClick(Sender: TObject);
  private
    fIgnore: Boolean;
    fField: TField;
    fActive: TObject;
    fFallsCollector: TSrvFallsCollector;
    fPainCollector: TSrvPainCollector;
    function getFieldVitalType(Sender: TObject): TVitalType;
    function Verify: string;
  public
    property Ignore: Boolean read fIgnore write fIgnore;
    procedure setUp;
    procedure ReportStatus;
    procedure CheckMedicationAdministrated;
    procedure setReadOnly(aReadOnly: Boolean = False);
    procedure ActivateTabForm;
    procedure SetActionStatus;
    procedure mapDataFields;
    function getFallsAssessment: string;
    procedure matchGUI;                   // map GUI elements to data sources and controllers
    procedure unmatchGUI;                 // break links to controllers
    procedure updateGUI;                  // update presentation based on data values
    procedure getData;                    // get values from data sources
    procedure setData;                    // set values based on GUI status
    procedure refreshGUI;                 // updateGUI;
    procedure wakeupGUI;                  // activate
    procedure laydownGUI;                 // deactivate
    function getMainMenu: TMainMenu;      // get access to presenter actions
    function getHelpContext: Integer;     // get presenter help index
  end;

var
  frmPost: TfrmPost;

implementation

uses
  dMDK_Data, uMDK_CDSCommon, uMDK_Engine, System.UITypes, uMDK_Common, uMDK_MedList, fMDK_Options, uMDK_Options,
  fMDK_DictionaryEdit, uMDK_Dictionary, Clipbrd, uMDK_Flowsheet, fMDK_PainAssessmentDLG, uMDK_ReportEngine;
{$R *.dfm}

procedure TfrmPost.mapDataFields;
begin
  dbeWeight.DataField := fnS_PostWeight;
  dbeDryWeight.DataField := fnS_PostDryWeight;
  dbeTemp.DataField := fnS_PostTemp;
  dbePulseSeated.DataField := fnS_PostPulseSeated;
  dbePulseStanding.DataField := fnS_PostPulseStanding;
  dbeSysSit.DataField := fnS_PostBPSysSitting;
  dbeDiasSit.DataField := fnS_PostBPDiasSitting;
  dbeSysStand.DataField := fnS_PostBPSysStanding;
  dbeDiasStand.DataField := fnS_PostBPDiasStanding;
  dbeResp.DataField := fnS_PostRespirations;
  dbcAlert.DataField := fnS_PostAlert;
  dbcConfused.DataField := fnS_PostConfused;
  dbcSedated.DataField := fnS_PostSedated;
  dbcUnresponsive.DataField := fnS_PostUnresposive;
  dbcLethargic.DataField := fnS_PostLethargic;
  dbcRestless.DataField := fnS_PostRestless;
  dbrgSOB.DataField := fnS_PostSOB;
  dbrgEdema.DataField := fnS_PostEdema;
  dbmComments.DataField := fnS_PostNotes;
  dbrgWeightAchieved.DataField := fnS_POWeight;
  dbrgMedicationAdministered.DataField := fnS_Medication;
  dbcVomiting.DataField := fnS_TlrVom;
  dbcHypotension.DataField := fnS_TlrHyp;
  dbcSyncope.DataField := fnS_TlrSyn;
  dbcCramping.DataField := fnS_TlrCram;
  dbcStable.DataField := fnS_TlrStable;
  dbcOther.DataField := fnS_TlrOther;
  dbeOther.DataField := fnS_TlrOtherDoc;
  dbeGoal.DataField := fnS_RxGoalWeight;
  dbcPostAmbulatory.DataField := fnS_PostAmbulatory;
  dbcPostOriented.DataField := fnS_PostOriented;
  dbcPostOrientedText.DataField := fnS_PostOrientedText;
  dbcTransportation.DataField := fnS_PostTransportation;
end;

procedure TfrmPost.setUp;
begin
  lblNotes.Visible := true;
  dbmComments.Visible := true;
  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  frFallsAssessment.Visible := not Preferences.bValue(onFallsAssessmentAsTIU);
  miFallsRiskEvaluation.Visible := not Preferences.bValue(onFallsAssessmentAsTIU);
  frFallsAssessment.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  frFallsAssessment.re.Color := Preferences.iValue(onReadOnlyFieldColor);
  frFallsAssessment.pnlButtons3D.Visible := devOptions.bValue(donWindowsXPTheme);
  frFallsAssessment.pnlButtons2D.Visible := not devOptions.bValue(donWindowsXPTheme);
  PainAssessment.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  PainAssessment.re.Color := Preferences.iValue(onReadOnlyFieldColor);
  PainAssessment.pnlButtons3D.Visible := devOptions.bValue(donWindowsXPTheme);
  PainAssessment.pnlButtons2D.Visible := not devOptions.bValue(donWindowsXPTheme);
  pnlPostToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlPostAssessment.Color := Preferences.iValue(onColorBackground);
  spbUpdateOldComments.Visible := devOptions.bValue(donIncludeCommentsUpdate);
  setReadOnly(Engine.CurrentPatient.ReadOnly);
  FrameMDK_Comments.pnlButtons2DH.Visible := not devOptions.bValue(donWindowsXPTheme);
  FrameMDK_Comments.pnlButtons3DH.Visible := devOptions.bValue(donWindowsXPTheme);
end;

procedure TfrmPost.dbcOtherClick(Sender: TObject);
begin
  dbeOther.Enabled := dbcOther.Checked;
  CheckDBField(dbeOther);
end;

procedure TfrmPost.dbeWeightDblClick(Sender: TObject);
begin
  UpdateDBEditField(TDBEdit(Sender), getFieldVitalType(Sender));
end;

procedure TfrmPost.dbeWeightChange(Sender: TObject);
var
  s: string;
begin
  s := TDBEdit(Sender).Text;
  case Length(s) of
    1: Exit;
    2: if pos('.', s) = 2 then Exit;
  else dbeWeightExit(Sender);
  end;
end;

function TfrmPost.getFieldVitalType(Sender: TObject): TVitalType;
var
  aVT: TVitalType;
begin
  if (Sender = dbeWeight) { or (Sender=dbeDryWeight) } or (Sender = dbeGoal) then aVT := vtWeight
  else if (Sender = dbePulseSeated) or (Sender = dbePulseStanding) then aVT := vtPulse
  else if Sender = dbeTemp then aVT := vtTemp
  else if Sender = dbeResp then aVT := vtResp
  else if (Sender = dbeSysSit) or (Sender = dbeDiasSit) or (Sender = dbeSysStand) or (Sender = dbeDiasStand) then
      aVT := vtBP
  else aVT := vtUnknown;
  Result := aVT;
end;

procedure TfrmPost.dbeWeightExit(Sender: TObject);
var
  s: string;
  aVT: TVitalType;
  bMetric: Boolean;
begin
  CheckDBField(Sender);
  fActive := nil;
  fField := nil;
  if dmData.bIgnore then Exit;
  s := TDBEdit(Sender).Text;
  if s = '' then Exit;
  aVT := getFieldVitalType(Sender);
  if (Sender = dbeWeight) or (Sender = dbeGoal) then bMetric := true
  else bMetric := False;
  if not(aVT = vtUnknown) then
    if not ValidVS(aVT, s, bMetric) then // zzzzzzandria 2008-04-15 set TRUE
    begin
      ShowMessage(HintString(bMetric, aVT)); // zzzzzzandria 2008-04-15 set TRUE
      TDBEdit(Sender).SetFocus;
    end;
  ReportStatus;
end;

procedure TfrmPost.dbmCommentsChange(Sender: TObject);
begin
  if Ignore then Exit;
  Ignore := true;
  UpdateMemo(Sender, Engine.Signature);
  Ignore := False;
  spbUpdateOldComments.Enabled := dbmComments.Text <> '';
end;

procedure TfrmPost.ReportStatus;
var
  iCode: Integer;
  sComment: string;
  oldIgnore: Boolean;
  function AddFieldReport(aReport: string): string;
  begin
    if aReport <> '' then Result := aReport + ', '
    else Result := aReport;
  end;

begin
  oldIgnore := Ignore;
  try
    CheckMedicationAdministrated;
    iCode := 0;
    sComment := '';
    sComment := sComment + AddFieldReport(CheckDBField(dbeWeight));
    sComment := sComment + AddFieldReport(CheckDBField(dbeGoal));
    sComment := sComment + AddFieldReport(CheckDBField(dbeTemp));
    sComment := sComment + AddFieldReport(CheckDBField(dbeSysSit));
    sComment := sComment + AddFieldReport(CheckDBField(dbeDiasSit));
    sComment := sComment + AddFieldReport(CheckDBField(dbePulseSeated));
    sComment := sComment + AddFieldReport(CheckDBField(dbeSysStand));
    sComment := sComment + AddFieldReport(CheckDBField(dbeDiasStand));
    sComment := sComment + AddFieldReport(CheckDBField(dbePulseStanding));
    sComment := sComment + AddFieldReport(CheckDBField(dbeResp));
    sComment := sComment + AddFieldReport(CheckDBField(dbeOther));
    sComment := sComment + AddFieldReport(CheckDBField(dbcTransportation));
    sComment := sComment + AddFieldReport(CheckDBField(dbmComments));
    if sComment <> '' then begin
      sComment := 'Required Fields without data: ' + sComment;
      sComment := copy(sComment, 1, Length(sComment) - 2) + '. ';
    end;
    sComment := sComment + Verify;
    if sComment <> '' then iCode := 1;
    if sComment = '' then sComment := 'OK';
    Engine.ReportStatus(pnPost, iCode, sComment);
    try
      if sComment = 'OK' then TTabSheet(Parent).ImageIndex := indexOK
      else TTabSheet(Parent).ImageIndex := indexWarning;
    except
    end;
  except
  end;
  Ignore := oldIgnore;
  setUp;
end;

procedure TfrmPost.dbcPostOrientedClick(Sender: TObject);
begin
  dbcPostOrientedText.Enabled := dbcPostOriented.Checked;
end;

procedure TfrmPost.CheckMedicationAdministrated;
var
  B: Boolean;
  BM: TBookmark;
begin
  if not Engine.MedList_CDS.Active then Exit;
  B := False;
  BM := Engine.MedList_CDS.GetBookmark;
  Engine.MedList_CDS.First;
  while not Engine.MedList_CDS.EOF do begin
    B := Engine.MedList_CDS.FieldByName(fnML_Status).AsString = fsValid;
    if B then Break;
    Engine.MedList_CDS.Next;
  end;
  Engine.MedList_CDS.GotoBookmark(BM);
  Engine.MedList_CDS.FreeBookmark(BM);
  if B then
    try
      Engine.Summary_CDS.Edit;
      Engine.Summary_CDS.FieldByName(fnS_Medication).asBoolean := B;
      Engine.Summary_CDS.Post;
    except
    end;
end;

procedure TfrmPost.dbmCommentsEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TfrmPost.dbcAlertExit(Sender: TObject);
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
  ReportStatus
end;

procedure TfrmPost.acFormatExecute(Sender: TObject);
var
  aVT: TVitalType;
begin
  if fField = nil then Exit;
  try
    aVT := getFieldVitalType(fActive);
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName, aVT);
    CheckDBField(fActive);
  except
  end;
end;

procedure TfrmPost.dbeGoalChange(Sender: TObject);
begin
  CheckDBField(dbeGoal);
end;

procedure TfrmPost.Copy1Click(Sender: TObject);
begin
  Clipboard.AsText := dbmComments.SelText;
end;

procedure TfrmPost.Paste1Click(Sender: TObject);
begin
  try
    if (Engine.Summary_CDS.State = dsBrowse) then Engine.Summary_CDS.Edit;
    dbmComments.SelText := Clipboard.AsText;
  except
  end;
end;

procedure TfrmPost.dbcTransportationContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// zzzzzzandria 2007-07-12 b. 312 #26
  Exit; // zzzzzzandria 20070326 no access to dictionary
{$ENDIF}
  if not devOptions.bValue(onAllowDictionaryEdit) then Exit;
  if Engine.CurrentOperatorMode <> rnAdmin then Exit;
  dbmCommentsEnter(Sender);
  WinCon := TWinControl(Sender);
  pupFormat.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
end;

procedure TfrmPost.setReadOnly(aReadOnly: Boolean = False);
begin
  Panel71.Enabled := not aReadOnly;
  Panel9.Enabled := not aReadOnly;
  dbmComments.ReadOnly := aReadOnly;
  if aReadOnly then pnlPostAssessment.Color := Preferences.iValue(onColorReview)
  else pnlPostAssessment.Color := Preferences.iValue(onColorBackground);
  FrameMDK_Comments.ReadOnly := aReadOnly;
  acEdit.Enabled := not aReadOnly;
  frFallsAssessment.acUpdate.Enabled := not aReadOnly;
  PainAssessment.acUpdate.Enabled := not aReadOnly;
end;

function TfrmPost.Verify: string;
begin
  Result := '';
  if dbmComments.Text <> '' then Result := 'Old Comments field is not empty  ';
end;

procedure TfrmPost.ActivateTabForm;
begin
  PainAssessment.acRefresh.Execute;
  frFallsAssessment.acRefresh.Execute;
  ReportStatus;
  FrameMDK_Comments.ActivateFrame;
  SetActionStatus;
end;

procedure TfrmPost.acEditExecute(Sender: TObject);
begin
  PainAssessment.acUpdate.Execute;
  // UpdatePainData(1);
  // SetUp;
end;

procedure TfrmPost.SetActionStatus;
begin
  acMoveComments.Enabled := dbmComments.Text <> '';
  FrameMDK_Comments.SetActionStatus;
  Invalidate;
end;

procedure TfrmPost.acMoveCommentsExecute(Sender: TObject);
begin
  if dbmComments.Modified then
    try
      dmData.cdsSummary.Post;
    except
    end;
  if dbmComments.Text <> '' then FrameMDK_Comments.moveComment(dbmComments.DataField, '')
  else MessageDLG('No comments available for update', mtInformation, [mbOK], 0);
end;

procedure TfrmPost.New1Click(Sender: TObject);
begin
  FrameMDK_Comments.acAddExecute(Sender);
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmPost.matchGUI;
// map GUI elements to data sources and controllers
begin
  mapDataFields;
  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnPost);
  fFallsCollector := newSrvFallsCollector(1);
  frFallsAssessment.setAssessmentInterface(fFallsCollector);
  frFallsAssessment.setAssessmentCaption('Falls Risk Evaluation');
  fPainCollector := newSrvPainCollector(1);
  PainAssessment.setAssessmentInterface(fPainCollector);
  PainAssessment.setAssessmentCaption('Pain Assessment');
end;

procedure TfrmPost.unmatchGUI;
// break links to controllers
begin
  if Assigned(fFallsCollector) then
    try
      frFallsAssessment.freeInterface;
      FreeAndNil(fFallsCollector);
    except
    end;
  if Assigned(fPainCollector) then
    try
      PainAssessment.freeInterface;
      FreeAndNil(fPainCollector);
    except
    end;
end;

procedure TfrmPost.updateGUI;
// update presentation based on data values
begin
  setUp;
end;

procedure TfrmPost.getData;
// get values from data sources
begin
  frFallsAssessment.acRefresh.Execute;
  PainAssessment.acRefresh.Execute;
end;

procedure TfrmPost.setData;
// set values based on GUI status
begin
end;

procedure TfrmPost.refreshGUI;
begin
  getData;
  updateGUI;
end;

procedure TfrmPost.wakeupGUI;
// activate
begin
end;

procedure TfrmPost.laydownGUI;
// deactivate
begin
end;

function TfrmPost.getMainMenu: TMainMenu;
// get access to presenter actions
begin
  Result := mnMain;
end;

function TfrmPost.getHelpContext: Integer;
// get presenter help index
begin
  Result := 5; // post help index
end;

procedure TfrmPost.FormCreate(Sender: TObject);
begin
  matchGUI;
end;

procedure TfrmPost.FormDestroy(Sender: TObject);
begin
  unmatchGUI;
end;

procedure TfrmPost.frFallsAssessmentSpeedButton1Click(Sender: TObject);
begin
  frFallsAssessment.acUpdateExecute(Sender);
end;

function TfrmPost.getFallsAssessment: string;
begin
  if frFallsAssessment.Visible then Result := frFallsAssessment.Assessment.getAssessmentText
  else Result := '';
end;

procedure TfrmPost.miFallsRiskEvaluationClick(Sender: TObject);
begin
  frFallsAssessment.acUpdate.Execute;
end;

end.
