unit fMDK_VADelete;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 4/07/08 9:25a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Access form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/VascularAccess/fMDK_VADelete.pas $
  *
  *       $ History: fMDK_VADelete.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, uMDK_VASite;

type
  TfrmVADelete = class(TForm)
    Panel1: TPanel;
    pnlRemove: TPanel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    lblRemovalRegistered: TLabel;
    cmbRemovedBy: TComboBox;
    cmbRemovedAt: TComboBox;
    Label7: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    lblAccessType: TLabel;
    lblLocation: TLabel;
    lblOpened: TLabel;
    lblSurgeon: TLabel;
    lblFacility: TLabel;
    Label16: TLabel;
    lblOperator: TLabel;
    edFate: TComboBox;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Bevel1: TBevel;
    dtpRemoved: TDateTimePicker;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure cmbRemovedByChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVADelete: TfrmVADelete;

function RemoveAccessSite(aSite: TVASite; anOperator: string): Boolean;

implementation

uses
  uMDK_Common, uMDK_Options, uMDK_Engine, uMDK_CDSCommon, System.UITypes,
  fMDK_SelectProvider, uMDK_Utils;
{$R *.dfm}

function RemoveAccessSite(aSite: TVASite; anOperator: string): Boolean;
var
  aTime: TdateTime;
begin
  Result := False;
  if not Assigned(frmVADelete) then begin
    Application.CreateForm(TfrmVADelete, frmVADelete);
    frmVADelete.edFate.Text := aSite.RemovalReason;
    frmVADelete.cmbRemovedBy.Text := aSite.RemovalSurgeon;
    frmVADelete.cmbRemovedAt.Text := aSite.RemovalFacility;
    aTime := aSite.RemovalDate;
    if aTime < aSite.PlacedDate then aTime := aSite.PlacedDate;
    frmVADelete.dtpRemoved.MaxDate := Now;
    frmVADelete.dtpRemoved.MinDate := round(aSite.PlacedDate) - 1.0; // Now-580;
    frmVADelete.dtpRemoved.Date := aTime;
    frmVADelete.dtpRemoved.Format := 'MM/dd/yy';
  end;
  with frmVADelete do begin
    AssignList(frmVADelete.cmbRemovedBy.Items, Engine.getSystemOptionByName(onSurgeons));
    frmVADelete.cmbRemovedBy.Items.Insert(0, '');
    frmVADelete.cmbRemovedBy.Items.Insert(1, '-- Other --');
    AssignList(frmVADelete.cmbRemovedAt.Items, Engine.getSystemOptionByName(onMedicalFacilities));
    frmVADelete.cmbRemovedAt.Items.Insert(0, '');
    frmVADelete.cmbRemovedAt.Items.Insert(1, '-- Other --');
    dtpRemoved.Refresh;
    lblAccessType.caption := SiteTypeNameByType(aSite.AccessType);
    lblLocation.caption := aSite.Location;
    lblSurgeon.caption := aSite.Surgeon;
    lblFacility.caption := aSite.Facility;
    lblOpened.caption := FormatDateTime(gMDK_DateFMT, aSite.PlacedDate);
    lblOperator.caption := aSite.RegisteredBy;
    lblRemovalRegistered.caption := anOperator;
    try
      edFate.ItemIndex := -1;
    except
    end;
    try
      cmbRemovedBy.ItemIndex := -1;
    except
    end;
    try
      cmbRemovedAt.ItemIndex := -1;
    except
    end;
    if ShowModal = mrOK then begin
      aSite.Status := asRemoved;
      aSite.RemovalDate := dtpRemoved.DateTime;
      aSite.RemovalSurgeon := cmbRemovedBy.Text;
      aSite.RemovalFacility := cmbRemovedAt.Text;
      aSite.RemovalRegisteredBy := lblRemovalRegistered.caption;
      aSite.RemovalReason := edFate.Text;
      Result := True;
    end;
  end;
  FreeAndNil(frmVADelete);
end;

procedure TfrmVADelete.BitBtn3Click(Sender: TObject);
var
  s: string;
  i: integer;
begin
  s := SelectProvider('', Engine.fRenalController);
  s := piece(s, '^', 1);
  if s <> '' then begin
    i := cmbRemovedBy.Items.IndexOf(s);
    if i < 0 then begin
      cmbRemovedBy.Items.Insert(0, s);
      i := 0;
    end;
    cmbRemovedBy.ItemIndex := i;
  end;
end;

procedure TfrmVADelete.BitBtn4Click(Sender: TObject);
var
  s: string;
  i: integer;
begin
  s := SelectProvider('', Engine.fRenalController, 1);
  s := piece(s, '^', 1);
  if s <> '' then begin
    i := cmbRemovedAt.Items.IndexOf(s);
    if i < 0 then begin
      cmbRemovedAt.Items.Insert(0, s);
      i := 0;
    end;
    cmbRemovedAt.ItemIndex := i;
  end;
end;

procedure TfrmVADelete.cmbRemovedByChange(Sender: TObject);
var
  s: string;
begin
  if TComboBox(Sender).Text = '-- Other --' then begin
    if Sender = cmbRemovedBy then s := InputBox('Surgeon Name Input Box', 'Surgeon Name', '');
    if Sender = cmbRemovedAt then s := InputBox('Medical Facility Name Input Box', 'Medical Facility Name', '');
    if s <> '' then begin
      TComboBox(Sender).Items.Insert(1, s);
      TComboBox(Sender).ItemIndex := 1;
    end
    else TComboBox(Sender).ItemIndex := 0;
  end;
end;

procedure TfrmVADelete.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  s: string;
  i: integer;
begin
  if ModalResult = mrCancel then begin
  end else if (edFate.Text = '') or (cmbRemovedBy.Text = '') or (cmbRemovedAt.Text = '') then begin
    if edFate.Text = '' then s := s + char(vk_tab) + 'Reason (Fate)' + #13#10;
    if cmbRemovedBy.Text = '' then s := s + char(vk_tab) + 'Surgeon' + #13#10;
    if cmbRemovedAt.Text = '' then s := s + char(vk_tab) + 'Medical Facility' + #13#10;
    i := MessageDLG('Input is not complete.' + #13#10 + 'The flollowing fields are not populated:' + #13#10#13#10 + s +
      #13#10 + 'These fields cannot be updated later.' + #13#10 + 'Do you want to save blank values?', mtWarning,
      [mbNo, mbYes, mbCancel], 0);
    case i of
      mrYes: CanClose := True;
      mrCancel: begin
          CanClose := True;
          ModalResult := mrCancel;
        end;
    else CanClose := False;
    end;
  end;
end;

end.
