unit uGMV_StudyList;

interface
uses
  uMDK_TreeInterfaces
  , Controls
  , Forms;

type
  TGMV_StudyList = class(TInterfacedObject, I_Viewable)
    private
      fViewForm: TForm;
      fFileName: String;
      procedure setFileName(aName:String);
    public
      property FileName: String read fFileName write setFileName;
      property ViewForm: TForm read fViewForm write fViewForm;

      function _AddRef:Integer;stdcall;
      function _Release:Integer;stdcall;

      function ShowViewForm:Integer;stdcall;
      function HideViewForm:Integer;stdcall;
      function AllowChange:Boolean;stdcall;
      function getViewForm:TForm;stdcall;
      procedure assignViewForm(aForm:TForm);stdcall;
      procedure assignParenForm(aParent:TWinControl);stdcall;
  end;

function New_TGMV_StudyList(aFileName:String): TGMV_StudyList;

implementation

uses
  SysUtils
  , fGMV_PictureViewer
  , XMLIntf
  , uXML
  ;

function getStudyListString(aList:String):String;
var
  i: integer;
  aDoc: IXMLDocument;
  ss: String;

begin
  Result := '';
  ss := '';
  try
    aDoc := XMLDocument(aList);
    with aDoc.DocumentElement do
      begin
        if ChildValues['STATUS'] <> 'OK' then exit;
        for i := 0 to ChildNodes.Count - 1 do
          begin
            if ChildNodes[i].NodeName <> 'RECORD' then continue;
            try  // reverse order update
              Result := ChildNodes[i].ChildValues['STUDY_ID'] + '^'+
                ChildNodes[i].ChildValues['STUDY_DATETIME']
                +#13#10+ Result;
            except
              on E: Exception do;
            end;
          end;
      end;
  except
  end;
end;



function New_TGMV_StudyList(aFileName:String): TGMV_StudyList;
begin
  Result := nil;
end;

////////////////////////////////////////////////////////////////////////////////

function TGMV_StudyList._AddRef:Integer;
begin
  Result := -1;
end;

function TGMV_StudyList._Release:Integer;
begin
  Result := -1;
end;

function TGMV_StudyList.HideViewForm:Integer;
begin
  if Assigned(fViewForm) then
    try
      fViewForm.Hide;
    except
    end;
  Result := 0;
end;

function TGMV_StudyList.AllowChange:Boolean;
begin
  Result := True;
end;

function TGMV_StudyList.getViewForm:TForm;
begin
  Result := fViewForm;
end;

procedure TGMV_StudyList.assignViewForm(aForm:TForm);
begin
  fViewForm := aForm;
end;

procedure TGMV_StudyList.assignParenForm(aParent:TWinControl);
begin
  fViewForm.Parent := aParent;
  fViewForm.BorderStyle := bsNone;
  fViewForm.Align := alClient;
end;

procedure TGMV_StudyList.setFileName(aName:String);
begin
  fFileName := aName;
end;

function TGMV_StudyList.ShowViewForm:Integer;
begin
  if Assigned(fViewForm) then
    begin
      fViewForm.Show;
    end;

  Result := 0;
end;

end.
